<div align="center"> <img src="images/revise-wordmark.svg" alt="Revise.jl"></img></div>

[![CI](https://github.com/timholy/Revise.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/timholy/Revise.jl/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/timholy/Revise.jl/graph/badge.svg?token=uLGKT2eFrZ)](https://codecov.io/gh/timholy/Revise.jl)

`Revise.jl` allows you to modify code and use the changes without restarting Julia.
With Revise, you can be in the middle of a session and then update packages, switch git branches,
and/or edit the source code in the editor of your choice; any changes will typically be incorporated
into the very next command you issue from the REPL.
This can save you the overhead of restarting Julia, loading packages, and waiting for code to JIT-compile.

See the [documentation](https://timholy.github.io/Revise.jl/stable):

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://timholy.github.io/Revise.jl/stable)

In particular, most users will probably want to alter their `.julia/config/startup.jl` file
to run Revise automatically, as described in the [Configuration section](https://timholy.github.io/Revise.jl/stable/config/#Using-Revise-by-default-1) of the documentation.

## Credits

Revise became possible because of Jameson Nash's fix of [Julia issue 265](https://github.com/JuliaLang/julia/issues/265).
[Julia for VSCode](https://www.julia-vscode.org/) and [Juno](http://junolab.org/) are IDEs that offer an editor-based mechanism for achieving a subset of
Revise's aims.

## Major releases

- Both the current 3.x and 2.x release cycles use JuliaInterpreter to step through your module-defining code.
- The 1.x release cycle does not use JuliaInterpreter, but does integrate with Pkg.jl. Try this if the more recent releases give you trouble. (But please report the problems first!)
- For Julia 0.6 [see this branch](https://github.com/timholy/Revise.jl/tree/v0.6). However, you really shouldn't be using Julia 0.6 anymore!

See the [NEWS](NEWS.md) for additional information.

using Base.CoreLogging
using Base.CoreLogging: Debug, Info

struct LogRecord
    level
    message
    group
    id
    file
    line
    kwargs
end
LogRecord(args...; kwargs...) = LogRecord(args..., kwargs)

mutable struct ReviseLogger <: AbstractLogger
    logs::Vector{LogRecord}
    min_level::LogLevel
end

ReviseLogger(; min_level=Info) = ReviseLogger(LogRecord[], min_level)

CoreLogging.min_enabled_level(logger::ReviseLogger) = logger.min_level

CoreLogging.shouldlog(::ReviseLogger, _level, _module, _group, _id) = _module == Revise

function CoreLogging.handle_message(logger::ReviseLogger, level, msg, _module,
                                    group, id, file, line; kwargs...)
    rec = LogRecord(level, msg, group, id, file, line, kwargs)
    push!(logger.logs, rec)
    if level >= Info
        if group == "lowered" && haskey(kwargs, :mod) && haskey(kwargs, :ex) && haskey(kwargs, :exception)
            ex, bt = kwargs[:exception]
            printstyled(stderr, msg; color=:red)
            print(stderr, "\n  ")
            showerror(stderr, ex, bt; backtrace = bt!==nothing)
            println(stderr, "\nwhile evaluating\n", kwargs[:ex], "\nin module ", kwargs[:mod])
        else
            show(stderr, rec)
        end
    end
end

CoreLogging.catch_exceptions(::ReviseLogger) = false

# Wrap a logger, dropping the `Base.Docs` "Replacing docs for ..." warnings while
# forwarding everything else. `revise(mod; force=true)` re-evaluates every
# docstring in `mod`, and `Base.Docs` warns on each rewrite (issue #975); for a
# large package this is pages of noise about an entirely expected action.
struct SuppressReplacingDocsLogger{L<:AbstractLogger} <: AbstractLogger
    logger::L
end

CoreLogging.min_enabled_level(l::SuppressReplacingDocsLogger) = CoreLogging.min_enabled_level(l.logger)
CoreLogging.shouldlog(l::SuppressReplacingDocsLogger, level, _module, group, id) =
    CoreLogging.shouldlog(l.logger, level, _module, group, id)
CoreLogging.catch_exceptions(l::SuppressReplacingDocsLogger) = CoreLogging.catch_exceptions(l.logger)
function CoreLogging.handle_message(l::SuppressReplacingDocsLogger, level, msg, _module,
                                    group, id, file, line; kwargs...)
    if _module === Base.Docs && occursin("Replacing docs for", string(msg))
        return nothing
    end
    return CoreLogging.handle_message(l.logger, level, msg, _module, group, id, file, line; kwargs...)
end

function Base.show(io::IO, l::LogRecord; kwargs...)
    verbose = get(io, :verbose, false)::Bool
    tmin = get(io, :time_min, nothing)::Union{Float64, Nothing}
    if !isempty(kwargs)
        Base.depwarn("Supplying keyword arguments to `show(io, l::Revise.LogRecord; verbose)` is deprecated, use `IOContext` instead.", :show)
        for (kw, val) in kwargs
            if kw === :verbose
                verbose = val::Bool
            end
        end
    end
    if verbose
        print(io, LogRecord)
        print(io, '(', l.level, ", ", l.message, ", ", l.group, ", ", l.id, ", \"", l.file, "\", ", l.line)
    else
        print(io, "Revise ", l.message)
        if tmin !== nothing
            print(io, ", time=", l.kwargs[:time] - tmin)
        end
    end
    exc = nothing
    if !isempty(l.kwargs)
        verbose && print(io, ", (")
        prefix = ""
        for (kw, val) in l.kwargs
            kw === :exception && (exc = val; continue)
            if verbose
                print(io, prefix, kw, "=", val)
            elseif kw === :deltainfo
                keepitem = nothing
                for item in val
                    if isa(item, Type) || isa(item, Union{MethodSummary,Vector{MethodSummary}}) || (keepitem === nothing && isa(item, Union{RelocatableExpr,Expr}))
                        keepitem = item
                    end
                end
                if isa(keepitem, Union{MethodSummary,Vector{MethodSummary}})
                    print(io, ": ", keepitem)
                elseif isa(keepitem, Union{RelocatableExpr,Expr})
                    print(io, ": ", firstline(keepitem))
                elseif isa(keepitem, Type)
                    print(io, ": ", keepitem)
                end
            end
            prefix = ", "
        end
        verbose && print(io, ')')
    end
    if exc !== nothing
        ex, bt = exc
        showerror(io, ex, bt; backtrace = bt!==nothing)
        verbose || println(io)
    end
    if verbose
        print(io, ')')
    end
end

function Base.show(io::IO, ::MIME"text/plain", rlogger::ReviseLogger)
    print(io, "ReviseLogger with min_level=", rlogger.min_level)
    if !isempty(rlogger.logs)
        println(io, ":")
        ioctx = IOContext(io, :time_min => first(rlogger.logs).kwargs[:time], :compact => true)
        show(ioctx, MIME("text/plain"), rlogger.logs)
    end
end

const _debug_logger = ReviseLogger()

"""
    logger = Revise.debug_logger(; min_level=Debug)

Turn on [debug logging](https://docs.julialang.org/en/v1/stdlib/Logging/)
(if `min_level` is set to `Debug` or better) and return the logger object.
`logger.logs` contains a list of the logged events. The items in this list are of type `Revise.LogRecord`,
with the following relevant fields:

- `group`: the event category. Revise currently uses the following groups:
  + "Action": a change was implemented, of type described in the `message` field.
  + "Parsing": a "significant" event in parsing. For these, examine the `message` field
    for more information.
  + "Watching": an indication that Revise determined that a particular file needed to be
    examined for possible code changes. This is typically done on the basis of `mtime`,
    the modification time of the file, and does not necessarily indicate that there were
    any changes.
  + "Bindings": "propagating" consequences of rebinding event(s), where dependent types
    or methods need to be re-evaluated.
- `message`: a string containing more information. Some examples:
  + For entries in the "Action" group, `message` can be `"Eval"` when modifying
    old methods or defining new ones, "DeleteMethod" when deleting a method,
    and "LineOffset" to indicate that the line offset for a method
    was updated (the last only affects the printing of stacktraces upon error,
    it does not change how code runs)
  + Items with group "Parsing" and message "Diff" contain sets `:newexprs` and `:oldexprs`
    that contain the expression unique to post- or pre-revision, respectively.
- `kwargs`: a pairs list of any other data. This is usually specific to particular `group`/`message`
  combinations.

See also [`Revise.actions`](@ref) and [`Revise.diffs`](@ref).
"""
function debug_logger(; min_level=Debug)
    _debug_logger.min_level = min_level
    return _debug_logger
end

"""
    actions(logger; line=false)

Return a vector of all log events in the "Action" group. "LineOffset" events are returned
only if `line=true`; by default the returned items are the events that modified
methods in your session.
"""
function actions(logger::ReviseLogger; line=false)
    filter(logger.logs) do r
        r.group=="Action" && (line || r.message!="LineOffset")
    end
end

"""
    diffs(logger)

Return a vector of all log events that encode a (non-empty) diff between two versions of a file.
"""
function diffs(logger::ReviseLogger)
    filter(logger.logs) do r
        r.message=="Diff" && r.group=="Parsing" && (!isempty(r.kwargs[:newexprs]) || !isempty(r.kwargs[:oldexprs]))
    end
end

## Make the logs portable

"""
    MethodSummary(method)

Create a portable summary of a method. In particular, a MethodSummary can be saved to a JLD2 file.
"""
struct MethodSummary
    name::Symbol
    modulename::Symbol
    file::Symbol
    line::Int32
    sig::Type
end
MethodSummary(m::Method) = MethodSummary(m.name, nameof(m.module), m.file, m.line, m.sig)

Base.show(io::IO, ms::MethodSummary) = Base.show_tuple_as_call(io, ms.name, ms.sig)

module Dep442B

using Requires

export check442B

check442B() = true

function link_442A()
    @debug "Loading 442A support into 442B"
    include("support_442A.jl")
end

function __init__()
    @require Dep442A="76238f47-ed95-4e4a-a4d9-95a3fb1630ea" link_442A()
end

end # module

using Revise, Test
using Revise.JuliaInterpreter: Frame
using Base.Meta: isexpr

isdefined(@__MODULE__, :do_test) || include("common.jl")

module BackEdgesTest
using Test
flag = false    # this needs to be defined for the conditional part to work
end

do_test("Backedges") && @testset "Backedges" begin
    frame = Frame(Base, :(max_values(T::Union{map(X -> Type{X}, BitIntegerSmall_types)...}) = 1 << (8*sizeof(T))))
    src = frame.framecode.src
    # Find the inner struct def for the anonymous function
    idtype = findall(stmt->isexpr(stmt, :thunk) && isa(stmt.args[1], Core.CodeInfo), src.code)[end]
    src2 = src.code[idtype].args[1]
    isrequired = Revise.minimal_evaluation!(frame, :sigs)[1]
    laststmt = src.code[end]
    @assert isa(laststmt, Core.ReturnNode)
    to_skip = isa(laststmt.val, Revise.JuliaInterpreter.SSAValue) ? 2 : 1
    # Revise.LoweredCodeUtils.print_with_code(stdout, src, isrequired)
    @test sum(isrequired) == length(src.code)-count(e->isexpr(e, :latestworld), src.code)-to_skip  # skips the `return` at the end (and its argument)

    src = """
    # issue #249
    flag = false
    if flag
        f() = 1
    else
        f() = 2
    end

    # don't do work in the interpreter that isn't needed for function definitions
    # inspired by #300
    const planetdiameters = Dict("Mercury" => 4_878)
    planetdiameters["Venus"] = 12_104

    function getdiameter(name)
        return planetdiameters[name]
    end
    """
    mexs = parse_source!(Revise.ModuleExprsInfos(BackEdgesTest), src, "backedges_test.jl", BackEdgesTest)
    Revise.instantiate_sigs!(mexs)
    @test isempty(methods(BackEdgesTest.getdiameter))
    @test !isdefined(BackEdgesTest, :planetdiameters)

    # issue #399
    src = """
    for jy in ("j","y"), nu in (0,1)
        jynu = Expr(:quote, Symbol(jy,nu))
        jynuf = Expr(:quote, Symbol(jy,nu,"f"))
        bjynu = Symbol("bessel",jy,nu)
        if jy == "y"
            @eval begin
                \$bjynu(x::Float64) = nan_dom_err(ccall((\$jynu,libm),  Float64, (Float64,), x), x)
                \$bjynu(x::Float32) = nan_dom_err(ccall((\$jynuf,libm), Float32, (Float32,), x), x)
                \$bjynu(x::Float16) = Float16(\$bjynu(Float32(x)))
            end
        else
            @eval begin
                \$bjynu(x::Float64) = ccall((\$jynu,libm),  Float64, (Float64,), x)
                \$bjynu(x::Float32) = ccall((\$jynuf,libm), Float32, (Float32,), x)
                \$bjynu(x::Float16) = Float16(\$bjynu(Float32(x)))
            end
        end
        @eval begin
            \$bjynu(x::Real) = \$bjynu(float(x))
            \$bjynu(x::Complex) = \$(Symbol("bessel",jy))(\$nu,x)
        end
    end
    """
    ex = Meta.parse(src)
    @test Revise.methods_by_execution(BackEdgesTest, ex) isa Tuple

    # Issue #428
    src = """
    @testset for i in (1, 2)
        @test i == i
    end
    """
    ex = Meta.parse(src)
    @test Revise.methods_by_execution(BackEdgesTest, ex) isa Tuple
end

using Revise, Pkg, Test

if isdefined(Core, :var"@latestworld")
    import Core: @latestworld
else
    # In older Julia versions, there were more implicit
    # world age increments, so the macro is generally not
    # required.
    macro latestworld()
        nothing
    end
end

mktempdir() do thisdir
    Pkg.activate(thisdir)

    Pkg.develop(path = joinpath(dirname(@__FILE__), "pkgs", "PkgChange_v1"))

    # This is only needed on Pkg versions that don't notify
    Revise.active_project_watcher()

    # Back to toplevel
    @eval begin
        using PkgChange
        @latestworld
        @test_throws UndefVarError PkgChange.somemethod()   # not present in v1
        # From a different process, switch the active version of ExponentialUtilities
        v2_cmd = """using Pkg; Pkg.activate("."); Pkg.develop(path = joinpath("$(escape_string(dirname(@__FILE__)))", "pkgs", "PkgChange_v2"))"""
        t = @async run(pipeline(Cmd(`$(Base.julia_cmd()) -e $v2_cmd`; dir=$thisdir); stderr, stdout))
        isdefined(Base, :errormonitor) && Base.errormonitor(t)
        wait(Revise.revision_event)
        reset(Revise.revision_event)
        revise()
        @latestworld
        @test PkgChange.somemethod() === 1   # present in v2
        # ...and then switch back (check that it's bidirectional and also to reset state)
        v1_cmd = """using Pkg; Pkg.activate("."); Pkg.develop(path = joinpath("$(escape_string(dirname(@__FILE__)))", "pkgs", "PkgChange_v1"))"""
        t = @async run(pipeline(Cmd(`$(Base.julia_cmd()) -e $v1_cmd`; dir=$thisdir); stderr, stdout))
        isdefined(Base, :errormonitor) && Base.errormonitor(t)
        wait(Revise.revision_event)
        reset(Revise.revision_event)
        revise()
        @latestworld
        @test_throws MethodError PkgChange.somemethod() # not present in v1
    end
end

using Test

# Verifies that Revise emits a single, actionable warning when the OS refuses an
# inotify watch (ENOSPC). This is only meaningful when the inotify watch limit has
# been set very low first; see the (currently disabled) `inotify` step in
# `.github/workflows/ci.yml`. Relevant issues: #26, #1010.
#
# `using Revise` is loaded inside the log collector on purpose: the warning uses
# `maxlog=1`, so it fires only once per session and may be triggered as soon as
# Revise starts watching its own dependencies.

@testset "inotify" begin
    logs, _ = Test.collect_test_logs() do
        @eval using Revise
        Revise.track(joinpath(@__DIR__, "revisetest.jl"))
        sleep(1)   # let the watcher tasks run and hit the inotify limit
    end
    inotify_warnings = filter(rec -> occursin("inotify", rec.message), logs)
    # `maxlog=1` collapses the per-directory flood into a single warning
    @test length(inotify_warnings) == 1
    if !isempty(inotify_warnings)
        msg = first(inotify_warnings).message
        @test occursin("ENOSPC", msg)
        @test occursin("JULIA_REVISE_POLL", msg)
    end
end

"""
    ParseResult(modexinfos, success, donotparse=false, [ret])

The outcome of [`parse_and_maybe_eval_source`](@ref):

- `modexinfos::ModuleExprsInfos`: the per-module expression map. The `!` form adds to it in place.
- `success::Bool`: `false` if parsing produced no usable expressions, e.g. a missing file or a
  source consisting only of a top-level literal.
- `donotparse::Bool`: `true` if the source begins with `# REVISE: DO NOT PARSE` and was therefore
  left unparsed.
- `ret`: the value of the last evaluated expression, set only in `:includet` mode (see [`includet`](@ref)).
  Left undefined (`isdefined(pr, :ret) === false`) when nothing was evaluated.
"""
struct ParseResult
    modexinfos::ModuleExprsInfos
    success::Bool
    donotparse::Bool
    ret
    ParseResult(modexinfos::ModuleExprsInfos, success::Bool, donotparse::Bool=false) =
        new(modexinfos, success, donotparse)
    ParseResult(modexinfos::ModuleExprsInfos, success::Bool, donotparse::Bool, @nospecialize(ret)) =
        new(modexinfos, success, donotparse, ret)
end

"""
    pr = parse_and_maybe_eval_source(filename::AbstractString, mod::Module; mode=:sigs, mapexpr=identity)

Parse the source `filename`, returning a [`ParseResult`](@ref) `pr`.
`mod` is the "parent" module for the file (i.e., the one that `include`d the file);
if `filename` defines more module(s) then these will all have separate entries in `pr.modexinfos`.

`mapexpr` is applied to each top-level expression, mirroring `include(mapexpr, filename)`;
supply the transform that was used when the file was included.

In `:includet` mode the expressions are also evaluated as they are parsed, and `pr.ret` holds the
value of the last one.
"""
parse_and_maybe_eval_source(filename::AbstractString, mod::Module; mode::Symbol=:sigs, mapexpr::Function=identity) =
    parse_and_maybe_eval_source!(ModuleExprsInfos(mod), filename, mod; mode, mapexpr)

"""
    pr = parse_and_maybe_eval_source!(modexinfos::ModuleExprsInfos, filename, mod::Module; mode=:sigs, mapexpr=identity)

Top-level parsing of `filename` as included into module `mod`. Successfully-parsed expressions are
added to `modexinfos`, which is also returned as `pr.modexinfos`. In `:includet` mode the expressions
are evaluated as they are parsed.

See also [`Revise.parse_and_maybe_eval_source`](@ref).
"""
function parse_and_maybe_eval_source!(modexinfos::ModuleExprsInfos, filename::AbstractString, mod::Module; mode::Symbol=:sigs, mapexpr::Function=identity)
    if !isfile(filename)
        @warn "$filename is not a file, omitting from revision tracking"
        return ParseResult(modexinfos, false)
    end
    return parse_and_maybe_eval_source!(modexinfos, read(filename, String), filename, mod; mode, mapexpr)
end

function parse_and_maybe_eval_source!(modexinfos::ModuleExprsInfos, src::AbstractString, filename::AbstractString, mod::Module; mode::Symbol=:sigs, mapexpr::Function=identity)
    if startswith(src, "# REVISE: DO NOT PARSE")
        return ParseResult(modexinfos, true, true)
    end
    if VERSION ≥ v"1.14-DEV.1836"
        ex = Base.parse_input_line(src; filename, mod)
    else
        ex = Base.parse_input_line(src; filename)
    end
    if ex === nothing
        return ParseResult(modexinfos, true)
    elseif ex isa Expr
        # issue #783: in `:includet` mode `process_ex!` returns the value of the last evaluated
        # expression, which `includet` returns like `include`.
        ret = process_ex!(modexinfos, ex, filename, mod; mode, mapexpr)
        return mode === :includet ? ParseResult(modexinfos, true, false, ret) : ParseResult(modexinfos, true)
    else # literals
        return ParseResult(modexinfos, false)
    end
end

# Transform `ex`, the `:toplevel` block that `Base.parse_input_line` returns for a whole file,
# the way `include(mapexpr, filename)` does: `Base.include_string` applies `mapexpr` to each
# parsed top-level statement, not to the file as a whole. A `module ... end` is a single
# top-level statement, so the transform sees it once; statements inside it are not individually
# transformed. `mapexpr` comes from user code loaded after Revise, hence the `invokelatest`.
# `ex.args` is mutated in place.
function apply_mapexpr!(mapexpr::Function, ex::Expr, filename::AbstractString)
    @assert ex.head === :toplevel
    lnn = LineNumberNode(1, Symbol(filename))
    function transform(@nospecialize(a), lnn::LineNumberNode)
        try
            return Base.invokelatest(mapexpr, a)
        catch err
            bt = trim_toplevel!(catch_backtrace())
            loc = location_string((lnn.file, lnn.line))
            throw(ReviseEvalException(loc, err, Any[(sf, 1) for sf in stacktrace(bt)]))
        end
    end
    for (i, a) in enumerate(ex.args)
        if a isa LineNumberNode
            lnn = a
            continue
        end
        ex.args[i] = transform(a, lnn)
    end
    return ex
end

function process_ex!(mod_exprs_sigs::ModuleExprsInfos, ex::Expr, filename::AbstractString, mod::Module; mode::Symbol=:sigs, mapexpr::Function=identity)
    if isexpr(ex, :error) || isexpr(ex, :incomplete)
        return eval(ex)
    end
    if mapexpr !== identity
        # A statement the transform maps to a non-`Expr` (e.g. a literal) defines nothing;
        # `ExprSplitter` skips it, so there is nothing to track.
        apply_mapexpr!(mapexpr, ex, filename)
    end
    lastval = nothing
    for (mod, ex) in ExprSplitter(mod, ex)
        if mode === :includet
            try
                lastval = Core.eval(mod, ex)
            catch err
                bt = trim_toplevel!(catch_backtrace())
                lnn = firstline(ex)
                loc = location_string((lnn.file, lnn.line))
                throw(ReviseEvalException(loc, err, Any[(sf, 1) for sf in stacktrace(bt)]))
            end
        end
        exprs_sigs = get!(ExprsInfos, mod_exprs_sigs, mod)
        if ex.head === :toplevel
            lnn = nothing
            for a in ex.args
                if isa(a, LineNumberNode)
                    lnn = a
                else
                    pushex!(exprs_sigs, Expr(:toplevel, lnn, a))
                end
            end
        else
            pushex!(exprs_sigs, ex)
        end
    end
    # issue #783: the value of the last evaluated expression, so `includet` can
    # return it like `include`. Only `:includet` mode evaluates; otherwise `nothing`.
    return lastval
end

"""
Revise.jl tracks source code changes and incorporates the changes to a running Julia session.

Revise.jl works behind-the-scenes. To track a package, e.g. `Example`:
```julia-repl
(@v1.6) pkg> dev Example        # make a development copy of the package
[...pkg output omitted...]

julia> using Revise             # this must come before the package under development

julia> using Example

[...develop the package...]     # Revise.jl will automatically update package functionality to match code changes

```

Functions in Revise.jl that may come handy in special circumstances:
- `Revise.track`: track updates to `Base` Julia itself or `Core.Compiler`
- `includet`: load a file and track future changes. Intended for small, quick works
- `entr`: call an additional function whenever code updates
- `revise`: evaluate any changes in `Revise.revision_queue` or every definition in a module
- `Revise.retry`: perform previously-failed revisions. Useful in cases of order-dependent errors
- `Revise.errors`: report the errors represented in `Revise.queue_errors`
"""
module Revise

# We use a code structure where all `using` and `import`
# statements in the package that load anything other than
# a Julia base or stdlib package are located in this file here.
# Nothing else should appear in this file here, apart from
# the `include("packagedef.jl")` statement, which loads what
# we would normally consider the bulk of the package code.
# This somewhat unusual structure is in place to support
# the VS Code extension integration.

using CodeTracking, JuliaInterpreter, LoweredCodeUtils, OrderedCollections
using Preferences: Preferences

using CodeTracking: MethodInfoKey, PkgFiles, basedir, basepath, srcfiles
using JuliaInterpreter: Compiled, Frame, Interpreter, LineTypes
using JuliaInterpreter: codelocs, get_return, is_doc_expr, is_quotenode_egal, isassign,
    linetable, lookup, moduleof, pc_expr, step_expr!
using LoweredCodeUtils: callee_matches, next_or_nothing!

include("packagedef.jl")

end # module

using Revise, InteractiveUtils, Test

@eval Revise juliadir = ARGS[1]

@test Revise.juliadir != Revise.basebuilddir
@test Revise.juliadir != Revise.fallback_juliadir()

# https://github.com/timholy/Revise.jl/issues/697
let def = Revise.definition(@which(Float32(π)))
    @test isa(def, Expr)
    @test Meta.isexpr(def, :macrocall)
end

# This runs only on CI. The goal is to populate the `.julia/compiled/v*` directory
# with some additional files, so that `filter_valid_cachefiles` has to run.
# This is to catch problems like #460.

using Pkg
using Test

Pkg.add(PackageSpec(name="EponymTuples", version="0.2.0"))
using EponymTuples  # force compilation
id = Base.PkgId(EponymTuples)
paths = Base.find_all_in_cache_path(id)
Pkg.rm("EponymTuples") # we don't need it anymore
path = first(paths)
base, ext = splitext(path)
mv(path, base*"blahblah"*ext; force=true)
Pkg.add(PackageSpec(name="EponymTuples"))

# Load a package from a stale precompile cache and revise it up to date,
# skipping the re-precompilation that `using`/`import` would trigger (issue #738).

"""
    Revise.stale_load(pkg::Union{AbstractString,Symbol,Base.PkgId}; throw=false) → Module

Load `pkg` from its most recent loadable precompile cache—even if that cache is
*stale* (the package's source files have changed since the cache was built)—and
then revise the loaded code to match the current source. This skips the
re-precompilation that `using`/`import` triggers for an edited package, which
can be a substantial savings for packages that are expensive to compile.

`stale_load` must be called before `pkg` is loaded by any other means; a
subsequent `using`/`import` binds the already-loaded module:

```julia
using Revise
Revise.stale_load("MyBigPackage")
using MyBigPackage
```

The cache on disk is not modified: every `stale_load` of the same cache starts
from the same checkpoint and re-applies the (accumulating) source changes.
Precompile the package when convenient to establish a fresh checkpoint.

# Limitations

- Revision is subject to the usual restrictions; in particular, redefining a
  `struct` requires Julia 1.12+ with struct revision enabled (see the
  `revise_structs` preference). Errors during revision are logged and can be
  inspected with [`Revise.errors`](@ref); pass `throw=true` to raise them
  instead.
- On Julia 1.10, only `pkg` itself may be stale: dependencies whose sources
  have also been edited must be `stale_load`ed first (in dependency order) or
  freshly precompiled. On Julia 1.11+, edited dependencies are loaded from
  their own stale caches and revised automatically.
- A cache may be unloadable for reasons other than source edits (different
  Julia version or build flags, changed preferences, an unsatisfiable
  dependency). In that case `stale_load` throws, and the package must be
  loaded normally.
"""
function stale_load(id::PkgId; throw::Bool=false)
    if Base.JLOptions().use_compiled_modules == 0
        error("stale_load requires compiled modules; restart Julia without `--compiled-modules=no`")
    end
    if Base.root_module_exists(id)
        @warn "$(id.name) is already loaded; `stale_load` applies only to packages that have not yet been loaded"
        return Base.root_module(id)
    end
    newmods = load_from_serialized_no_stale(id)
    # Loading with the staleness check disabled skips both `register_root_module`
    # (so `using` would not find the module) and `run_package_callbacks` (so Revise
    # would not track it). Register every newly loaded module before running any
    # callback, so that callbacks observe a consistent set of root modules.
    @lock Base.require_lock begin
        for M in newmods
            key = PkgId(M)
            Base.root_module_exists(key) || Base.register_root_module(M)
        end
        for M in newmods
            key = PkgId(M)
            Base.insert_extension_triggers(key)
            Base.run_package_callbacks(key)
        end
    end
    # Queue each file whose on-disk source differs from the snapshot stored in the
    # cache; `revise` diffs against that snapshot (see `maybe_parse_from_cache!`).
    anychanged = false
    for M in newmods
        anychanged |= queue_changed_files!(PkgId(M))
    end
    anychanged && revise(; throw)
    return Base.root_module(id)
end

function stale_load(pkg::Union{AbstractString,Symbol}; kwargs...)
    id = Base.identify_package(String(pkg))
    id === nothing && error("could not identify a package named $pkg in the current environment")
    return stale_load(id; kwargs...)
end

@noinline function nocache_error(id::PkgId, @nospecialize(reason))
    msg = """
        no loadable precompile cache found for $(id.name). A cache can fail to load if it \
        was built by a different Julia version or with different options, if compile-time \
        preferences have changed, or if a dependency cannot be satisfied."""
    @static if VERSION < v"1.11"
        msg *= " On Julia 1.10, dependencies of the requested package must not be stale."
    end
    msg *= " Load the package normally to (re)build its cache."
    if reason !== nothing
        msg *= " Last failure: $reason"
    end
    error(msg)
end

@static if VERSION >= v"1.11"

# `_require_search_from_serialized` with `stalecheck=false` (the mode `require_stdlib`
# uses) picks the newest cachefile that passes all structural validation—header, flags,
# CPU target, dependency build_ids, CRCs, preferences—while skipping only the
# source-freshness checks. Stale dependencies load recursively the same way.
function load_from_serialized_no_stale(id::PkgId)
    @lock Base.require_lock begin
        before = IdSet{Module}()
        for M in Iterators.flatten(values(Base.loaded_precompiles))
            push!(before, M)
        end
        spec = isdefined(Base, :locate_package_load_spec) ?
            Base.locate_package_load_spec(id) : Base.locate_package(id)
        spec === nothing && error("cannot locate source for $(id.name); is it in the current environment?")
        sourcepath = spec isa String ? spec : spec.path
        Base.set_pkgorigin_version_path(id, sourcepath)
        loaded = Base.start_loading(id, UInt128(0), false)
        if loaded === nothing
            try
                loaded = Base._require_search_from_serialized(id, spec, UInt128(0), false)
            finally
                Base.end_loading(id, loaded)
            end
        end
        loaded isa Module || nocache_error(id, loaded)
        newmods = Module[M for M in Iterators.flatten(values(Base.loaded_precompiles)) if M ∉ before]
        # The target module may have been loaded earlier (e.g., by a failed prior call)
        # without being registered; make sure it gets registered and announced.
        if loaded ∉ newmods && !Base.root_module_exists(id)
            push!(newmods, loaded)
        end
        return newmods
    end
end

else # VERSION < v"1.11"

# 1.10 lacks the `stalecheck` keyword, but `_tryrequire_from_serialized(pkg, path,
# ocachepath)` loads a given cachefile while ignoring staleness—of the requested
# package only; its dependencies are loaded through the normal (stale-checked) path.
# It also registers every restored module and runs the callbacks for the
# dependencies, but not for `pkg` itself.
function load_from_serialized_no_stale(id::PkgId)
    @lock Base.require_lock begin
        sourcepath = Base.locate_package(id)
        sourcepath === nothing && error("cannot locate source for $(id.name); is it in the current environment?")
        Base.set_pkgorigin_version_path(id, sourcepath)
        local loaded = nothing
        local lastfail = nothing
        for path in Base.find_all_in_cache_path(id)  # sorted newest-first
            ocachepath = nothing
            ok = try
                clone_targets = Base.parse_cache_header(path)[7]
                if isempty(clone_targets)
                    true
                elseif Base.JLOptions().use_pkgimages == 0
                    false
                else
                    ocachepath = Base.ocachefile_from_cachefile(path)
                    isfile(ocachepath)
                end
            catch
                false
            end
            ok || continue
            ret = Base._tryrequire_from_serialized(id, path, ocachepath)
            if ret isa Module
                loaded = ret
                break
            end
            lastfail = ret
        end
        loaded isa Module || nocache_error(id, lastfail)
        return Module[loaded]
    end
end

end # @static if

function queue_changed_files!(id::PkgId)
    changed = false
    @lock revise_lock begin
        pkgdata = get(pkgdatas, id, nothing)
        if pkgdata === nothing
            # `watch_package` declines some packages (e.g., `Revise.dont_watch_pkgs`)
            # and warns on its own; nothing more to do here.
            return false
        end
        if isempty(srcfiles(pkgdata))
            error("Revise could not obtain the file list for $(id.name); it remains in the state of its precompile cache")
        end
        for file in srcfiles(pkgdata)
            fi = fileinfo(pkgdata, file)
            isempty(fi.cachefile) && continue  # no cache snapshot; the baseline is the on-disk source
            filep = joinpath(basedir(pkgdata), file)
            if !isfile(filep)
                @warn "$filep is recorded in the cache for $(id.name) but no longer exists; its definitions remain active"
                continue
            end
            cached = try
                # A snapshot that is no longer the one this session loaded says nothing
                # about what needs revising, so treat it as absent.
                cached_source_is_current(pkgdata, fi) ? read_from_cache(pkgdata, file) : nothing
            catch
                nothing  # queue it; revision will surface the problem
            end
            if cached === nothing || cached != read(filep, String)
                push!(revision_queue, (pkgdata, file))
                changed = true
            end
        end
    end
    return changed
end

#     old_methods_with(oldtypename::Core.TypeName) -> Union{Nothing, Set{Method}}
#
# Find all methods whose signature references `oldtypename`.
#
# When a type is redefined, methods that reference the old type in their signature
# need to be re-evaluated. This function traverses the global method table and
# collects all methods that have `oldtypename` in any of their signature parameters.
#
# For example, if `OldType` is being redefined and there exists a method
# `foo(x::OldType)`, that method will be included in the returned set.
#
# See also [`old_types_with`](@ref).
function old_methods_with(oldtypename::Core.TypeName)
    meths = Ref{Union{Nothing,Set{Method}}}(nothing)
    methodtable = @static isdefinedglobal(Core, :methodtable) ? Core.methodtable : Core.GlobalMethods
    Base.visit(methodtable) do method
        sigt = Base.unwrap_unionall(method.sig)
        if sigt isa DataType
            for i = 1:length(sigt.parameters)
                if is_with_oldtypename(sigt.parameters[i], oldtypename)
                    if meths[] === nothing
                        meths[] = Set{Method}()
                    end
                    push!(meths[]::Set{Method}, method)
                    break
                end
            end
        end
    end
    return meths[]
end

# Every type reachable as `subtypes(Any)` recursively is the
# canonical binding of some name in some loaded module. Enumerate them in a
# single pass over module bindings, rather than issuing one `subtypes` query per
# type: `subtypes(T)` rescans every loaded module's names on each call, so the
# recursive walk costs one full system-wide name scan per abstract parent
# (O(#abstract-types × #names)), whereas one binding sweep is O(#names).
function all_named_types(world::UInt=Base.get_world_counter())
    types = Base.IdSet{Type}()
    seen = Base.IdSet{Module}()
    work = Base.loaded_modules_array()
    while !isempty(work)
        m = pop!(work)
        m in seen && continue
        push!(seen, m)
        # `unsorted_names` skips the per-module name sort that `names` does; since
        #  the result is an unordered set, order is irrelevant here.
        for s in Base.unsorted_names(m; all=true)
            # Read bindings at `world` (the revision's pre-deletion snapshot). With Revise's own
            # dispatch pinned to its frozen init world (issue #552), a plain access would miss or
            # stale-read types defined or redefined after Revise initialized.
            (!Base.isdeprecated(m, s) && Base.invoke_in_world(world, isdefinedglobal, m, s)) || continue
            t = Base.invoke_in_world(world, getglobal, m, s)
            if t isa Type
                dt = Base.unwrap_unionall(t)
                # Keep only the canonical binding (a type's home module/name)
                # so re-exports and imports don't enter the set more than once.
                if dt isa DataType && dt.name.name === s && dt.name.module === m && t !== Any
                    push!(types, t)
                end
            elseif t isa Module && nameof(t) === s && parentmodule(t) === m && t !== m && t !== Base
                push!(work, t)
            end
        end
    end
    return types
end

# TODO Use fixed sized FIFO cache?
const types_cache = IdDict{Type,Union{Nothing,Vector{Any}}}()
const types_cache_lock = ReentrantLock()

function fieldtypes_cached(@nospecialize(type))
    # This function is called from the cache thread during __init__ so we need the lock here
    @lock types_cache_lock begin
        # the equivalent `get!(types_cache, type) do ... end` form is not used because on 1.12 it triggers recompilation
        cache = get(types_cache, type, missing)
        cache !== missing && return cache
        types_cache[type] = ftypes = fieldtypes_array(type)
        return ftypes
    end
end

function fieldtypes_array(@nospecialize(type))
    nflds = Base.Compiler.fieldcount_noerror(type)
    if nflds !== nothing && nflds > 0
        ftypes = Vector{Any}(undef, nflds)
        for i in 1:nflds
            ftypes[i] = fieldtype(type, i)
        end
    else
        ftypes = nothing
    end
    return ftypes
end

#     old_types_with(oldtypename::Core.TypeName, alltypes::Base.IdSet{Type}) -> Union{Nothing, Base.IdSet{Type}}
#
# Find all types whose field types reference `oldtypename`.
#
# When a type is redefined, other types that use it as a field type also need to
# be re-evaluated. This function traverses all known types and collects those that
# have `oldtypename` in any of their field types.
#
# For example, if `Inner` is being redefined and there exists
# `struct Outer; x::Inner; end`, then `Outer` will be included in the returned set.
#
# See also [`old_methods_with`](@ref).
function old_types_with(oldtypename::Core.TypeName, alltypes::Base.IdSet{Type})
    related_types = nothing
    for type in alltypes
        types = fieldtypes_cached(type)
        if types !== nothing
            for ft in types
                if is_with_oldtypename(ft, oldtypename)
                    if related_types === nothing
                        related_types = Base.IdSet{Type}()
                    end
                    push!(related_types, type)
                    break
                end
            end
        end
    end
    return related_types
end

function is_typeeq(@nospecialize(typlike))
    @static if isdefined(Core, :TypeEq)
        return typlike isa Core.TypeEq
    else
        return false
    end
end

function typeeq_parameter(@nospecialize(typlike))
    @static if isdefined(Base, :type_parameter)
        return Base.type_parameter(typlike)
    else
        return getfield(typlike, :T)
    end
end

function is_with_oldtypename(@nospecialize(typlike), oldtypename::Core.TypeName)
    if typlike isa DataType
        typlike.name == oldtypename && return true
        for i = 1:length(typlike.parameters)
            if is_with_oldtypename(typlike.parameters[i], oldtypename)
                return true
            end
        end
    elseif is_typeeq(typlike)
        return is_with_oldtypename(typeeq_parameter(typlike), oldtypename)
    elseif typlike isa UnionAll
        return is_with_oldtypename(typlike.body, oldtypename)
    elseif typlike isa Union
        return is_with_oldtypename(typlike.a, oldtypename) || is_with_oldtypename(typlike.b, oldtypename)
    elseif typlike isa TypeVar
        return is_with_oldtypename(typlike.lb, oldtypename) || is_with_oldtypename(typlike.ub, oldtypename)
    end
    return false
end

"""
    Revise.WatchList

A struct for holding files that live inside a directory.
Some platforms (OSX) have trouble watching too many files. So we
watch parent directories, and keep track of which files in them
should be tracked.

Fields:
- `trackedfiles`: map from basename to `PkgId` for each watched file
- `file_ctimes`: last-seen `ctime` for each tracked file, used to detect changes
- `file_hashes`: content hash for each tracked file, recorded when the file is
  queued for revision. Disambiguates a filesystem event whose ctime matches the
  stored one: kernel timestamps have tick resolution, so an unchanged ctime can
  mean either a duplicate notification or a same-tick rewrite.
"""
mutable struct WatchList
    trackedfiles::Dict{String,PkgId}
    file_ctimes::Dict{String,Float64}
    file_hashes::Dict{String,UInt64}
end

"""
    ExtendedData

Linked list structure for storing extension data from multiple tools.
Each node contains:
- `owner::Symbol`: The extension that owns this data (e.g., `:jet`, `:coverage`)
- `data`: The extension-specific data (untyped for flexibility)
- `next::Union{ExtendedData,Nothing}`: Link to the next extension's data

The linked list allows multiple extensions to attach data to the same signature
without interfering with each other.
"""
struct ExtendedData
    owner::Symbol
    data::Any
    next::ExtendedData
    ExtendedData(owner::Symbol, @nospecialize(data), next::ExtendedData) = new(owner, data, next)
    ExtendedData(owner::Symbol, @nospecialize(data)) = new(owner, data)
    ExtendedData() = new(:Revise, nothing)
end

# Sentinel value representing the absence of extension data.
const no_extended_data = ExtendedData()

"""
    SigInfo

Data structure used as a leaf node of the `pkgdatas` data structure,
which can hold additional extension data.

Fields:
- `mt::Union{Nothing,MethodTable}`: Method table (or `nothing`)
- `sig::Type`: Signature type
- `ext::ExtendedData`: Extension data (for external tools like JET),
  stored as a linked list of [`ExtendedData`](@ref)

This is a Revise-internal data structure; when interacting with CodeTracking,
use `MethodInfoKey(::SigInfo)` to convert to `MethodInfoKey`.
"""
struct SigInfo
    mt::Union{Nothing,MethodTable}
    sig::Type
    ext::ExtendedData
    SigInfo(mt::Union{Nothing,MethodTable}, @nospecialize(sig::Type), ext::ExtendedData) = new(mt, sig, ext)
end

SigInfo(mt::Union{Nothing,MethodTable}, @nospecialize(sig::Type)) = SigInfo(mt, sig, no_extended_data)
SigInfo((mt, sig)::MethodInfoKey) = SigInfo(mt, sig, no_extended_data)

function Base.iterate(e::SigInfo, st::Int=0)
    if st == 0
        return e.mt, 1
    elseif st == 1
        return e.sig, 2
    elseif st == 2
        return e.ext, 3
    else
        return nothing
    end
end

CodeTracking.MethodInfoKey(si::SigInfo) = MethodInfoKey(si.mt, si.sig)

struct TypeInfo
    typname::Core.TypeName
    ext::ExtendedData
    TypeInfo(typname::Core.TypeName, ext::ExtendedData = no_extended_data) = new(typname, ext)
end

"""
    ExInfo(ex::Expr)

Create a cache for storing information about method and type definitions.

Adding signatures to such an object inserts them into `CodeTracking.method_info`,
which maps signature Tuple-types to `(lnn::LineNumberNode, ex::Expr)` pairs.
Because method signatures are unique within a module, this is the foundation for
identifying methods in a manner independent of source-code location.

Type definitions are also tracked to support struct revision, but unlike method
signatures, they are not currently cached in CodeTracking.

It also has the following fields:

- `exprstack`: used when descending into `@eval` statements: `ex` (used in creating the `ExInfo` object) is the first entry in the stack
- `allsigs`: a list of all method signatures defined by a given expression (cached in `CodeTracking.method_info`)
- `typeinfos`: a list of all type definitions defined by a given expression (not cached in CodeTracking)
- `includes`: a list of `(module, mapexpr, filename)` for any `include` statements encountered
  while the expression was parsed. `mapexpr` is the transform passed to
  `include(mapexpr, filename)`, or `identity` for plain `include(filename)`.
"""
struct ExInfo
    exprstack::Vector{Expr}
    allsigs::Vector{SigInfo}
    typeinfos::Vector{TypeInfo}
    includes::Vector{Tuple{Module,Function,String}}
end
ExInfo(ex::Expr) = ExInfo(Expr[ex], SigInfo[], TypeInfo[], Tuple{Module,Function,String}[])

"""
    get_extended_data(ext::ExtendedData, owner::Symbol) -> ext::Union{ExtendedData,Nothing}

Retrieve extension data for a specific owner from the linked list.
Returns `nothing` if no data is found for the given owner.
"""
function get_extended_data(ext::ExtendedData, owner::Symbol)
    while true
        ext.owner === owner && return ext
        isdefined(ext, :next) || break
        ext = ext.next
    end
    return nothing
end

"""
    get_extended_data(siginfo::SigInfo, owner::Symbol) -> ext::Union{ExtendedData,Nothing}

Retrieve extension data for a specific owner from the `SigInfo`'s extension data.
Returns `nothing` if no data is found for the given owner.
"""
get_extended_data(siginfo::SigInfo, owner::Symbol) = get_extended_data(siginfo.ext, owner)

"""
    replace_extended_data(ext::ExtendedData, owner::Symbol, @nospecialize(data)) -> new_ext::ExtendedData

Replace extension data for a specific owner, or add it if not present.
Returns a new `ExtendedData` linked list with the updated data.
"""
function replace_extended_data(ext::ExtendedData, owner::Symbol, @nospecialize(data))
    if isdefined(ext, :next)
        if ext.owner === owner
            # Base case: this is the node to replace
            return ExtendedData(owner, data, ext.next)
        else
            # Recursive case: rebuild this node with updated next
            return ExtendedData(ext.owner, ext.data, replace_extended_data(ext.next, owner, data))
        end
    else
        if ext.owner === owner
            # If this is the last node and we found the owner, just return new node
            return ExtendedData(owner, data)
        else
            # If this is the last node and we haven't found the owner, add new node at end
            return ExtendedData(ext.owner, ext.data, ExtendedData(owner, data))
        end
    end
end

"""
    replace_extended_data(siginfo::SigInfo, owner::Symbol, @nospecialize(data)) -> new_siginfo::SigInfo

Replace extension data for a specific owner in a `SigInfo`, or add it if not present.
Returns a new `SigInfo` with the updated extension data.
"""
function replace_extended_data(siginfo::SigInfo, owner::Symbol, @nospecialize(data))
    new_ext = replace_extended_data(siginfo.ext, owner, data)
    return SigInfo(siginfo.mt, siginfo.sig, new_ext)
end

const ExprsInfos = OrderedDict{RelocatableExpr,Union{Nothing,Vector{Union{SigInfo,TypeInfo}}}}

# `TypePredictions`
#
# Per-revision record of whether the incoming source preserves each type it
# (re)defines, built by `predict_changes!` before any deletions are applied.
#
# - `preserved[(mod, name)]` is `true` when evaluating the new code is predicted to
#   keep the existing binding `mod.name`: the new definition is equivalent per the
#   runtime's own redefinition checks (`Core.resolve_typegroup`'s internal
#   equivalence test, or `Core._equiv_typedef`/`Core._typebody!` on older
#   versions), so evaluation reuses the existing type and the `const` re-assert
#   leaves the binding partition untouched. `delete_missing!` consults this to skip the expensive subtype-tree
#   walk in `handle_type_deletion!` (issue #1022).
# - `skipped` records every `(typeinfo, oldtype)` whose deletion walk was skipped on
#   the strength of a prediction. Predictions are made before any queued change is
#   applied, so a same-revision change to a binding the type's structure depends on
#   (a field-type alias, a supertype, a parameter bound) can falsify them; `revise`
#   re-checks each entry after evaluation and runs the walk late for stale ones.
struct TypePredictions
    preserved::Dict{Tuple{Module,Symbol},Bool}
    skipped::Vector{Tuple{TypeInfo,Type}}
end
TypePredictions() = TypePredictions(Dict{Tuple{Module,Symbol},Bool}(), Tuple{TypeInfo,Type}[])

const DepDictVals = Tuple{Module,RelocatableExpr}
const DepDict = Dict{Symbol,Set{DepDictVals}}

function Base.show(io::IO, exs_infos::ExprsInfos)
    compact = get(io, :compact, false)
    if compact
        n_sigs = n_types = 0
        for (_, exinfos) in exs_infos
            exinfos === nothing && continue
            for exinfo in exinfos
                if exinfo isa SigInfo
                    n_sigs += 1
                else
                    n_types += 1
                end
            end
        end
        print(io, "ExprsInfos(<$(length(exs_infos)) expressions>, <$n_sigs signatures>, <$n_types types>)")
    else
        print(io, "ExprsInfos with the following expressions: ")
        for def_rex in keys(exs_infos)
            print(io, "\n  ")
            Base.show_unquoted(io, RelocatableExpr(unwrap(def_rex)), 2)
        end
    end
end

"""
    ModuleExprsInfos

For a particular source file, the corresponding `ModuleExprsInfos` is a mapping
`mod=>exprs=>mt_sigs` of the expressions `exprs` found in `mod` and the method table/signature pairs `mt_sigs`
that arise from them. Specifically, if `mes` is a `ModuleExprsInfos`, then `mes[mod][ex]`
is a list of method table/signature pairs that result from evaluating `ex` in `mod`. It is possible that
this returns `nothing`, which can mean either that `ex` does not define any methods
or that the method table/signature pairs have not yet been cached.

The first `mod` key is guaranteed to be the module into which this file was `include`d.

To create a `ModuleExprsInfos` from a source file, see [`Revise.parse_and_maybe_eval_source`](@ref).
"""
const ModuleExprsInfos = OrderedDict{Module,ExprsInfos}

function Base.typeinfo_prefix(::IO, mod_exs_infos::ModuleExprsInfos)
    tn = typeof(mod_exs_infos).name
    return string(tn.module, '.', tn.name), true
end

"""
    fm = ModuleExprsInfos(mod::Module)

Initialize an empty `ModuleExprsInfos` for a file that is `include`d into `mod`.
"""
ModuleExprsInfos(mod::Module) = ModuleExprsInfos(mod=>ExprsInfos())

Base.isempty(fm::ModuleExprsInfos) = length(fm) == 1 && isempty(first(values(fm)))

"""
    FileInfo(mod_exs_infos::ModuleExprsInfos, cachefile=""; mapexpr=identity)

Structure to hold the per-module expressions found when parsing a
single file.
`mod_exs_infos` holds the [`Revise.ModuleExprsInfos`](@ref) for the file.

`mapexpr` is the transform passed to `include(mapexpr, filename)` when the file was
included (`identity` for plain `include`). Parsing the file for revision applies the
same transform to each top-level expression, matching what `include` evaluated.
A file included more than once with different `mapexpr`s has one `FileInfo` per
inclusion (see `Revise.fileindices`).

Optionally, a `FileInfo` can also record the path to a cache file holding the original source code.
This is applicable only for precompiled modules and `Base`.
(This cache file is distinct from the original source file that might be edited by the
developer, and it will always hold the state
of the code when the package was precompiled or Julia's `Base` was built.)
When a cache is available, `mod_exs_infos` will be empty until the file gets edited:
the original source code gets parsed only when a revision needs to be made.

Source cache files greatly reduce the overhead of using Revise.
"""
struct FileInfo
    mod_exs_infos::ModuleExprsInfos
    mapexpr::Function                                  # transform applied to each top-level expression (identity if none)
    cachefile::String
    cachefilename::String                              # the source path as recorded inside `cachefile`; the lookup key for reading from the cache
    cachesrcid::Union{Nothing,UInt64}                  # identifies the source text `cachefile` holds for this file (`nothing` if unknown)
    cacheexprs::Vector{Tuple{Module,Expr}}             # "unprocessed" exprs, used to support @require
    extracted::Base.RefValue{Bool}                     # true if signatures have been processed from mod_exs_infos
    parsed::Base.RefValue{Bool}                        # true if mod_exs_infos have been parsed from cachefile
end
FileInfo(mod_exs_infos::ModuleExprsInfos, cachefile="", cachefilename=""; mapexpr::Function=identity, cachesrcid=nothing) =
    FileInfo(mod_exs_infos, mapexpr, cachefile, cachefilename, cachesrcid, Tuple{Module,Expr}[], Ref(false), Ref(false))

"""
    FileInfo(mod::Module, cachefile="", cachefilename=""; mapexpr=identity, cachesrcid=nothing)

Initialize an empty FileInfo for a file that is `include`d into `mod`.
"""
FileInfo(mod::Module, cachefile::AbstractString="", cachefilename::AbstractString=""; mapexpr::Function=identity, cachesrcid=nothing) =
    FileInfo(ModuleExprsInfos(mod), cachefile, cachefilename; mapexpr, cachesrcid)

FileInfo(fm::ModuleExprsInfos, fi::FileInfo) = FileInfo(fm, fi.mapexpr, fi.cachefile, fi.cachefilename, fi.cachesrcid, copy(fi.cacheexprs), Ref(fi.extracted[]), Ref(fi.parsed[]))

function Base.show(io::IO, fi::FileInfo)
    print(io, "FileInfo(")
    for (mod, exs_infos) in fi.mod_exs_infos
        show(io, mod)
        print(io, "=>")
        show(io, exs_infos)
        print(io, ", ")
    end
    if fi.mapexpr !== identity
        print(io, "with mapexpr ", fi.mapexpr, ", ")
    end
    if !isempty(fi.cachefile)
        print(io, "with cachefile ", fi.cachefile)
    end
    print(io, ')')
end

"""
    PkgData(id, path, fileinfos::Dict{String,FileInfo})

A structure holding the data required to handle a particular package.
`path` is the top-level directory defining the package,
and `fileinfos` holds the [`Revise.FileInfo`](@ref) for each file defining the package.
`cachebuildid` is the build id of the precompile cache this session loaded the package
from, and identifies the source snapshot the `FileInfo`s read from that cache (see
[`Revise.rewritten_caches`](@ref)); it is zero for packages not loaded from a cache.
`cacheio` is a handle held open on that cache file, which on platforms where a rename
does not disturb open handles keeps the snapshot readable even after another process
replaces the file; it is `nothing` when no handle is held.

For the `PkgData` associated with `Main` (e.g., for files loaded with [`includet`](@ref)),
the corresponding `path` entry will be empty.
"""
mutable struct PkgData
    info::PkgFiles
    fileinfos::Vector{FileInfo}
    requirements::Vector{PkgId}
    cachebuildid::UInt128        # build id of the precompile cache this session loaded (0 if none)
    cacheio::Union{Nothing,IOStream}   # handle held open on that cache file, where the platform allows it
end

PkgData(id::PkgId, path) = PkgData(PkgFiles(id, path), FileInfo[], PkgId[], zero(UInt128), nothing)
PkgData(id::PkgId, ::Nothing) = PkgData(id, "")
function PkgData(id::PkgId)
    bp = basepath(id)
    if !isempty(bp) && !isabspath(bp)
        bp = abspath(bp)
    end
    PkgData(id, bp)
end

# Abstraction interface for PkgData
Base.PkgId(pkgdata::PkgData) = PkgId(pkgdata.info)
CodeTracking.basedir(pkgdata::PkgData) = basedir(pkgdata.info)
CodeTracking.srcfiles(pkgdata::PkgData) = srcfiles(pkgdata.info)

function fileindex(info::PkgData, file::AbstractString)
    for (i, f) in enumerate(srcfiles(info))
        String(f) == String(file) && return i
    end
    return nothing
end

# A single file may be `include`d into several modules, in which case it appears
# once in `srcfiles` per inclusion, each with its own `FileInfo` (issue #730).
# `fileindices` returns every such index so a revision updates all of them.
function fileindices(info::PkgData, file::AbstractString)
    sf = String(file)
    return Int[i for (i, f) in enumerate(srcfiles(info)) if String(f) == sf]
end

function hasfile(info::PkgData, file::AbstractString)
    if isabspath(file)
        file = relpath(file, info)
    end
    fileindex(info, file) !== nothing
end

function fileinfo(pkgdata::PkgData, file::String)
    i = fileindex(pkgdata, file)
    i === nothing && error("file ", file, " not found")
    return pkgdata.fileinfos[i]
end
fileinfo(pkgdata::PkgData, i::Int) = pkgdata.fileinfos[i]

function Base.push!(pkgdata::PkgData, pr::Pair{<:AbstractString,FileInfo})
    push!(srcfiles(pkgdata), pr.first)
    push!(pkgdata.fileinfos, pr.second)
    return pkgdata
end

function Base.show(io::IO, pkgdata::PkgData)
    compact = get(io, :compact, false)
    print(io, "PkgData(")
    if compact
        print(io, '"', pkgdata.info.basedir, "\", ")
        nexs, nsigs, nparsed = 0, 0, 0
        for fi in pkgdata.fileinfos
            thisnexs, thisnsigs = 0, 0
            for (_, exs_infos) in fi.mod_exs_infos
                for (_, exinfos) in exs_infos
                    thisnexs += 1
                    exinfos === nothing && continue
                    thisnsigs += length(exinfos)
                end
            end
            nexs += thisnexs
            nsigs += thisnsigs
            if thisnexs > 0
                nparsed += 1
            end
        end
        print(io, nparsed, '/', length(pkgdata.fileinfos), " parsed files, ", nexs, " expressions, ", nsigs, " signatures)")
    else
        show(io, pkgdata.info.id)
        println(io, ", basedir \"", pkgdata.info.basedir, "\":")
        for (f, fi) in zip(pkgdata.info.files, pkgdata.fileinfos)
            print(io, "  \"", f, "\": ")
            show(IOContext(io, :compact=>true), fi)
            print(io, '\n')
        end
    end
end

function pkgfileless((pkgdata1,file1)::Tuple{PkgData,String}, (pkgdata2,file2)::Tuple{PkgData,String})
    # implements a partial order
    PkgId(pkgdata1) ∈ pkgdata2.requirements && return true
    PkgId(pkgdata1) == PkgId(pkgdata2) && return fileindex(pkgdata1, file1) < fileindex(pkgdata2, file2)
    return false
end

"""
    ReviseEvalException(loc::String, exc::Exception, stacktrace=nothing)

Provide additional location information about `exc`.

When running via the interpreter, the backtraces point to interpreter code rather than the original
culprit. This makes it possible to use `loc` to provide information about the frame backtrace,
and even to supply a fake backtrace.

If `stacktrace` is supplied it must be a `Vector{Any}` containing `(::StackFrame, n)` pairs where `n`
is the recursion count (typically 1).
"""
struct ReviseEvalException <: Exception
    loc::String
    exc::Exception
    stacktrace::Union{Nothing,Vector{Any}}
end
ReviseEvalException(loc::AbstractString, exc::Exception) = ReviseEvalException(loc, exc, nothing)

function Base.showerror(io::IO, ex::ReviseEvalException; blame_revise::Bool=true)
    showerror(io, ex.exc)
    st = ex.stacktrace
    if st !== nothing
        Base.show_backtrace(io, st)
    end
    if blame_revise
        println(io, "\nRevise evaluation error at ", ex.loc)
    end
end

"""
    StaleCacheError(id::PkgId, file::String)

Reports that `file` cannot be revised because the precompile cache of `id` no longer
holds the source this session loaded it from, leaving nothing to compare the current
source against. See [`Revise.rewritten_caches`](@ref).
"""
struct StaleCacheError <: Exception
    id::PkgId
    file::String
end

function Base.showerror(io::IO, err::StaleCacheError)
    print(io, """
        $(err.file) cannot be revised: the precompile cache of $(err.id.name) was rebuilt by another process, and the source this session loaded for this file is no longer recorded anywhere, so there is nothing to compare the current source against.
        The definitions in this file remain as they were when the session loaded them. Restart Julia to pick up their current state.""")
end

"""
    SignatureExtractionError(mod::Module, loc::String, exc::Exception)

Reports a failure to reconstruct method signatures using partial evaluation.
"""
struct SignatureExtractionError <: Exception
    mod::Module
    loc::String
    exc
    SignatureExtractionError(mod::Module, loc::String, @nospecialize exc) = new(mod, loc, exc)
end

function captured_stacktrace(ex::SignatureExtractionError)
    cause = ex.exc
    while cause isa ReviseEvalException
        cause.stacktrace === nothing || return cause.stacktrace
        cause = cause.exc
    end
    return nothing
end

function Base.showerror(io::IO, ex::SignatureExtractionError)
    print(io, "failed to extract method signatures for ", ex.mod, " at ", ex.loc)
    print(io, "\nRevise could not determine which methods this top-level expression defines")
    print(io, "\nwithout re-running module initialization. Generated definitions may depend")
    print(io, "\non temporary state created by earlier top-level operations, such as mutation")
    print(io, "\nor `@eval`. To make this file revisable, derive each generated definition")
    print(io, "\ndirectly from stable inputs rather than from state built by preceding")
    print(io, "\noperations. (`mode = :sigs` does not replay all assignments and side effects.)")
    print(io, "\n\ncaused by: ")
    cause = ex.exc
    while cause isa ReviseEvalException
        cause = cause.exc
    end
    showerror(io, cause)
    stacktrace = captured_stacktrace(ex)
    stacktrace === nothing || Base.show_backtrace(io, stacktrace)
end

struct GitRepoException <: Exception
    filename::String
end

function Base.showerror(io::IO, ex::GitRepoException)
    print(io, "no repository at ", ex.filename, " to track stdlibs you must build Julia from source")
end

struct LoweringException <: Exception
    ex::Expr
end

function Base.showerror(io::IO, ex::LoweringException)
    print(io, "lowering returned an exception:\n", ex.ex)
end

"""
    thunk = TaskThunk(f, args)

To facilitate precompilation and reduce latency, we avoid creation of anonymous thunks.
`thunk` can be used as an argument in `schedule(Task(thunk))`.
"""
struct TaskThunk
    f          # deliberately untyped
    args       # deliberately untyped
end

@noinline (thunk::TaskThunk)() = thunk.f(thunk.args...)

function relpath_safe(path::AbstractString, startpath::AbstractString)
    isempty(startpath) && return path
    if ispath(path)
        path = relpath(realpath(path), realpath(startpath))
        !isabspath(path) && return path
    end
    return relpath(path, startpath)
end

function Base.relpath(filename::AbstractString, pkgdata::PkgData)
    if isabspath(filename)
        filename = relpath_safe(filename, basedir(pkgdata))
    elseif startswith(filename, "compiler")
        # Core.Compiler's pkgid includes "compiler/" in the path
        filename = relpath(filename, "compiler")
    end
    return filename
end

function iswritable(file::AbstractString)  # note this trashes the Base definition, but we don't need it
    return uperm(stat(file)) & 0x02 != 0x00
end

function unique_dirs(iter)
    udirs = Set{String}()
    for file in iter
        dir, _ = splitdir(file)
        push!(udirs, dir)
    end
    return udirs
end

function abspath_no_normalize(a)
    if !isabspath(a)
        cwd = pwd()
        a_drive, a_nodrive = splitdrive(a)
        if a_drive != "" && lowercase(splitdrive(cwd)[1]) != lowercase(a_drive)
            cwd = a_drive * Base.Filesystem.path_separator
            a = joinpath(cwd, a_nodrive)
        else
            a = joinpath(cwd, a)
        end
    end
    return a
end

function file_exists(filename::AbstractString)
    filename = normpath(filename)
    isfile(filename) && return true
    alt = get(cache_file_key, filename, nothing)
    alt === nothing && return false
    return isfile(alt)
end

function use_compiled_modules()
    return Base.JLOptions().use_compiled_modules != 0
end

function firstline(ex::Expr)
    for a in ex.args
        isa(a, LineNumberNode) && return a
        if isa(a, Expr)
            line = firstline(a)
            isa(line, LineNumberNode) && return line
        end
    end
    return nothing
end
firstline(rex::RelocatableExpr) = firstline(rex.ex)

location_string((file, line)::Tuple{AbstractString, Any},) = abspath(file)*':'*string(line)
location_string((file, line)::Tuple{Symbol, Any},) = location_string((string(file), line))
location_string(::Nothing) = "unknown location"

function linediff(la::LineNumberNode, lb::LineNumberNode)
    (isa(la.file, Symbol) && isa(lb.file, Symbol) && (la.file::Symbol === lb.file::Symbol)) || return typemax(Int)
    return abs(la.line - lb.line)
end

# Return the only non-trivial expression in ex, or ex itself
function unwrap(ex::Expr)
    if ex.head === :block || ex.head === :toplevel
        for (i, a) in enumerate(ex.args)
            if isa(a, Expr)
                for j = i+1:length(ex.args)
                    istrivial(ex.args[j]) || return ex
                end
                return unwrap(a)
            elseif !istrivial(a)
                return ex
            end
        end
        return nothing
    end
    return ex
end
unwrap(rex::RelocatableExpr) = RelocatableExpr(unwrap(rex.ex))

istrivial(@nospecialize a) = a === nothing || isa(a, LineNumberNode)

function unwrap_where(ex::Expr)
    while isexpr(ex, :where)
        ex = ex.args[1]
    end
    return ex::Expr
end

function pushex!(exs_infos::ExprsInfos, ex::Expr)
    uex = unwrap(ex)
    if is_doc_expr(uex)
        body = uex.args[4]
        # Don't trigger for exprs where the documented expression is just a signature
        # (e.g. `"docstr" f(x::Int)`, `"docstr" f(x::T) where T` etc.)
        if isa(body, Expr) && unwrap_where(body).head !== :call
            exs_infos[RelocatableExpr(body)] = nothing
        end
        if length(uex.args) < 5
            push!(uex.args, false)
        else
            uex.args[5] = false
        end
    end
    exs_infos[RelocatableExpr(ex)] = nothing
    return exs_infos
end

## WatchList utilities
Base.push!(wl::WatchList, filenameid::Pair{<:AbstractString,PkgId}) =
    push!(wl.trackedfiles, filenameid)
Base.push!(wl::WatchList, filenameid::Pair{<:AbstractString,PkgFiles}) =
    push!(wl, filenameid.first=>filenameid.second.id)
Base.push!(wl::WatchList, filenameid::Pair{<:AbstractString,PkgData}) =
    push!(wl, filenameid.first=>filenameid.second.info)
WatchList() = WatchList(Dict{String,PkgId}(), Dict{String,Float64}(), Dict{String,UInt64}())
Base.in(file, wl::WatchList) = haskey(wl.trackedfiles, file)

"""
    success = throwto_repl(e::Exception)

Try throwing `e` from the REPL's backend task. Returns `true` if the necessary conditions
were met and the throw can be expected to succeed. The throw is generated from another
task, so a `yield` will need to occur before it happens.
"""
function throwto_repl(e::Exception)
    if isdefined(Base, :active_repl_backend) &&
            !isnothing(Base.active_repl_backend) &&
            Base.active_repl_backend.backend_task.state === :runnable &&
            isempty(Base.Workqueue) &&
            Base.active_repl_backend.in_eval
        @async Base.throwto(Base.active_repl_backend.backend_task, e)
        return true
    end
    return false
end

function printf_maxsize(f::Function, io::IO, args...; maxchars::Integer=500, maxlines::Integer=20)
    # This is dumb but certain to work
    iotmp = IOBuffer()
    for a in args
        print(iotmp, a)
    end
    print(iotmp, '\n')
    seek(iotmp, 0)
    str = read(iotmp, String)
    if length(str) > maxchars
        str = first(str, (maxchars+1)÷2) * "…" * last(str, maxchars - (maxchars+1)÷2)
    end
    lines = split(str, '\n')
    if length(lines) <= maxlines
        for line in lines
            f(io, line)
        end
        return
    end
    half = (maxlines+1) ÷ 2
    for i = 1:half
        f(io, lines[i])
    end
    maxlines > 1 && f(io, '⋮')
    for i = length(lines) - (maxlines-half) + 1:length(lines)
        f(io, lines[i])
    end
end
println_maxsize(args...; kwargs...) = println_maxsize(stdout, args...; kwargs...)
println_maxsize(io::IO, args...; kwargs...) = printf_maxsize(println, io, args...; kwargs...)

"""
    trim_toplevel!(bt)

Truncate a list of instruction pointers, as obtained from `backtrace()` or `catch_backtrace()`,
at the first "top-level" call (e.g., as executed from the REPL prompt) or the
first entry corresponding to a method in Revise or its dependencies.

This is used to make stacktraces obtained with Revise more similar to those obtained
without Revise, while retaining one entry to reveal Revise's involvement.
"""
function trim_toplevel!(bt)
    # return bt       # uncomment this line if you're debugging Revise itself
    n = itoplevel = length(bt)
    for (i, t) in enumerate(bt)
        sfs = StackTraces.lookup(t)
        for sf in sfs
            if sf.func === Symbol("top-level scope") || (let mi = sf.linfo
                mi isa Core.MethodInstance && (let def = mi.def
                    def isa Method && def.module ∈ (JuliaInterpreter, LoweredCodeUtils, Revise)
                end) end)
                itoplevel = i
                break
            end
        end
        itoplevel < n && break
    end
    deleteat!(bt, itoplevel+1:length(bt))
    return bt
end

# For this test, Julia should be started without Revise and then it should be added to the running session
# Catches #664

using Test

t = @async(
    VERSION >= v"1.12.0-DEV.612" ? Base.run_main_repl(true, true, :no, true) :
    VERSION >= v"1.11.0-DEV.222" ? Base.run_main_repl(true, true, :no, true, false)   :
                                   Base.run_main_repl(true, true, false, true, false))
isdefined(Base, :errormonitor) && Base.errormonitor(t)
while !isdefined(Base, :active_repl_backend) || isnothing(Base.active_repl_backend)
    sleep(0.5)
end

using Revise
@test Revise.revise_first ∈ Base.active_repl_backend.ast_transforms

exit()

# Globals needed to support `entr` and other callbacks

"""
    Revise.revision_event::Base.Event

This event is used to notify `entr` that one of the watched files has changed.
It is created with `autoreset=true` so that a `notify` fired between a waiter's
return from `wait` and its next call to `wait` is not lost — see issue #837.
"""
const revision_event = Base.Event(true)

"""
    Revise.user_callbacks_queue

Global variable, `user_callbacks_queue` holds `key` values for which the
file has changed but the user hooks have not yet been called.
"""
const user_callbacks_queue = Set{Any}()

"""
    Revise.user_callbacks_by_file

Global variable, maps files (identified by their absolute path) to the set of
callback keys registered for them.
"""
const user_callbacks_by_file = Dict{String, Set{Any}}()

"""
    Revise.user_callbacks_by_key

Global variable, maps callback keys to user hooks.
"""
const user_callbacks_by_key = Dict{Any, Any}()

"""
    key = Revise.add_callback(f, files, modules=nothing; key=gensym())

Add a user-specified callback, to be executed during the first run of
`revise()` after a file in `files` or a module in `modules` is changed on the
file system. If `all` is set to `true`, also execute the callback whenever any
file already monitored by Revise changes. In an interactive session like the
REPL, Juno or Jupyter, this means the callback executes immediately before
executing a new command / cell.

You can use the return value `key` to remove the callback later
(`Revise.remove_callback`) or to update it using another call
to `Revise.add_callback` with `key=key`.
"""
function add_callback(f, files, modules=nothing; all=false, key=gensym())
    fix_trailing(path) = isdir(path) ? joinpath(path, "") : path   # insert a trailing '/' if missing, see https://github.com/timholy/Revise.jl/issues/470#issuecomment-633298553

    remove_callback(key)

    files = map(fix_trailing, map(abspath, files))
    init_watching(files)

    # in case the `all` kwarg was set:
    # add all files which are already known to Revise
    if all
        for pkgdata in allpkgdatas()
            append!(files, joinpath.(Ref(basedir(pkgdata)), srcfiles(pkgdata)))
        end
    end

    if modules !== nothing
        for mod in modules
            track(mod)  # Potentially needed for modules like e.g. Base
            id = PkgId(mod)
            pkgdata = getpkgdata(id)
            pkgdata === nothing && continue
            for file in srcfiles(pkgdata)
                absname = joinpath(basedir(pkgdata), file)
                push!(files, absname)
            end
        end
    end

    # There might be duplicate entries in `files`, but it shouldn't cause any
    # problem with the sort of things we do here
    @lock revise_lock begin
        for file in files
            cb = get!(Set, user_callbacks_by_file, file)
            push!(cb, key)
        end
        user_callbacks_by_key[key] = f
    end

    return key
end

"""
    Revise.remove_callback(key)

Remove a callback previously installed by a call to `Revise.add_callback(...)`.
See its docstring for details.
"""
function remove_callback(key)
    @lock revise_lock begin
        for cbs in values(user_callbacks_by_file)
            delete!(cbs, key)
        end
        delete!(user_callbacks_queue, key)
        delete!(user_callbacks_by_key, key)
    end

    # possible future work: we may stop watching (some of) these files
    # now. But we don't really keep track of what background tasks are running
    # and Julia doesn't have an ergonomic way of task cancellation yet (see
    # e.g.
    #     https://github.com/JuliaLang/Juleps/blob/master/StructuredConcurrency.md
    # so we'll omit this for now. The downside is that in pathological cases,
    # this may exhaust inotify resources.

    nothing
end

function process_user_callbacks!(keys = user_callbacks_queue; throw::Bool=false)
    try
        # use (a)sync so any exceptions get nicely collected into CompositeException
        @sync for key in keys
            f = user_callbacks_by_key[key]
            @async Base.invokelatest(f)
        end
    catch err
        if throw
            rethrow(err)
        else
            @warn "[Revise] Ignoring callback errors" err
        end
    finally
        empty!(keys)
    end
end

"""
    entr(f, files; all=false, postpone=false, pause=0.02)
    entr(f, files, modules; all=false, postpone=false, pause=0.02)

Execute `f()` whenever files or directories listed in `files`, or code in `modules`, updates.
If `all` is `true`, also execute `f()` as soon as code updates are detected in
any module tracked by Revise.

`entr` will process updates (and block your command line) until you press Ctrl-C.
Unless `postpone` is `true`, `f()` will be executed also when calling `entr`,
regardless of file changes. The `pause` is the quiet period (in seconds) that
`entr` waits after the most recent change before calling `f()`; a cluster of
modifications less than `pause` apart — such as those produced by saving files
in certain text editors — therefore triggers only a single call.

# Example

```julia
entr(["/tmp/watched.txt"], [Pkg1, Pkg2]) do
    println("update")
end
```
This will print "update" every time `"/tmp/watched.txt"` or any of the code defining
`Pkg1` or `Pkg2` gets updated.
"""
function entr(f::Function, files, modules=nothing; all=false, postpone=false, pause=0.02)
    yield()
    postpone || f()
    # `entr` runs `f` on a trailing-edge debounce: a change schedules `f` for
    # `pause` seconds later, and any further change before then pushes the
    # deadline out. A burst of changes no more than `pause` apart therefore
    # collapses into a single `f()` call.
    lk = ReentrantLock()
    deadline = Ref(0.0)                          # `time()` at which `f` should next run; a past value means "nothing pending"
    dtask = Ref{Union{Task,Nothing}}(nothing)    # the in-flight debounce task, or `nothing`
    err = Ref{Any}(nothing)                      # an error from `f`, relayed to the loop below so it can rethrow
    stopped = Ref(false)
    function run_debounce()
        while true
            remaining = @lock lk begin
                local remaining = deadline[] - time()
                # Decide to exit and clear `dtask` atomically, so a change
                # arriving now either extends this task or spawns a fresh one.
                remaining <= 0 && (dtask[] = nothing)
                remaining
            end
            remaining <= 0 && break
            sleep(remaining)
        end
        stopped[] && return
        try
            Base.invokelatest(f)  # `f` typically calls code that `revise` just updated
        catch e
            err[] = e
            notify(revision_event)  # wake the loop below so it can rethrow
        end
        return
    end
    # The watch callback fires once per detected change and must return
    # promptly (it runs while `revise` holds `revise_lock`), so it only
    # records a new deadline; the wait and `f()` happen in `run_debounce`. A
    # debounce task already counting down will see the bumped `deadline` and
    # extend itself, so spawn one only when `dtask` is empty. Pairing this with
    # the task clearing `dtask` as it commits to exit (both under `lk`) means a
    # change racing an expiring task either extends it or spawns its successor.
    key = add_callback(files, modules; all=all) do
        @lock lk begin
            deadline[] = time() + pause
            if dtask[] === nothing
                dtask[] = @async run_debounce()
            end
        end
    end
    try
        while true
            wait(revision_event)  # autoreset; see issue #837
            err[] === nothing || throw(err[])
            revise(throw=true)
            err[] === nothing || throw(err[])
        end
    catch e
        isa(e, InterruptException) || rethrow(e)
    finally
        stopped[] = true
        remove_callback(key)
    end
    nothing
end

module test_visit

using Revise, Test

function record_invalidations_for_type_deletion(@nospecialize oldtype)
    reeval_list = IdSet{Union{Method,Type}}()
    handled_types = IdSet{Type}()
    alltypes = Revise.all_named_types()
    Revise.record_invalidations_for_type_deletion!(oldtype, reeval_list, handled_types, alltypes)
    return reeval_list
end

struct TestVisitInner1; x::Int; end
struct TestVisit1; x::TestVisitInner1; end
func_test_visit1(::TestVisit1) = nothing
let oldtype = TestVisitInner1
    reeval_list = record_invalidations_for_type_deletion(oldtype)
    @test TestVisit1 in reeval_list
    for m in methods(TestVisit1)
        @test m in reeval_list
    end
    m = only(methods(func_test_visit1, (TestVisit1,)))
    @test m in reeval_list
end

abstract type TestVisitAbs2 end
struct TestVisitInner2 <: TestVisitAbs2; x::Int; end
struct TestVisit2; x::TestVisitInner2; end
func_test_visit_abs2(::TestVisitAbs2) = nothing
func_test_visit2(::TestVisit2) = nothing
let oldtype = TestVisitInner2
    reeval_list = record_invalidations_for_type_deletion(oldtype)
    @test TestVisit2 in reeval_list
    @test TestVisitAbs2 ∉ reeval_list
    for m in methods(TestVisit2)
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit_abs2, (TestVisitAbs2,)))
        @test m ∉ reeval_list
    end
    let m = only(methods(func_test_visit2, (TestVisit2,)))
        @test m in reeval_list
    end
end
let oldtype = TestVisitAbs2
    reeval_list = record_invalidations_for_type_deletion(oldtype)
    @test TestVisit2 in reeval_list
    for m in methods(TestVisit2)
        @test m in reeval_list
    end
    @test TestVisitInner2 in reeval_list
    for m in methods(TestVisitInner2)
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit_abs2, (TestVisitAbs2,)))
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit2, (TestVisit2,)))
        @test m in reeval_list
    end
end

abstract type TestVisitAbs3 end
struct TestVisitInner3{T} <: TestVisitAbs3; x::T; end
struct TestVisit3{T<:TestVisitInner3}; x::T; end
func_test_visit_abs3(::TestVisitAbs3) = nothing
func_test_visit3(::TestVisit3) = nothing
let oldtype = TestVisitAbs3
    reeval_list = record_invalidations_for_type_deletion(oldtype)
    @test TestVisit3 in reeval_list
    for m in methods(TestVisit3)
        @test m in reeval_list
    end
    @test TestVisitInner3 in reeval_list
    for m in methods(TestVisitInner3)
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit_abs3, (TestVisitAbs3,)))
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit3, (TestVisit3,)))
        @test m in reeval_list
    end
end

abstract type TestVisitAbs4 end
struct TestVisitInner4{T} <: TestVisitAbs4; x::T; end
struct TestVisit4; xs::Vector{<:TestVisitInner4}; end
func_test_visit_abs4(::TestVisitAbs4) = nothing
func_test_visit4(::TestVisit4) = nothing
let oldtype = TestVisitAbs4
    reeval_list = record_invalidations_for_type_deletion(oldtype)
    @test TestVisit4 in reeval_list
    for m in methods(TestVisit4)
        @test m in reeval_list
    end
    @test TestVisitInner4 in reeval_list
    for m in methods(TestVisitInner4)
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit_abs4, (TestVisitAbs4,)))
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit4, (TestVisit4,)))
        @test m in reeval_list
    end
end

struct TestVisitInner5; x::Int; end
struct TestVisitOther5; end
struct TestVisit5; x::Union{TestVisitInner5, TestVisitOther5}; end
func_test_visit_union5(::Union{TestVisitInner5, TestVisitOther5}) = nothing
func_test_visit5(::TestVisit5) = nothing
let oldtype = TestVisitInner5
    reeval_list = record_invalidations_for_type_deletion(oldtype)
    @test TestVisit5 in reeval_list
    for m in methods(TestVisit5)
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit_union5, (TestVisitInner5,)))
        @test m in reeval_list
    end
    let m = only(methods(func_test_visit5, (TestVisit5,)))
        @test m in reeval_list
    end
end

end # test_visit

## Analyzing lowered code

function assign_this!(frame::Frame, @nospecialize value)
    frame.framedata.ssavalues[frame.pc] = value
end

# The callee of a lowered statement may be a `GlobalRef`, or the function itself: JuliaInterpreter
# resolves some `GlobalRef`s to their values (as a `QuoteNode`) when it builds a `FrameCode`.
function is_getproperty(@nospecialize(f))
    isa(f, QuoteNode) && (f = f.value)
    isa(f, GlobalRef) && return f.name === :getproperty
    return f === getproperty
end

function is_some_include(@nospecialize(f))
    @assert !isa(f, Core.SSAValue) && !isa(f, JuliaInterpreter.SSAValue)
    if isa(f, GlobalRef)
        return f.name === :include
    elseif isa(f, Symbol)
        return f === :include
    elseif isa(f, Expr)
        # A qualified `Mod.include` (e.g. `Base.include(mapexpr, mod, path)`) lowers to a
        # `getproperty` call, so the callee of the `include` call is that expression rather
        # than a `GlobalRef`. Whether it really resolves to an `include` function is settled
        # by identity when the call is reached; here it need only be a candidate.
        isexpr(f, :call) && length(f.args) == 3 || return false
        is_getproperty(f.args[1]) || return false
        name = f.args[3]
        isa(name, QuoteNode) && (name = name.value)
        return name === :include
    else
        if isa(f, QuoteNode)
            f = f.value
        end
        if isa(f, Function)
            if @static isdefined(Base, :IncludeInto) && isa(f, Base.IncludeInto)
                return true
            end
            mod = Base.typename(typeof(f)).module
            return isdefined(mod, :include) && f === (@isdefined(getglobal) ? getglobal(mod, :include) : getfield(mod, :include))
        end
    end
    return false
end

function is_defaultctors(@nospecialize(f))
    @assert !isa(f, Core.SSAValue) && !isa(f, JuliaInterpreter.SSAValue)
    if isa(f, GlobalRef)
        return (f.mod === Core || f.mod === Base) && f.name === :_defaultctors
    else
        if isa(f, QuoteNode)
            f = f.value
        end
        if isdefined(Core, :_defaultctors) && f === Core._defaultctors
            return true
        elseif isdefined(Base, :_defaultctors) && f === Base._defaultctors
            return true
        end
    end
    return false
end

is_define_method_ref(@nospecialize(f)) = isdefined(LoweredCodeUtils, :is_define_method_ref) &&
    getfield(LoweredCodeUtils, :is_define_method_ref)(f)
is_methoddef(@nospecialize(stmt)) = isdefined(LoweredCodeUtils, :ismethod) ?
    getfield(LoweredCodeUtils, :ismethod)(stmt) : isexpr(stmt, :method)
is_methoddef1(@nospecialize(stmt)) = isdefined(LoweredCodeUtils, :ismethod1) ?
    getfield(LoweredCodeUtils, :ismethod1)(stmt) : isexpr(stmt, :method, 1)
is_define_method_call_4arg(@nospecialize(stmt)) =
    isdefined(LoweredCodeUtils, :is_define_method_call_4arg) &&
    getfield(LoweredCodeUtils, :is_define_method_call_4arg)(stmt)

function matches_eval(stmt::Expr)
    stmt.head === :call || return false
    f = stmt.args[1]
    return f === :eval ||
           (callee_matches(f, Base, :getproperty) && is_quotenode_egal(stmt.args[end], :eval)) ||
           (isa(f, GlobalRef) && f.name === :eval) || is_quotenode_egal(f, Core.eval)
end

function categorize_stmt(@nospecialize(stmt), code::Vector{Any})
    ismeth, haseval, isinclude, isnamespace, istoplevel = false, false, false, false, false
    if isa(stmt, Expr)
        haseval = matches_eval(stmt)
        ismeth = stmt.head === :method || (stmt.head === :thunk && defines_function(only(stmt.args)))
        istoplevel = stmt.head === :toplevel
        isnamespace = stmt.head === :export || stmt.head === :import || stmt.head === :using
        isinclude = false
        if stmt.head === :call && length(stmt.args) >= 1
            callee = stmt.args[1]
            while isa(callee, Core.SSAValue) || isa(callee, JuliaInterpreter.SSAValue)
                callee = code[callee.id]
            end
            isinclude = is_some_include(callee)
            ismeth = is_defaultctors(callee) || is_define_method_ref(callee)
        end
    end
    return ismeth, haseval, isinclude, isnamespace, istoplevel
end
# Check for thunks that define functions (fixes #792)
function defines_function(@nospecialize(ci))
    isa(ci, CodeInfo) || return false
    if length(ci.code) == 1
        stmt = ci.code[1]
        if isa(stmt, Core.ReturnNode)
            val = stmt.val
            isexpr(val, :method) && return true
        end
    end
    return false
end

"""
    isrequired, evalassign = minimal_evaluation!([predicate,] src::Core.CodeInfo, mode::Symbol)

Mark required statements in `src`: `isrequired[i]` is `true` if `src.code[i]` should be evaluated.
Statements are analyzed by `isreq, haseval = predicate(stmt)`.
`haseval` is true if the statement came from `@eval` or `eval(...)` call.
Since the contents of such expression are difficult to analyze, it is generally
safest to execute all such evals.
"""
function minimal_evaluation!(@nospecialize(predicate), mod::Module, src::Core.CodeInfo, mode::Symbol)
    edges = CodeEdges(mod, src)
    # LoweredCodeUtils.print_with_code(stdout, src, edges)
    isrequired = fill(false, length(src.code))
    namedconstassigned = Dict{GlobalRef,Bool}()
    evalassign = false
    for (i, stmt) in enumerate(src.code)
        if !isrequired[i]
            isrequired[i], haseval = predicate(stmt, src.code)::Tuple{Bool,Bool}
            if haseval                              # line `i` may be the equivalent of `f = Core.eval`, so...
                isrequired[edges.succs[i]] .= true  # ...require each stmt that calls `eval` via `f(expr)`
                isrequired[i] = true
            end
        end
        if isexpr(stmt, :const)
            name = stmt.args[1]
            if isa(name, Symbol)
                name = GlobalRef(mod, name)
            end
            namedconstassigned[name::GlobalRef] = false
        elseif (lhs_rhs = LoweredCodeUtils.get_lhs_rhs(stmt); lhs_rhs !== nothing)
            lhs, _ = lhs_rhs
            if isa(lhs, Symbol)
                lhs = GlobalRef(mod, lhs)
            end
            if isa(lhs, GlobalRef)
                if haskey(namedconstassigned, lhs)
                    namedconstassigned[lhs] = true
                end
            end
            if mode === :evalassign
                evalassign = isrequired[i] = true
                if isa(lhs, GlobalRef)
                    isrequired[edges.byname[lhs].succs] .= true  # mark any `const` statements or other "uses" in this block
                end
            end
        end
    end
    if mode === :sigs
        for (name, isassigned) in namedconstassigned
            isassigned || continue
            if isdefined(name.mod, name.name)
                empty!(edges.byname[name].succs)   # avoid redefining `consts` in `:sigs` mode (fixes #789)
            end
        end
    end
    # Check for docstrings
    if length(src.code) > 1 && mode !== :sigs
        stmt = src.code[end-1]
        if isexpr(stmt, :call) && (stmt::Expr).args[1] === Base.Docs.doc!
            isrequired[end-1] = true
        end
    end
    # All tracked expressions are marked. Now add their dependencies.
    # LoweredCodeUtils.print_with_code(stdout, src, isrequired)
    lines_required!(isrequired, src, edges;)
                    # norequire = mode === :sigs ? LoweredCodeUtils.exclude_named_typedefs(src, edges) : ())
    # LoweredCodeUtils.print_with_code(stdout, src, isrequired)
    return isrequired, evalassign
end
@noinline minimal_evaluation!(@nospecialize(predicate), frame::Frame, mode::Symbol) =
    minimal_evaluation!(predicate, moduleof(frame), frame.framecode.src, mode)

function minimal_evaluation!(frame::Frame, mode::Symbol)
    minimal_evaluation!(frame, mode) do @nospecialize(stmt), code::Vector{Any}
        ismeth, haseval, isinclude, isnamespace, istoplevel = categorize_stmt(stmt, code)
        isreq = ismeth | isinclude | istoplevel
        return mode === :sigs ? (isreq, haseval) : (isreq | isnamespace, haseval)
    end
end

function methods_by_execution(mod::Module, ex::Expr; kwargs...)
    exinfo = ExInfo(ex)
    _, thk = methods_by_execution!(JuliaInterpreter.Compiled(), exinfo, mod, ex; kwargs...)
    return exinfo, thk
end

"""
    methods_by_execution!(
        [interp::Interpreter=JuliaInterpreter.Compiled(),] exinfo::ExInfo, mod::Module, ex::Expr;
        mode::Symbol = :eval, disablebp::Bool = true, skip_include::Bool = mode!==:eval, always_rethrow::Bool = false
    )

Evaluate or analyze `ex` in the context of `mod`.
Depending on the setting of `mode` (see the Extended help), it supports full evaluation or just the minimal
evaluation needed to extract method signatures.
`interp` controls JuliaInterpreter's evaluation of any non-intercepted statement;
likely choices are `JuliaInterpreter.Compiled()` or `JuliaInterpreter.RecursiveInterpreter()`.
`exinfo` is a cache for storing information about any method definitions (see [`ExInfo`](@ref)).

# Extended help

The action depends on `mode`:

- `:eval` evaluates the expression in `mod`, similar to `Core.eval(mod, ex)` except that `exinfo`
  will be populated with information about any signatures. This mode is used to implement `includet`.
- `:sigs` analyzes `ex` and extracts signatures of methods (specifically, statements flagged by
  [`Revise.minimal_evaluation!`](@ref)), but does not evaluate `ex` in the traditional sense.
  It will selectively execute statements needed to form the signatures of defined methods.
  It will also expand any `@eval`ed expressions, since these might contain method definitions.
- `:evalmeth` analyzes `ex` and extracts signatures like `:sigs`, but takes the additional step of
  evaluating any `:method` statements.
- `:evalassign` acts similarly to `:evalmeth`, and also evaluates assignment statements.

When selectively evaluating an expression, Revise will incorporate required dependencies, even for
minimal-evaluation modes like `:sigs`. For example, the method definition

    max_values(T::Union{map(X -> Type{X}, Base.BitIntegerSmall_types)...}) = 1 << (8*sizeof(T))

found in `base/abstractset.jl` requires that it create the anonymous function in order to compute the
signature.

The other keyword arguments are more straightforward:

- `disablebp` controls whether JuliaInterpreter's breakpoints are disabled before stepping through the code.
  They are restored on exit.
- `skip_include` prevents execution of `include` statements, instead inserting them into `exinfo`'s
  cache. This defaults to `true` unless `mode` is `:eval`.
- `always_rethrow`, if true, causes an error to be thrown if evaluating `ex` triggered an error.
  If false, the error is logged with `@error`. `InterruptException`s are always rethrown.
  This is primarily useful for debugging.
"""
function methods_by_execution!(
        interp::Interpreter, exinfo::ExInfo, mod::Module, ex::Expr;
        mode::Symbol = :eval, disablebp::Bool = true, always_rethrow::Bool = false, kwargs...
    )
    mode ∈ (:sigs, :eval, :evalmeth, :evalassign) || error("unsupported mode ", mode)
    lwr = Meta.lower(mod, ex)
    isa(lwr, Expr) || return Pair{Any,Union{Nothing,Expr}}(nothing, nothing)
    if lwr.head === :error || lwr.head === :incomplete
        throw(LoweringException(lwr))
    end
    if lwr.head !== :thunk
        mode === :sigs && return Pair{Any,Union{Nothing,Expr}}(nothing, nothing)
        return Pair{Any,Union{Nothing,Expr}}(Core.eval(mod, lwr), nothing)
    end
    # Interpret user code at the latest world (JuliaInterpreter dispatches it at `frame.world`),
    # so that even when Revise's own machinery is pinned to its frozen world (issue #552), new
    # definitions remain visible within the batch and to the running session.
    frame = Frame(mod, lwr.args[1]::CodeInfo; world=Base.get_world_counter())
    mode === :eval || LoweredCodeUtils.rename_framemethods!(interp, frame)
    # Determine whether we need interpreted mode
    isrequired, evalassign = minimal_evaluation!(frame, mode)
    # LoweredCodeUtils.print_with_code(stdout, frame.framecode.src, isrequired)
    if !any(isrequired) && (mode === :eval || !evalassign)
        # We can evaluate the entire expression in compiled mode
        if mode === :eval
            ret = try
                Core.eval(mod, ex)
            catch err
                (always_rethrow || isa(err, InterruptException)) && rethrow(err)
                loc = location_string(whereis(frame))
                bt = trim_toplevel!(catch_backtrace())
                throw(ReviseEvalException(loc, err, Any[(sf, 1) for sf in stacktrace(bt)]))
            end
        else
            ret = nothing
        end
    else
        # Use the interpreter
        local active_bp_refs
        if disablebp
            # We have to turn off all active breakpoints, https://github.com/timholy/CodeTracking.jl/issues/27
            bp_refs = JuliaInterpreter.BreakpointRef[]
            for bp in JuliaInterpreter.breakpoints()
                append!(bp_refs, bp.instances)
            end
            active_bp_refs = filter(bp->bp[].isactive, bp_refs)
            foreach(disable, active_bp_refs)
        end
        ret = try
            _methods_by_execution!(interp, exinfo, frame, isrequired; mode, kwargs...)
        catch err
            (always_rethrow || isa(err, InterruptException)) && (@isdefined(active_bp_refs) && foreach(enable, active_bp_refs); rethrow(err))
            loc = location_string(whereis(frame))
            sfs = []  # crafted for interaction with Base.show_backtrace
            frame = JuliaInterpreter.leaf(frame)
            while frame !== nothing
                push!(sfs, (Base.StackTraces.StackFrame(frame), 1))
                frame = frame.caller
            end
            throw(ReviseEvalException(loc, err, sfs))
        end
        if @isdefined active_bp_refs
            foreach(enable, active_bp_refs)
        end
    end
    return Pair{Any,Union{Nothing,Expr}}(ret, lwr)
end
methods_by_execution!(exinfo::ExInfo, mod::Module, ex::Expr; kwargs...) =
    methods_by_execution!(Compiled(), exinfo, mod, ex; kwargs...)

function _methods_by_execution!(
        interp::Interpreter, exinfo::ExInfo, frame::Frame, isrequired::AbstractVector{Bool};
        mode::Symbol = :eval, skip_include::Bool = true
    )
    isok(lnn::LineTypes) = !iszero(lnn.line) || lnn.file !== :none   # might fail either one, but accept anything

    mod = moduleof(frame)
    # Hoist this lookup for performance. Don't throw even when `mod` is a baremodule.
    # Read at the latest world: when `frame` defines a new submodule, that module's
    # `include` is a `const` created in a newer world than this frame runs in, and a
    # plain access would be a backdated-const read (warning now, error in future Julia).
    modinclude = @invokelatest(isdefinedglobal(mod, :include)) ? @invokelatest(getglobal(mod, :include)) : nothing
    signatures = MethodInfoKey[]  # temporary for method signature storage
    pc = frame.pc
    while true
        JuliaInterpreter.is_leaf(frame) || (@warn("not a leaf"); break)
        stmt = pc_expr(frame, pc)
        if !isrequired[pc] && mode !== :eval && !(mode === :evalassign && LoweredCodeUtils.get_lhs_rhs(stmt) !== nothing)
            if isa(stmt, Core.ReturnNode)
                # Follow control flow: a `return` terminates this frame. Walking past it
                # would march into a statically-untaken branch of an `if`/`else` and try
                # to resolve names that may not exist (issue #954).
                break
            end
            pc = next_or_nothing!(frame)
            pc === nothing && break
            continue
        end
        if isa(stmt, Expr)
            head = stmt.head
            if head === :toplevel
                local value
                for ex in stmt.args
                    ex isa Expr || continue
                    value, _ = methods_by_execution!(interp, exinfo, mod, ex; mode, disablebp=false, skip_include)
                end
                isassign(frame, pc) && @isdefined(value) && assign_this!(frame, value)
                pc = next_or_nothing!(frame)
            elseif head === :thunk && defines_function(only(stmt.args))
                mode !== :sigs && Core.eval(mod, stmt)
                pc = next_or_nothing!(frame)
            # elseif head === :thunk && isanonymous_typedef(stmt.args[1])
            #     # Anonymous functions should just be defined anew, since there does not seem to be a practical
            #     # way to find them within the already-defined module.
            #     # They may be needed to define later signatures.
            #     # Note that named inner methods don't require special treatment.
            #     pc = step_expr!(interp, frame, stmt, true)
            elseif is_methoddef(stmt)
                empty!(signatures)
                ret = methoddef!(interp, signatures, frame, stmt, pc; define=mode!==:sigs)
                if ret === nothing
                    # This was just `function foo end` or similar.
                    # However, it might have been followed by a thunk that defined a
                    # method (issue #435), so we still need to check for additions.
                    if !isempty(signatures)
                        loc = whereis(frame.framecode, pc)
                        if loc !== nothing
                            file, line = loc
                            lnn = LineNumberNode(Int(line), Symbol(file))
                            for sig in signatures
                                add_signature!(exinfo, sig, lnn)
                            end
                        end
                    end
                    @assert is_methoddef1(stmt)
                    pc = mode !== :sigs ? step_expr!(interp, frame, stmt, true) :
                        next_or_nothing!(frame)
                else
                    pc, pc3 = ret
                    # Get the line number from the body
                    stmt3 = pc_expr(frame, pc3)::Expr
                    if is_define_method_call_4arg(stmt3)
                        # define_method(mod, name, sigdata, body): sigdata = svec(types, sparams, lnn)
                        sigcode = lookup(interp, frame, stmt3.args[4])::Core.SimpleVector
                    else
                        sigcode = lookup(interp, frame, stmt3.args[2])::Core.SimpleVector
                    end
                    lnn = sigcode[end]
                    if !isa(lnn, LineNumberNode)
                        lnn = nothing
                    end
                    if lnn === nothing
                        bodycode = stmt3.args[end]
                        if !isa(bodycode, CodeInfo)
                            bodycode = lookup(interp, frame, bodycode)
                        end
                        if isa(bodycode, CodeInfo)
                            lnn = linetable(bodycode, 1)
                            if !isok(lnn)
                                lnn = nothing
                                if length(bodycode.code) > 1
                                    # This may be a kwarg method. Mimic LoweredCodeUtils.bodymethod,
                                    # except without having a method
                                    stmt = bodycode.code[end-1]
                                    if isa(stmt, Expr) && length(stmt.args) > 1
                                        stmt = stmt::Expr
                                        a = stmt.args[1]
                                        nargs = length(stmt.args)
                                        hasself = let stmt = stmt, slotnames::Vector{Symbol} = bodycode.slotnames
                                            any(i->LoweredCodeUtils.is_self_call(stmt, slotnames, i), 2:nargs)
                                        end
                                        if isa(a, Core.SlotNumber)
                                            a = bodycode.slotnames[a.id]
                                        end
                                        if hasself && (isa(a, Symbol) || isa(a, GlobalRef))
                                            thismod, thisname = isa(a, Symbol) ? (mod, a) : (a.mod, a.name)
                                            if isdefined(thismod, thisname)
                                                f = getfield(thismod, thisname)
                                                mths = methods(f)
                                                if length(mths) == 1
                                                    mth = first(mths)
                                                    lnn = LineNumberNode(Int(mth.line), mth.file)
                                                end
                                            end
                                        end
                                    end
                                end
                                if lnn === nothing
                                    # Just try to find *any* line number
                                    for lnntmp in linetable(bodycode)
                                        lnntmp = lnntmp::LineTypes
                                        if isok(lnntmp)
                                            lnn = lnntmp
                                            break
                                        end
                                    end
                                end
                            end
                        elseif isexpr(bodycode, :lambda)
                            bodycode = bodycode::Expr
                            lnntmp = bodycode.args[end][1]::LineTypes
                            if isok(lnntmp)
                                lnn = lnntmp
                            end
                        end
                    end
                    if lnn === nothing
                        i = codelocs(frame, pc3)
                        while i > 0
                            lnntmp = linetable(frame, i)
                            if isok(lnntmp)
                                lnn = lnntmp
                                break
                            end
                            i -= 1
                        end
                    end
                    if lnn !== nothing && isok(lnn)
                        for sig in signatures
                            add_signature!(exinfo, sig, lnn)
                        end
                    end
                end
            elseif LoweredCodeUtils.get_lhs_rhs(stmt) !== nothing
                if mode === :sigs && stmt.head === :const && (a = stmt.args[1]) isa GlobalRef && @invokelatest(isdefined(mod, a.name))
                    # avoid redefining types unless we have to
                    pc = next_or_nothing!(frame)
                else
                    # If the RHS is a call, unwrap it and dispatch to the call handler
                    callstmt = LoweredCodeUtils.getrhs(stmt)
                    if isa(callstmt, Expr) && callstmt.head === :call
                        @goto call_dispatch
                    end
                    pc = step_expr!(interp, frame, stmt, true)
                end
            elseif head === :call
                callstmt = stmt
                @label call_dispatch
                f = lookup(frame, callstmt.args[1])
                if @static(isdefined(Core, :resolve_typegroup) ? true : false) && f === Core.resolve_typegroup
                    # The statement that creates the type(s) of a struct definition or
                    # `typegroup` block. In `:sigs` mode, when every type in the group is
                    # already defined (e.g., by package loading), reuse the existing types
                    # rather than re-creating them; the lowered `olds` argument holds
                    # exactly the currently-bound types. Like `reuse_existing_type!`, no
                    # structural equivalence check is performed. The subsequent
                    # `declare_const` calls are skipped by `skip_declare_const`.
                    pc0 = pc
                    local groupresult
                    if mode === :sigs && (existing = existing_typegroup_types(interp, frame, callstmt)) !== nothing
                        groupresult = existing
                        assign_this!(frame, existing)
                        pc = next_or_nothing!(frame)
                    else
                        pc = step_expr!(interp, frame, stmt, true)
                        # (guarded: an assignment form would store to the slot instead)
                        groupresult = isassigned(frame.framedata.ssavalues, pc0) ?
                            frame.framedata.ssavalues[pc0] : nothing
                    end
                    if __bpart__[]
                        analyze_typegroup_result!(exinfo, groupresult)
                    end
                elseif @static(isdefined(Core, :_typebody!) ? true : false) && f === Core._typebody!
                    if __bpart__[]
                        analyze_typebody!(exinfo, interp, frame, callstmt)
                    end
                    if mode === :sigs && length(callstmt.args) >= 4 && reuse_existing_type!(interp, frame, callstmt)
                        # The type is already defined (e.g., by package loading).
                        # In :sigs mode we just want to extract signatures, so don't
                        # execute `_typebody!` — that would rebind the type and clear
                        # methods that aren't redefined here (e.g., outer constructors
                        # whose `:method` statements are skipped because `define=false`).
                        pc = next_or_nothing!(frame)
                    else
                        pc = step_expr!(interp, frame, stmt, true)
                    end
                elseif mode === :sigs && @static(isdefined(Core, :declare_const) ? true : false) && f === Core.declare_const &&
                       length(callstmt.args) >= 3 && skip_declare_const(interp, frame, callstmt)
                    # The corresponding `_typebody!` was skipped above; skip the matching
                    # `declare_const` to avoid creating a new binding partition for an
                    # already-defined type.
                    pc = next_or_nothing!(frame)
                elseif is_defaultctors(f) && length(callstmt.args) == 3
                    # Create the constructors for a type (i.e., a method definition)
                    T = lookup(frame, callstmt.args[2])
                    lnn = lookup(frame, callstmt.args[3])
                    if T isa Type && lnn isa LineNumberNode
                        empty!(signatures)
                        uT = Base.unwrap_unionall(T)::DataType
                        ft = uT.types
                        sig1 = Tuple{Base.rewrap_unionall(Type{uT}, T), Any[Any for _ in 1:length(ft)]...}
                        push!(signatures, MethodInfoKey(nothing, sig1))
                        sig2 = Base.rewrap_unionall(Tuple{Type{T}, ft...}, T)
                        while T isa UnionAll
                            sig2 isa UnionAll || (sig2 = sig1; break) # sig2 doesn't define all parameters, so drop it
                            T = T.body
                        end
                        sig1 == sig2 || push!(signatures, MethodInfoKey(nothing, sig2))
                        for sig in signatures
                            add_signature!(exinfo, sig, lnn)
                        end
                    end
                    if mode === :sigs
                        pc = next_or_nothing!(frame)
                    else # also execute this call
                        pc = step_expr!(interp, frame, stmt, true)
                    end
                elseif f === Core.eval
                    # an @eval or eval block: this may contain method definitions, so intercept it.
                    evalmod = lookup(interp, frame, callstmt.args[2])::Module
                    evalex = lookup(interp, frame, callstmt.args[3])
                    local value = nothing
                    for (newmod, newex) in ExprSplitter(evalmod, evalex)
                        if is_doc_expr(newex)
                            newex = newex.args[4]
                        end
                        newex = unwrap(newex)
                        push!(exinfo.exprstack, newex)
                        value, _ = methods_by_execution!(interp, exinfo, newmod, newex; mode, skip_include, disablebp=false)
                        pop!(exinfo.exprstack)
                    end
                    assign_this!(frame, value)
                    pc = next_or_nothing!(frame)
                elseif skip_include && (f === modinclude || f === Core.include || f === Base.include)
                    # include calls need to be managed carefully from several standpoints, including
                    # path management and parsing new expressions
                    handle_include!(exinfo, interp, frame, callstmt)
                    assign_this!(frame, nothing)  # FIXME: the file might return something different from `nothing`
                    pc = next_or_nothing!(frame)
                elseif f === Base.Docs.doc! # && mode !== :eval
                    fargs = JuliaInterpreter.collect_args(interp, frame, callstmt)
                    popfirst!(fargs)
                    length(fargs) == 3 && push!(fargs, Union{})  # add the default sig
                    dmod::Module, b::Base.Docs.Binding, str::Base.Docs.DocStr, sig = fargs
                    if @invokelatest(isdefinedglobal(b.mod, b.var))
                        tmpvar = @invokelatest(getglobal(b.mod, b.var))
                        if isa(tmpvar, Module)
                            dmod = tmpvar
                        end
                    end
                    # Workaround for julia#38819 on older Julia versions
                    if !isdefined(dmod, Base.Docs.META)
                        Base.Docs.initmeta(dmod)
                    end
                    m = get!(Base.Docs.meta(dmod), b, Base.Docs.MultiDoc())::Base.Docs.MultiDoc
                    if haskey(m.docs, sig)
                        currentstr = m.docs[sig]::Base.Docs.DocStr
                        redefine = currentstr.text != str.text
                    else
                        push!(m.order, sig)
                        redefine = true
                    end
                    # (Re)assign without the warning
                    if redefine
                        m.docs[sig] = str
                        str.data[:binding] = b
                        str.data[:typesig] = sig
                    end
                    assign_this!(frame, Base.Docs.doc(b, sig))
                    pc = next_or_nothing!(frame)
                else
                    # A :call Expr we don't want to intercept
                    pc = step_expr!(interp, frame, stmt, true)
                end
            else
                # An Expr we don't want to intercept
                frame.pc = pc
                pc = step_expr!(interp, frame, stmt, true)
            end
        else
            # A statement we don't want to intercept
            pc = step_expr!(interp, frame, stmt, true)
        end
        pc === nothing && break
    end
    return isrequired[frame.pc] ? get_return(frame) : nothing
end

function add_signature!(exinfo::ExInfo, mt_sig::MethodInfoKey, ln::LineNumberNode)
    locdefs = CodeTracking.invoked_get!(Vector{Tuple{LineNumberNode,Expr}}, CodeTracking.method_info, mt_sig)
    newdef = unwrap(exinfo.exprstack[end])
    if newdef !== nothing
        if !any(locdef->locdef[1] == ln && isequal(RelocatableExpr(locdef[2]), RelocatableExpr(newdef)), locdefs)
            push!(locdefs, (fixpath(ln), newdef))
        end
        push!(exinfo.allsigs, SigInfo(mt_sig))
    end
    return exinfo
end

# The path may be a custom AbstractString from interpreted user code (e.g.
# RelocatableFolders.Path) whose methods are newer than Revise's frozen world;
# convert at the latest world.
include_filename(path::String) = path
include_filename(path::AbstractString) = (@invokelatest String(path))::String

function handle_include!(exinfo::ExInfo, interp::Interpreter, frame::Frame, stmt::Expr)
    if length(stmt.args) == 2
        # include(path)
        local arg2 = lookup(interp, frame, stmt.args[2])
        if arg2 isa AbstractString
            push!(exinfo.includes, (moduleof(frame), identity, include_filename(arg2)))
            return exinfo
        end
    elseif length(stmt.args) == 3
        # include(mod, path) or include(mapexpr, path)
        local arg2 = lookup(interp, frame, stmt.args[2])
        local arg3 = lookup(interp, frame, stmt.args[3])
        if arg3 isa AbstractString
            if arg2 isa Module
                push!(exinfo.includes, (arg2, identity, include_filename(arg3)))
                return exinfo
            elseif arg2 isa Function
                push!(exinfo.includes, (moduleof(frame), arg2, include_filename(arg3)))
                return exinfo
            end
        end
    elseif length(stmt.args) == 4
        # include(mapexpr, mod, path)
        local arg2 = lookup(interp, frame, stmt.args[2])
        local arg3 = lookup(interp, frame, stmt.args[3])
        local arg4 = lookup(interp, frame, stmt.args[4])
        if arg2 isa Function && arg3 isa Module && arg4 isa AbstractString
            push!(exinfo.includes, (arg3, arg2, include_filename(arg4)))
            return exinfo
        end
    end
    error("Bad include call")
end

# `_typebody!` comes in two protocols: the older struct protocol
# `_typebody!(prev, partial[, fieldtypes])`, where `prev` is `false` or the
# existing type, and the typegroup-era `_typebody!(partial[, fieldtypes])`
# (emitted at top level only for abstract and primitive type definitions).
# Identify the partial type structurally so both lowerings are handled: in the
# newer protocol the first argument is the type, followed by nothing or the
# field-type `SimpleVector`; in the older one the type sits in second position.
function typebody_partial(interp::Interpreter, frame::Frame, callstmt::Expr)
    length(callstmt.args) >= 2 || return nothing
    arg2 = lookup(interp, frame, callstmt.args[2])
    if arg2 isa Type &&
            (length(callstmt.args) == 2 || lookup(interp, frame, callstmt.args[3]) isa Core.SimpleVector)
        return arg2
    end
    length(callstmt.args) >= 3 || return nothing
    arg3 = lookup(interp, frame, callstmt.args[3])
    return arg3 isa Type ? arg3 : nothing
end

function analyze_typebody!(exinfo::ExInfo, interp::Interpreter, frame::Frame, stmt::Expr)
    typ = typebody_partial(interp, frame, stmt)
    typ === nothing && return nothing
    datatype = Base.unwrap_unionall(typ)::DataType
    push!(exinfo.typeinfos, TypeInfo(datatype.name))
    return exinfo
end

# For `resolve_typegroup(mod, typevars, infos, olds)` in `:sigs` mode: return a
# tuple of the already-existing types for this group (to be assigned as the
# statement's result in place of executing it), or `nothing` if any group member
# is not currently defined.
function existing_typegroup_types(interp::Interpreter, frame::Frame, callstmt::Expr)
    length(callstmt.args) >= 5 || return nothing
    olds = lookup(interp, frame, callstmt.args[5])
    olds isa Core.SimpleVector || return nothing
    isempty(olds) && return nothing
    all(o -> o isa Type, olds) || return nothing
    return (olds...,)
end

# Record a `TypeInfo` for each type created (or reused) by a `resolve_typegroup`
# statement, whose result is the tuple of group types.
function analyze_typegroup_result!(exinfo::ExInfo, @nospecialize(result))
    result isa Tuple || return nothing
    for typ in result
        typ isa Type || continue
        push!(exinfo.typeinfos, TypeInfo((Base.unwrap_unionall(typ)::DataType).name))
    end
    return exinfo
end

# Look up the existing type that this `_typebody!` call would (re)define. If found,
# assign it as the result of the SSA statement and return `true`; otherwise return
# `false` so the caller falls back to executing the call normally.
#
# Only call this from `mode=:sigs`, which assumes the in-memory bindings already
# match the source (the same assumption that lets `:sigs` skip `:method` statements
# via `define=false`). No structural equivalence check is performed: on Julia 1.12+
# `_equiv_typedef` is exactly what we're trying to avoid tripping, so a comparison
# here would defeat the purpose. Genuine struct edits arrive through `revise()` in
# `:eval`/`:evalmeth` mode, which does not take this path.
#
# `_typebody!(arg2, new_partial, fieldtypes_svec [, ...])` where `new_partial` is a
# fresh `DataType` constructed by `_structtype`; its `.name.module/.name.name` give
# the destination binding.
function reuse_existing_type!(interp::Interpreter, frame::Frame, stmt::Expr)
    new_partial = lookup(interp, frame, stmt.args[3])
    new_partial isa DataType || return false
    tn = new_partial.name
    mod = tn.module
    name = tn.name
    @invokelatest(isdefined(mod, name)) || return false
    existing = @invokelatest getfield(mod, name)
    existing isa Type || return false
    assign_this!(frame, existing)
    return true
end

# Return `true` if the destination of `Core.declare_const(mod, :name, value)` is
# already defined; if so, the caller will skip the call. This pairs with
# `reuse_existing_type!` to avoid generating a new binding partition for a struct
# whose definition we just skipped.
function skip_declare_const(interp::Interpreter, frame::Frame, stmt::Expr)
    mod_arg = lookup(interp, frame, stmt.args[2])
    mod_arg isa Module || return false
    name_arg = stmt.args[3]
    name = name_arg isa QuoteNode ? name_arg.value : name_arg
    name isa Symbol || return false
    return @invokelatest isdefined(mod_arg, name)
end

## Prediction of type preservation (issue #1022)
#
# Before deletions are applied, `revise` asks whether the new source re-creates
# each old type unchanged. If so, the subtype-tree walk in
# `handle_type_deletion!` is unnecessary. Problems arise from `struct`
# definitions like those in #1022, which disguise the fact that the type is
# unchanged and only surrounding code is changed. We fix this with a two-phase
# evaluation: first, a limited evaluation that reconstructs (from the lowered
# code) the *proposed* new type (henceforth called the "prediction"). This
# prediction is compared for type-equivalence against the existing type; if they
# are equivalent, type-deletion is skipped. Constructing the prediction builds
# only throwaway objects and never publishes a binding; the point is to determine
# whether the deletion is necessary, and if not we can trust the ordinary
# mechanisms to do the right thing.
#
# The prediction interprets only the lowered statements that feed
# `Core._typebody!` calls, plus `eval` calls (whose contents may define types
# via metaprogramming). This is implemented by mimicking the larger pipeline
# above: a new set of `isrequired` rules plus a focused line-stepper.

# Resolve the callee of `stmt` (or of the call it wraps as the RHS of an
# assignment), following SSA chains; `nothing` if `stmt` is not a call.
function typedef_callee(@nospecialize(stmt), code::Vector{Any})
    isa(stmt, Expr) || return nothing
    callstmt = stmt
    if callstmt.head !== :call
        LoweredCodeUtils.get_lhs_rhs(callstmt) === nothing && return nothing
        rhs = LoweredCodeUtils.getrhs(callstmt)
        isa(rhs, Expr) && rhs.head === :call || return nothing
        callstmt = rhs
    end
    isempty(callstmt.args) && return nothing
    callee = callstmt.args[1]
    while isa(callee, Core.SSAValue) || isa(callee, JuliaInterpreter.SSAValue)
        callee = code[callee.id]
    end
    return callee
end

# `true` when `stmt` is (or wraps, as the RHS of an assignment) a call to
# `Core._typebody!`, following SSA chains to resolve the callee.
function is_typebody_stmt(@nospecialize(stmt), code::Vector{Any})
    callee = typedef_callee(stmt, code)
    callee === nothing && return false
    if isa(callee, GlobalRef)
        return callee.mod === Core && callee.name === :_typebody!
    end
    isa(callee, QuoteNode) && (callee = callee.value)
    return @static(isdefined(Core, :_typebody!) ? true : false) && callee === Core._typebody!
end

# `true` when `stmt` is (or wraps) a call to `Core.resolve_typegroup`, the
# statement that creates the types of a struct definition or `typegroup` block.
function is_resolve_typegroup_stmt(@nospecialize(stmt), code::Vector{Any})
    callee = typedef_callee(stmt, code)
    callee === nothing && return false
    if isa(callee, GlobalRef)
        return callee.mod === Core && callee.name === :resolve_typegroup
    end
    isa(callee, QuoteNode) && (callee = callee.value)
    return @static(isdefined(Core, :resolve_typegroup) ? true : false) && callee === Core.resolve_typegroup
end

# Statement filter for the prediction pass: only type-defining calls
# (`_typebody!`/`resolve_typegroup`), `eval` calls, and `:toplevel` blocks (and,
# via `lines_required!`, their dependencies) run.
function predict_predicate(@nospecialize(stmt), code::Vector{Any})
    isa(stmt, Expr) || return (false, false)
    haseval = matches_eval(stmt)
    isreq = haseval | (stmt.head === :toplevel) | is_typebody_stmt(stmt, code) |
            is_resolve_typegroup_stmt(stmt, code)
    return (isreq, haseval)
end

# Execute `Core._typebody!` — its effects are confined to the throwaway partial type
# created earlier in the frame — and record in `predictions` whether evaluating this
# definition will preserve the existing binding. Returns the value to assign to the
# statement's SSA slot.
#
# Both `_typebody!` protocols are handled (see `typebody_partial`). The
# preservation test depends on the form: the older struct protocol passes a `prev`
# argument (the existing type if `Core._equiv_typedef` judged the headers
# equivalent, `false` otherwise) along with the field types, and
# `_typebody!(prev, partial, ftypes)` returns `prev` exactly when evaluation would
# reuse the existing type — so `result === existing` is the complete test. In every
# other form (abstract and primitive types on either protocol), the lowering gates
# the `const` on `Core._equiv_typedef`, so calling that directly replicates the
# test evaluation would perform.
function record_typebody_prediction!(predictions::TypePredictions, interp::Interpreter, frame::Frame, callstmt::Expr)
    partial = typebody_partial(interp, frame, callstmt)
    partial isa Type || error("unexpected _typebody! call ", callstmt)
    tn = (Base.unwrap_unionall(partial)::DataType).name
    existing = @invokelatest(isdefinedglobal(tn.module, tn.name)) ?
               @invokelatest(getglobal(tn.module, tn.name)) : nothing
    fargs = Any[lookup(interp, frame, a) for a in callstmt.args[2:end]]
    result = Core._typebody!(fargs...)
    oldstructform = length(fargs) >= 3 && partial === fargs[2]
    preserved = if oldstructform
        existing isa Type && result === existing
    else
        existing isa Type &&
            @static(isdefined(Core, :_equiv_typedef) ? true : false) &&
            Core._equiv_typedef(existing, partial)
    end
    predictions.preserved[(tn.module, tn.name)] = preserved
    return result
end

# Execute `Core.resolve_typegroup` — it creates the group's types (or, per its
# internal equivalence check, returns the existing ones) without publishing any
# binding — and record for each group member whether evaluation would preserve
# the existing binding: `resolve_typegroup` returns the existing type object
# exactly when the new definition is equivalent to it. Returns the value to
# assign to the statement's SSA slot.
function record_typegroup_prediction!(predictions::TypePredictions, interp::Interpreter, frame::Frame, callstmt::Expr)
    mod = lookup(interp, frame, callstmt.args[2])::Module
    typevars = lookup(interp, frame, callstmt.args[3])::Core.SimpleVector
    infos = lookup(interp, frame, callstmt.args[4])::Core.SimpleVector
    olds = lookup(interp, frame, callstmt.args[5])::Core.SimpleVector
    result = Core.resolve_typegroup(mod, typevars, infos, olds)
    for (i, tv) in enumerate(typevars)
        old = olds[i]
        preserved = old isa Type && result[i] === old
        predictions.preserved[(mod, (tv::TypeVar).name)] = preserved
    end
    return result
end

# Record a prediction for every type `ex` would define, without publishing any
# binding or defining any method. Throws on lowering or execution failure; the
# caller treats a throw as "no prediction", leaving the pessimistic deletion path
# in force (correct, just unoptimized).
function predict_typebodies!(predictions::TypePredictions, mod::Module, ex::Expr)
    # The walk requires the Julia 1.12+ struct-lowering protocol, in which the
    # type-defining statement (`_typebody!` with a `prev` argument, or
    # `resolve_typegroup` on typegroup-based versions) builds only throwaway
    # objects and the binding is published only by a subsequent
    # `const`/`declare_const`. Older lowering binds the type through statements
    # this walk executes, so prediction would not be non-destructive there;
    # report "no prediction" instead.
    @static VERSION >= v"1.12.0-DEV.2047" || return predictions
    lwr = Meta.lower(mod, ex)
    isa(lwr, Expr) || return predictions
    if lwr.head === :error || lwr.head === :incomplete
        throw(LoweringException(lwr))
    end
    lwr.head === :thunk || return predictions
    src = lwr.args[1]::CodeInfo
    any(stmt -> predict_predicate(stmt, src.code)[1], src.code) || return predictions
    frame = Frame(mod, src; world=Base.get_world_counter())
    isrequired, _ = minimal_evaluation!(predict_predicate, frame, :sigs)
    interp = Compiled()
    pc = frame.pc
    while true
        stmt = pc_expr(frame, pc)
        if !isrequired[pc]
            pc = next_or_nothing!(frame)
        elseif isa(stmt, Expr)
            head = stmt.head
            if head === :const || head === :method || head === :thunk
                # `:const` would publish a binding; `:method`/`:thunk` would define
                # methods ahead of the deletion phase. None of these feed a
                # `_typebody!` call, so skipping is safe; if one is nevertheless a
                # dependency, evaluation fails and the caller falls back to the
                # pessimistic path.
                pc = next_or_nothing!(frame)
            elseif head === :toplevel
                for a in stmt.args
                    a isa Expr || continue
                    predict_typebodies!(predictions, mod, a)
                end
                assign_this!(frame, nothing)
                pc = next_or_nothing!(frame)
            else
                callstmt = stmt
                if head !== :call
                    rhs = LoweredCodeUtils.get_lhs_rhs(stmt) === nothing ? nothing :
                          LoweredCodeUtils.getrhs(stmt)
                    callstmt = isa(rhs, Expr) && rhs.head === :call ? rhs : nothing
                end
                if callstmt === nothing
                    pc = step_expr!(interp, frame, stmt, true)
                else
                    f = lookup(frame, callstmt.args[1])
                    if @static(isdefined(Core, :resolve_typegroup) ? true : false) && f === Core.resolve_typegroup && length(callstmt.args) >= 5
                        assign_this!(frame, record_typegroup_prediction!(predictions, interp, frame, callstmt))
                        pc = next_or_nothing!(frame)
                    elseif @static(isdefined(Core, :_typebody!) ? true : false) && f === Core._typebody! &&
                           length(callstmt.args) >= 2
                        assign_this!(frame, record_typebody_prediction!(predictions, interp, frame, callstmt))
                        pc = next_or_nothing!(frame)
                    elseif @static(isdefined(Core, :declare_const) ? true : false) && f === Core.declare_const
                        pc = next_or_nothing!(frame)
                    elseif f === Core.eval
                        evalmod = lookup(interp, frame, callstmt.args[2])
                        evalex = lookup(interp, frame, callstmt.args[3])
                        if evalmod isa Module && evalex isa Expr
                            for (newmod, newex) in ExprSplitter(evalmod, evalex)
                                if is_doc_expr(newex)
                                    newex = newex.args[4]
                                end
                                newex = unwrap(newex)
                                newex isa Expr && predict_typebodies!(predictions, newmod, newex)
                            end
                        end
                        assign_this!(frame, nothing)
                        pc = next_or_nothing!(frame)
                    else
                        pc = step_expr!(interp, frame, stmt, true)
                    end
                end
            end
        else
            pc = step_expr!(interp, frame, stmt, true)
        end
        pc === nothing && break
    end
    return predictions
end

module CalleeError

inner(A, i) = A[i]
function outer(A)
    s = zero(eltype(A))
    for i = 1:length(A)+1
        s += inner(A, i)
    end
    return s
end

s = outer([1,2,3])

foo(x::Float32) = 1

end

module DistributedExt

import Distributed: myid, workers, remotecall

import Revise
import Revise: DistributedWorker


function get_workers()
    map(DistributedWorker, workers())
end

function Revise.remotecall_impl(f, worker::DistributedWorker, args...; kwargs...)
    remotecall(f, worker.id, args...; kwargs...)
end

Revise.is_master_worker(::typeof(get_workers)) = myid() == 1
Revise.is_master_worker(worker::DistributedWorker) = worker.id == 1

function __init__()
    Revise.register_workers_function(get_workers)
end

end

# We will need to detect new function bodies, compare function bodies
# to see if they've changed, etc.  This has to be done "blind" to the
# line numbers at which the functions are defined.
#
# Now, we could just discard line numbers from expressions, but that
# would have a very negative effect on the quality of backtraces. So
# we keep them, but introduce machinery to compare expressions without
# concern for line numbers.

"""
A `RelocatableExpr` wraps an `Expr` to ensure that comparisons
between `RelocatableExpr`s ignore line numbering information.
This allows one to detect that two expressions are the same no matter
where they appear in a file.
"""
struct RelocatableExpr
    ex::Expr
end

const ExLike = Union{Expr,RelocatableExpr}

Base.convert(::Type{Expr}, rex::RelocatableExpr) = rex.ex
Base.convert(::Type{RelocatableExpr}, ex::Expr) = RelocatableExpr(ex)
# Expr(rex::RelocatableExpr) = rex.ex   # too costly (inference invalidation)

Base.copy(rex::RelocatableExpr) = RelocatableExpr(copy(rex.ex))

# Implement the required comparison functions. `hash` is needed for Dicts.
function Base.:(==)(ra::RelocatableExpr, rb::RelocatableExpr)
    a, b = ra.ex, rb.ex
    if a.head == b.head
    elseif a.head === :block
        a = unwrap(a)
    elseif b.head === :block
        b = unwrap(b)
    end
    return a.head == b.head && isequal(LineSkippingIterator(a.args), LineSkippingIterator(b.args))
end

const hashrex_seed = UInt == UInt64 ? 0x7c4568b6e99c82d9 : 0xb9c82fd8
Base.hash(x::RelocatableExpr, h::UInt) = hash(LineSkippingIterator(x.ex.args),
                                              hash(x.ex.head, h + hashrex_seed))

function Base.show(io::IO, rex::RelocatableExpr)
    show(io, striplines!(copy(rex.ex)))
end

function striplines!(ex::Expr)
    if ex.head === :macrocall
        # for macros, the show method in Base assumes the line number is there,
        # so don't strip it
        args3 = [a isa ExLike ? striplines!(a) : a for a in ex.args[3:end]]
        return Expr(ex.head, ex.args[1], nothing, args3...)
    end
    args = [a isa ExLike ? striplines!(a) : a for a in ex.args]
    fargs = collect(LineSkippingIterator(args))
    return Expr(ex.head, fargs...)
end
striplines!(rex::RelocatableExpr) = RelocatableExpr(striplines!(rex.ex))

# We could just collect all the non-line statements to a Vector, but
# doing things in-place will be more efficient.

struct LineSkippingIterator
    args::Vector{Any}
end

Base.IteratorSize(::Type{LineSkippingIterator}) = Base.SizeUnknown()

function Base.iterate(iter::LineSkippingIterator, i=0)
    i = skip_to_nonline(iter.args, i+1)
    i > length(iter.args) && return nothing
    return (iter.args[i], i)
end

function skip_to_nonline(args::Vector{Any}, i::Int)
    while true
        i > length(args) && return i
        ex = args[i]
        if isa(ex, Expr) && ex.head === :line
            i += 1
        elseif isa(ex, LineNumberNode)
            i += 1
        elseif isa(ex, Pair) && (ex::Pair).first === :linenumber     # used in the doc system
            i += 1
        elseif isa(ex, Base.RefValue) && !isdefined(ex, :x)          # also in the doc system
            i += 1
        else
            return i
        end
    end
end

# Gensym counters do not reproduce across runs of macro expansion or lowering,
# so two structurally identical expressions can differ in the numeric part of
# generated names. Comparison and hashing therefore ignore the counters — but
# only the counters: the base name must match exactly, and the pairing between
# generated names must be consistent across the whole expression (wherever one
# expression repeats a generated name, the other must repeat the corresponding
# name). `'#'`-prefixed names without a counter (`var"#self#"`, a user's
# var"#x") are reproducible and compare exactly, like any other symbol; this
# keeps distinct global bindings distinct as `ExprsInfos` keys.

const anonymous_gensym_rex = r"^#+(\d+)$"        # gensym(): "##277"
const suffixed_gensym_rex  = r"^#+(.*)#(\d+)$"   # gensym(:name): "##name#123"; closures: "#f#42"; anonymous closures: "#1#2"
const hygiene_gensym_rex   = r"^#(?:\d+#)+(.+)$" # macro hygiene: "#28#t0"

"""
    base, iscounter = gensym_base(str)

Classify a `'#'`-prefixed variable name. If `str` contains a gensym counter
(`"##name#123"`, `"#f#42"`, `"#28#t0"`, `"##277"`, `"#1#2"`), return the
non-counter part of the name and `iscounter = true`; names that are purely
counters return `base = ""`. Otherwise (`"#self#"`, `"#x"`, ...) the name is
reproducible: return it unmodified, with `iscounter = false`.
"""
function gensym_base(str::AbstractString)
    m = match(anonymous_gensym_rex, str)
    m !== nothing && return "", true
    m = match(suffixed_gensym_rex, str)
    if m !== nothing
        base = m.captures[1]::AbstractString
        return (all(isdigit, base) ? "" : String(base)), true
    end
    m = match(hygiene_gensym_rex, str)
    m !== nothing && return String(m.captures[1]::AbstractString), true
    return String(str), false
end

# Correspondence between the counter-bearing generated names of two expressions
# under comparison. Consistency requires a bijection, so both directions are tracked.
struct GensymPairing
    fwd::Dict{Symbol,Symbol}
    rev::Dict{Symbol,Symbol}
end
GensymPairing() = GensymPairing(Dict{Symbol,Symbol}(), Dict{Symbol,Symbol}())

function isequal_sym(pairing::GensymPairing, a::Symbol, b::Symbol)
    sa, sb = String(a), String(b)
    if startswith(sa, '#') && startswith(sb, '#')
        basea, countera = gensym_base(sa)
        baseb, counterb = gensym_base(sb)
        countera == counterb || return false
        countera || return a === b
        basea == baseb || return false
        # the same pairing must hold at every occurrence, even when a === b
        return get!(pairing.fwd, a, b) === b && get!(pairing.rev, b, a) === a
    end
    return a === b
end

function Base.isequal(itera::LineSkippingIterator, iterb::LineSkippingIterator)
    return isequal_lsi(GensymPairing(), itera, iterb)
end

function isequal_lsi(pairing::GensymPairing, itera::LineSkippingIterator, iterb::LineSkippingIterator)
    # We could use `zip` here except that we want to insist that the
    # iterators also have the same length.
    reta, retb = iterate(itera), iterate(iterb)
    while true
        reta === nothing && retb === nothing && return true
        (reta === nothing || retb === nothing) && return false
        vala, ia = reta::Tuple{Any,Int}
        valb, ib = retb::Tuple{Any,Int}
        if isa(vala, Expr) && isa(valb, Expr)
            vala, valb = vala::Expr, valb::Expr
            vala.head == valb.head || return false
            isequal_lsi(pairing, LineSkippingIterator(vala.args), LineSkippingIterator(valb.args)) || return false
        elseif isa(vala, Symbol) && isa(valb, Symbol)
            isequal_sym(pairing, vala::Symbol, valb::Symbol) || return false
        elseif isa(vala, Number) && isa(valb, Number)
            vala === valb || return false    # issue #233
        else
            isequal(vala, valb) || return false
        end
        reta, retb = iterate(itera, ia), iterate(iterb, ib)
    end
end

const hashlsi_seed = UInt === UInt64 ? 0x533cb920dedccdae : 0x2667c89b
function Base.hash(iter::LineSkippingIterator, h::UInt)
    return hash_lsi(Dict{Symbol,Int}(), iter, h)
end

function hash_lsi(gensym_indices::Dict{Symbol,Int}, iter::LineSkippingIterator, h::UInt)
    h += hashlsi_seed
    for x in iter
        if x isa Expr
            h += hash_lsi(gensym_indices, LineSkippingIterator(x.args), hash(x.head, h + hashrex_seed))
        elseif x isa Symbol
            xs = String(x)
            if startswith(xs, '#')
                base, iscounter = gensym_base(xs)
                if iscounter
                    # hash the base name and the order of first occurrence;
                    # this matches `isequal_sym`'s counter-insensitive pairing
                    idx = get!(gensym_indices, x, length(gensym_indices) + 1)
                    h += hash(base, hash(idx, h))
                    continue
                end
            end
            h += hash(x, h)
        elseif x isa Number
            h += hash(typeof(x), hash(x, h))::UInt
        else
            h += hash(x, h)::UInt
        end
    end
    h
end

using Random
using Base.Meta: isexpr

# Testsets will reset the default RNG after each testset to make
# tests more reproducible, but we need to be able to create new random
# directories (see julia #24445)
const RNG = copy(Random.default_rng())
const to_remove = String[]

randtmp() = joinpath(tempdir(), randstring(RNG, 10))

function newtestdir()
    testdir = randtmp()
    mkdir(testdir)
    push!(to_remove, testdir)
    push!(LOAD_PATH, testdir)
    return testdir
end

# Spacing between successive writes to a tracked file, so that the watcher sees
# each edit as distinct. A file named in a filesystem event is settled by a
# content hash when its ctime is unchanged (see `scan_changed_files`), so this
# only needs to clear the resolution of `mtime`-based change detection on the
# polling/non-notifying path, where ext4 timestamps are fine-grained.
const mtimedelay = 0.1

# The suite assumes a deleted tracked file is processed at the first revise():
# `yry()` waits on `revision_queue` becoming non-empty, and several testsets
# assert on captured logs — a deletion deferred by `missing_file_grace` would
# keep stray entries queued (making the wait vacuous) and emit its warning
# inside whichever later testset crosses the grace boundary. The deferral
# itself is exercised by the "Missing-file grace" testset, which sets its own
# values.
Revise.missing_file_grace[] = 0.0

# Upper bound on how long `yry()` will wait for the file-watcher task to push
# the expected change onto `revision_queue`. Only paid by yry() calls that
# produce no revision (rare), so a generous value protects against slow
# FSEvents delivery on macOS CI without significantly affecting wall time.
const event_timeout = 10.0

if isdefined(Core, :var"@latestworld")
    using Core: @latestworld
else
    # In older Julia versions, there were more implicit
    # world age increments, so the macro is generally not
    # required.
    macro latestworld()
        nothing
    end
end

# Wait for a pending file change to be revised:
#   * the pre-revise wait is event-driven (block until the background watcher
#     task populates `Revise.revision_queue`), with `event_timeout` as a
#     fall-through for tests that legitimately produce no revision.
#   * a short settling pause lets a *burst* of writes that the watcher delivers
#     across more than one wakeup land in the queue before we revise.
#   * under `watching_files[]` (per-file and polling watches) a trailing pause
#     lets the one-shot `watch_file` re-arm before the next test write. That
#     path re-watches a single file after each revision and, unlike the
#     buffered per-directory watcher, has neither an event queue nor a content
#     hash to recover a write that lands while it is between watches.
#
# `expect_revision=true` (the default) means a write should already have been
# queued: hitting `event_timeout` then signals a dropped/late filesystem event,
# the usual cause of "revision not applied" CI flakes, so we warn. Tests that
# legitimately expect no revision pass `expect_revision=false` to take the
# timeout silently.
function yry(; expect_revision::Bool=true)
    status = timedwait(() -> !isempty(Revise.revision_queue), event_timeout; pollint=0.02)
    if expect_revision && status === :timed_out
        @warn "yry: timed out after $(event_timeout)s waiting for revision_queue; a filesystem event was likely dropped or delayed"
    end
    sleep(0.02)
    revise()
    # Drain to quiescence. The watcher can deliver a just-written edit's event
    # *after* this first revise (notably under macOS FSEvents latency): the first
    # revise then drains some earlier/stale queue entry while the edit we are
    # waiting for is still in flight, so a single revise would leave it unapplied
    # until a later `yry`. Keep revising as long as each pass clears something,
    # absorbing such stragglers within this call. Two stop conditions keep this
    # bounded: skip entirely once a revision errors (an errored file stays queued
    # for retry, and re-revising it would re-log and perturb error-reporting
    # tests), and stop on any pass that makes no progress (a missing file within
    # `missing_file_grace` is re-queued each pass, so the queue need not empty).
    if expect_revision
        for _ in 1:50   # hard cap; the conditions below are the normal exits
            isempty(Revise.queue_errors) || break
            timedwait(() -> !isempty(Revise.revision_queue), mtimedelay; pollint=0.02) === :ok || break
            n = length(Revise.revision_queue)
            revise()
            length(Revise.revision_queue) < n || break
        end
    end
    Revise.watching_files[] && sleep(mtimedelay)
end
macro yry(args...)
    # Forward `@yry(expect_revision=false)` as a keyword argument, not a positional one.
    kws = [a isa Expr && a.head === :(=) ? Expr(:kw, a.args[1], a.args[2]) : a for a in args]
    esc(quote
        yry($(kws...))
        @latestworld
    end)
end

function collectexprs(rex::Revise.RelocatableExpr)
    items = []
    for item in Revise.LineSkippingIterator(rex.ex.args)
        push!(items, isa(item, Expr) ? Revise.RelocatableExpr(item) : item)
    end
    items
end

# Test helpers, *not* Revise functions: each wraps `Revise.parse_and_maybe_eval_source[!]`, asserts
# the parse succeeded, and returns the resulting `ModuleExprsInfos`. Sharing one terse name keeps the
# many call sites readable and localizes the `ParseResult` unwrapping to this one spot.
function parse_source(file::AbstractString, mod::Module; kwargs...)
    pr = Revise.parse_and_maybe_eval_source(file, mod; kwargs...)
    pr.success || error("parsing $file produced no usable expressions")
    return pr.modexinfos
end
function parse_source!(mexs::Revise.ModuleExprsInfos, args...; kwargs...)
    pr = Revise.parse_and_maybe_eval_source!(mexs, args...; kwargs...)
    pr.success || error("parsing produced no usable expressions")
    return pr.modexinfos
end

function get_docstring(obj)
    while !isa(obj, AbstractString)
        fn = fieldnames(typeof(obj))
        if :content ∈ fn
            obj = obj.content[1]
        elseif :code ∈ fn
            obj = obj.code
        else
            error("unknown object ", obj)
        end
    end
    return obj
end

function get_code(f, typ)
    # Julia 1.5 introduces ":code_coverage_effect" exprs
    ci = code_typed(f, typ)[1].first
    code = copy(ci.code)
    while !isempty(code) && isexpr(code[1], :code_coverage_effect)
        popfirst!(code)
    end
    return code
end

function do_test(name)
    runtest = isempty(ARGS) || name in ARGS
    # Sometimes we get "no output received for 10 minutes" on CI,
    # to debug this it may be useful to know what test is being run.
    runtest && haskey(ENV, "CI") && println("Starting test ", name)
    return runtest
end

function rm_precompile(pkgname::AbstractString)
    filepath = Base.cache_file_entry(Base.PkgId(pkgname))
    isa(filepath, Tuple) && (filepath = filepath[1]*filepath[2])  # Julia 1.3+
    for depot in DEPOT_PATH
        fullpath = joinpath(depot, filepath)
        isfile(fullpath) && rm(fullpath)
    end
end

function isreturning(stmt, val)
    isa(stmt, Core.ReturnNode) || return false
    return stmt.val == val
end
function isreturning_slot(stmt, val)
    isa(stmt, Core.ReturnNode) || return false
    v = stmt.val
    isa(v, Core.SlotNumber) || isa(v, Core.Argument) || return false
    return (isa(v, Core.SlotNumber) ? v.id : v.n) == val
end

if !isempty(ARGS) && "REVISE_TESTS_WATCH_FILES" ∈ ARGS
    Revise.watching_files[] = true
    println("Running tests with `Revise.watching_files[] = true`")
    idx = findall(isequal("REVISE_TESTS_WATCH_FILES"), ARGS)
    deleteat!(ARGS, idx)
end

errmsg(err::Base.Meta.ParseError) = err.msg
errmsg(err::AbstractString) = err

__precompile__(false)

module ReviseTest

square(x) = x^2

cube(x) = error("cube")

fourth(x) = x^4  # this is an addition to the file

module Internal

mult2(x) = error("mult2")
mult3(x) = 3*x

"""
This has a docstring
"""
unchanged(x) = x

unchanged2(@nospecialize(x)) = x

end  # Internal

end

"""
    Revise.track(Base; revise_throw::Bool=!isinteractive())
    Revise.track(Core.Compiler; revise_throw::Bool=!isinteractive())
    Revise.track(stdlib; revise_throw::Bool=!isinteractive())
    Revise.track(SysimagePackage; revise_throw::Bool=!isinteractive())

Track updates to the code in Julia's `base` directory, `base/compiler`, one of its
standard libraries, or a package baked into the running system image (e.g. one
compiled with PackageCompiler.jl). Calls `revise()` after tracking to ensure that any
changes detected during tracking are applied immediately. Optionally, if `revise_throw`
is `true`, `revise()` will throw if any exceptions are encountered while revising.

A package compiled into a system image is already loaded at startup, so Revise's
usual package callback never fires and any source edits made since the image was
built go unnoticed. Calling `Revise.track` on such a package starts watching it and
applies any pending edits.
"""
function track(mod::Module; modified_files=revision_queue, revise_throw::Bool=!isinteractive())
    id = pkgidid_for_mod(mod)
    modname = nameof(mod)
    ret = _track(id, modname; modified_files=modified_files)
    revise(; throw=revise_throw) # force revision so following calls in the same block work
    return ret
end

pkgidid_for_mod(mod) = Base.moduleroot(mod) == Core.Compiler ? PkgId(mod, "Core.Compiler") : PkgId(mod)

const vstring = "v$(VERSION.major).$(VERSION.minor)"

function inpath(path::AbstractString, dirs::Vector{String})
    spath = splitpath(path)
    idx = findfirst(isequal(first(dirs)), spath)
    idx === nothing && return false
    for i = 2:length(dirs)
        idx += 1
        idx <= length(spath) || return false
        if spath[idx] == vstring
            idx += 1
        end
        spath[idx] == dirs[i] || return false
    end
    return true
end

function _track(id::PkgId, modname::Symbol; modified_files=revision_queue)
    haspkgdata(id) && return nothing  # already tracked
    isbase = modname === :Base
    isstdlib = !isbase && Base.is_stdlib(id)
    if isbase || isstdlib
        # Test whether we know where to find the files
        if isbase
            srcdir = fixpath(joinpath(juliadir, "base"))
            dirs = String["base"]
        else
            stdlibv = joinpath("stdlib", vstring, String(modname))
            srcdir = fixpath(joinpath(juliadir, stdlibv))
            if !isdir(srcdir)
                srcdir = fixpath(joinpath(juliadir, "stdlib", String(modname)))
            end
            if !isdir(srcdir)
                # This can happen for Pkg, since it's developed out-of-tree
                srcdir = joinpath(juliadir, "usr", "share", "julia", stdlibv)  # omit fixpath deliberately
            end
            dirs = String["stdlib", String(modname)]
        end
        if !isdir(srcdir)
            @error "unable to find path containing source for $modname, tracking is not possible"
        end
        # Determine when the basesrccache was built
        mtcache = mtime(basesrccache)
        # Initialize expression-tracking for files, and
        # note any modified since Base was built
        pkgdata = getpkgdata(id)
        if pkgdata === nothing
            pkgdata = PkgData(id, srcdir)
        end
        ret = Revise.pkg_fileinfo(id)
        if ret !== nothing
            cachefile, _ = ret
            if cachefile === nothing
                @error "unable to find cache file for $id, tracking is not possible"
            end
        else
            cachefile = basesrccache
        end
        @lock revise_lock begin
            for (submod, filename) in modulefiles_basestlibs(id)
                ffilename = fixpath(filename)
                inpath(ffilename, dirs) || continue
                keypath = ffilename[1:last(findfirst(dirs[end], ffilename))]
                rpath = relpath(ffilename, keypath)
                fullpath = joinpath(basedir(pkgdata), rpath)
                if fullpath != filename
                    cache_file_key[fullpath] = filename
                    src_file_key[filename] = fullpath
                end
                push!(pkgdata, rpath=>FileInfo(submod, cachefile))
                if mtime(ffilename) > mtcache
                    with_logger(_debug_logger) do
                        @debug "Recipe for Base/StdLib" _group="Watching" filename=filename mtime=mtime(filename) mtimeref=mtcache
                    end
                    push!(modified_files, (pkgdata, rpath))
                end
            end
        end
        # Add files to CodeTracking pkgfiles
        CodeTracking._pkgfiles[id] = pkgdata.info
        # Add the files to the watch list
        init_watching(pkgdata, srcfiles(pkgdata))
        # Save the result (unnecessary if already in pkgdatas, but doesn't hurt either)
        @lock revise_lock pkgdatas[id] = pkgdata
    elseif modname === :Compiler
        compilerdir = joinpath(juliadir, "Compiler", "src")
        compilerdir_pre_112 = joinpath(juliadir, "base", "compiler")
        isdir(compilerdir) || (compilerdir = compilerdir_pre_112)
        pkgdata = getpkgdata(id)
        if pkgdata === nothing
            pkgdata = PkgData(id, compilerdir)
        end
        track_subdir_from_git!(pkgdata, compilerdir; modified_files=modified_files)
        # insertion into pkgdatas is done by track_subdir_from_git!
    else
        # issue #685: a package compiled into a system image (e.g. with
        # PackageCompiler.jl) is already loaded when the session starts, so the
        # `using`/`import` package callback that normally sets up watching never
        # fired, and Julia never checked whether the on-disk source is newer than
        # the baked-in code. Set up watching now and queue any source file modified
        # since the package was precompiled. We use the precompile cache file's
        # mtime as the reference point; for a sysimage package the cache file
        # remains in the depot after the build.
        origin = get(Base.pkgorigins, id, nothing)
        cachepath = origin === nothing ? nothing : origin.cachepath
        if cachepath === nothing || isempty(cachepath)
            error("no Revise.track recipe for module ", modname)
        end
        pkgdata = watch_package(id)
        pkgdata === nothing && return nothing
        reftime = mtime(cachepath)
        @lock revise_lock begin
            for rpath in srcfiles(pkgdata)
                fullpath = joinpath(basedir(pkgdata), rpath)
                if mtime(fullpath) > reftime
                    push!(modified_files, (pkgdata, rpath))
                end
            end
        end
    end
    return nothing
end

# Fix paths to files that define Julia (base and stdlibs)
function fixpath(filename::AbstractString; badpath=basebuilddir, goodpath=juliadir)
    startswith(filename, badpath) || return normpath(filename)
    relfilename = relpath(filename, badpath)
    relfilename0 = relfilename
    for strippath in (#joinpath("usr", "share", "julia", "stdlib", "v$(VERSION.major).$(VERSION.minor)"),
                      joinpath("usr", "share", "julia"),)
        if startswith(relfilename, strippath)
            relfilename = relpath(relfilename, strippath)
            if occursin("stdlib", relfilename0) && !occursin("stdlib", relfilename)
                relfilename = joinpath("stdlib", relfilename)
            end
        end
    end
    ffilename = normpath(joinpath(goodpath, relfilename))
    if (isfile(filename) & !isfile(ffilename))
        ffilename = normpath(filename)
    end
    return ffilename
end
_fixpath(lnn; kwargs...) = LineNumberNode(lnn.line, Symbol(fixpath(String(lnn.file); kwargs...)))
fixpath(lnn::LineNumberNode; kwargs...) = _fixpath(lnn; kwargs...)
fixpath(lnn::Core.LineInfoNode; kwargs...) = _fixpath(lnn; kwargs...)

# For tracking subdirectories of Julia itself (base/compiler, stdlibs)
function track_subdir_from_git!(pkgdata::PkgData, subdir::AbstractString; commit=Base.GIT_VERSION_INFO.commit, modified_files=revision_queue)
    # diff against files at the same commit used to build Julia
    repo, repo_path = git_repo(subdir)
    if repo == nothing
        throw(GitRepoException(subdir))
    end
    prefix = string(relpath(realpath(subdir), realpath(repo_path)), "/")   # git-relative path of this subdir
    tree = git_tree(repo, commit)
    files = Iterators.filter(file->startswith(file, prefix) && endswith(file, ".jl"), keys(tree))
    ccall((:giterr_clear, :libgit2), Cvoid, ())  # necessary to avoid errors like "the global/xdg file 'attributes' doesn't exist: No such file or directory"
    @lock revise_lock begin
        for file in files
            fullpath = joinpath(repo_path, file)
            rpath = relpath(fullpath, pkgdata)  # this might undo the above, except for Core.Compiler
            local src
            try
                src = git_source(file, tree)
            catch err
                if err isa KeyError
                    @warn "skipping $file, not found in repo"
                    continue
                end
                rethrow(err)
            end
            fmod = get(juliaf2m, fullpath, Core.Compiler)  # Core.Compiler is not cached
            # The top-level Compiler.jl file `include`s every other Compiler source file
            # and defines the `Compiler` baremodule itself. We can't usefully parse/track
            # it as a normal source file: in Julia 1.12+ its parent module is `Base` (via
            # `Base._included_files`) rather than `Core.Compiler`, and re-executing its
            # contents would attempt to redefine the `Compiler` baremodule.
            endswith(fullpath, "compiler.jl") && continue              # v1.11-: defines the module
            endswith(fullpath, "/Compiler/src/Compiler.jl") && continue  # v1.12+: defines the module
            if fmod === Core.Compiler
                @static if isdefined(Core.Compiler, :EscapeAnalysis)
                    # after https://github.com/JuliaLang/julia/pull/43800
                    if endswith(fullpath, "/compiler/ssair/EscapeAnalysis.jl") || contains(fullpath, "/Compiler/src/ssair/EscapeAnalysis.jl")
                        fmod = Core.Compiler.EscapeAnalysis
                    end
                end
                @static if isdefined(Core.Compiler, :TrimVerifier)
                    if endswith(fullpath, "/Compiler/src/verifytrim.jl")
                        fmod = Core.Compiler.TrimVerifier
                    end
                end
            end
            if src != read(fullpath, String)
                push!(modified_files, (pkgdata, rpath))
            end
            fi = FileInfo(fmod)
            if !parse_and_maybe_eval_source!(fi.mod_exs_infos, src, file, fmod).success
                @warn "failed to parse Git source text for $file"
            else
                instantiate_sigs!(fi.mod_exs_infos)
            end
            push!(pkgdata, rpath=>fi)
        end
    end
    if !isempty(pkgdata.fileinfos)
        id = PkgId(pkgdata)
        CodeTracking._pkgfiles[id] = pkgdata.info
        init_watching(pkgdata, srcfiles(pkgdata))
        @lock revise_lock pkgdatas[id] = pkgdata
    end
    return nothing
end

# This replacement is needed because the path written during compilation differs from
# the git source path
const stdpath_rep = (joinpath("usr", "share", "julia", "stdlib", "v$(VERSION.major).$(VERSION.minor)") => "stdlib",
                    joinpath("usr", "share", "julia", "Compiler") => "Compiler")

const juliaf2m = Dict(normpath(replace(file, stdpath_rep...))=>mod
    for (mod,file) in Base._included_files)

# COV_EXCL_START

const PRECOMPILE_ERRORS = Ref(false)

macro warnpcfail(ex::Expr)
    modl = __module__
    file = __source__.file === nothing ? "?" : String(__source__.file)
    line = __source__.line

    quote

        $(esc(ex)) || begin
            @warn """precompile directive

                $($(Expr(:quote, ex)))

            failed. Please report an issue in $($modl) (after checking for duplicates) or remove this directive.
            """ _file=$file _line=$line

            $PRECOMPILE_ERRORS[] = true
        end
    end
end

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing

    @warnpcfail precompile(Tuple{TaskThunk})
    @warnpcfail precompile(Tuple{typeof(wait_changed), String})
    @warnpcfail precompile(Tuple{typeof(watch_package), PkgId})
    @warnpcfail precompile(Tuple{typeof(watch_includes), Module, String})
    @warnpcfail precompile(Tuple{typeof(watch_manifest), String})
    @warnpcfail precompile(Tuple{typeof(revise_dir_queued), String})
    @warnpcfail precompile(Tuple{typeof(revise_file_queued), PkgData, String})
    @warnpcfail precompile(Tuple{typeof(init_watching), PkgData, Vector{String}})
    @warnpcfail precompile(Tuple{typeof(add_revise_deps)})
    @warnpcfail precompile(Tuple{typeof(watch_package_callback), PkgId})

    @warnpcfail precompile(Tuple{typeof(revise)})
    @warnpcfail precompile(Tuple{typeof(revise_first), Expr})
    @warnpcfail precompile(Tuple{typeof(includet), String})
    @warnpcfail precompile(Tuple{typeof(track), Module, String})
    # setindex! doesn't fully precompile, but it's still beneficial to do it
    # (it shaves off a bit of the time)
    # See https://github.com/JuliaLang/julia/pull/31466
    @warnpcfail precompile(Tuple{typeof(setindex!), ExprsInfos, Nothing, RelocatableExpr})
    @warnpcfail precompile(Tuple{typeof(setindex!), ExprsInfos, Vector{Any}, RelocatableExpr})
    @warnpcfail precompile(Tuple{typeof(setindex!), ModuleExprsInfos, ExprsInfos, Module})
    @warnpcfail precompile(Tuple{typeof(setindex!), Dict{PkgId,PkgData}, PkgData, PkgId})
    @warnpcfail precompile(Tuple{Type{WatchList}})
    @warnpcfail precompile(Tuple{typeof(setindex!), Dict{String,WatchList}, WatchList, String})

    MI = ExInfo
    @warnpcfail precompile(Tuple{typeof(minimal_evaluation!), Any, Module, Core.CodeInfo, Symbol})
    @warnpcfail precompile(Tuple{typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    @warnpcfail precompile(Tuple{typeof(_methods_by_execution!), Compiled, MI, Frame, Vector{Bool}})
    @warnpcfail precompile(Tuple{typeof(Core.kwfunc(methods_by_execution!)),
                             NamedTuple{(:mode,),Tuple{Symbol}},
                             typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    @warnpcfail precompile(Tuple{typeof(Core.kwfunc(methods_by_execution!)),
                             NamedTuple{(:skip_include,),Tuple{Bool}},
                             typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    @warnpcfail precompile(Tuple{typeof(Core.kwfunc(methods_by_execution!)),
                             NamedTuple{(:mode, :skip_include),Tuple{Symbol,Bool}},
                             typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    @warnpcfail precompile(Tuple{typeof(Core.kwfunc(_methods_by_execution!)),
                             NamedTuple{(:mode,),Tuple{Symbol}},
                             typeof(_methods_by_execution!), Compiled, MI, Frame, Vector{Bool}})
    @warnpcfail precompile(Tuple{typeof(Core.kwfunc(_methods_by_execution!)),
                             NamedTuple{(:mode, :skip_include),Tuple{Symbol,Bool}},
                             typeof(_methods_by_execution!), Compiled, MI, Frame, Vector{Bool}})

    mex = which(methods_by_execution!, (Compiled, MI, Module, Expr))
    mbody = bodymethod(mex)
    # use `typeof(pairs(NamedTuple()))` here since it actually differs between Julia versions
    @warnpcfail precompile(Tuple{mbody.sig.parameters[1], Symbol, Bool, Bool, typeof(pairs(NamedTuple())), typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    if VERSION >= v"1.12-"
        @warnpcfail precompile(Tuple{mbody.sig.parameters[1], Symbol, Bool, Bool, Iterators.Pairs{Symbol,Bool,Nothing,NamedTuple{(:skip_include,),Tuple{Bool}}}, typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    else
        @warnpcfail precompile(Tuple{mbody.sig.parameters[1], Symbol, Bool, Bool, Iterators.Pairs{Symbol,Bool,Tuple{Symbol},NamedTuple{(:skip_include,),Tuple{Bool}}}, typeof(methods_by_execution!), Compiled, MI, Module, Expr})
    end
    mfr = which(_methods_by_execution!, (Compiled, MI, Frame, Vector{Bool}))
    mbody = bodymethod(mfr)
    @warnpcfail precompile(Tuple{mbody.sig.parameters[1], Symbol, Bool, typeof(_methods_by_execution!), Compiled, MI, Frame, Vector{Bool}})

    @warnpcfail precompile(Tuple{typeof(get_def), Method})
    @warnpcfail precompile(Tuple{typeof(parse_pkg_files), PkgId})
    if isdefined(Revise, :filter_valid_cachefiles)
        @warnpcfail precompile(Tuple{typeof(filter_valid_cachefiles), String, Vector{String}})
    end
    @warnpcfail precompile(Tuple{typeof(Revise.iswritable), String})
    @warnpcfail precompile(Tuple{typeof(Revise.active_repl_backend_available)})
    @warnpcfail precompile(Tuple{typeof(wait_for_repl_backend)})
    @warnpcfail precompile(Tuple{typeof(pkg_fileinfo), PkgId})
    @warnpcfail precompile(Tuple{typeof(push!), WatchList, Pair{String,PkgId}})
    @warnpcfail precompile(Tuple{typeof(pushex!), ExprsInfos, Expr})
    @warnpcfail precompile(Tuple{Type{ModuleExprsInfos}, Module})
    @warnpcfail precompile(Tuple{Type{FileInfo}, Module, String})
    @warnpcfail precompile(Tuple{Type{PkgData}, PkgId})
    @warnpcfail precompile(Tuple{typeof(Base._deleteat!), Vector{Tuple{Module,String,Float64}}, Vector{Int}})
    @warnpcfail precompile(Tuple{typeof(add_require), String, Module, String, String, Expr})
    @warnpcfail precompile(Tuple{Core.kwftype(typeof(maybe_add_includes_to_pkgdata!)),NamedTuple{(:eval_now,), Tuple{Bool}},typeof(maybe_add_includes_to_pkgdata!),PkgData,String,Vector{Tuple{Module, Function, String}}})

    for TT in (Tuple{Module,Expr}, Tuple{DataType,MethodSummary})
        @warnpcfail precompile(Tuple{Core.kwftype(typeof(Base.CoreLogging.handle_message)),NamedTuple{(:time, :deltainfo), Tuple{Float64, TT}},typeof(Base.CoreLogging.handle_message),ReviseLogger,LogLevel,String,Module,String,Symbol,String,Int})
    end

    if get(ENV, "REVISE_PRECOMPILE_ERROR", "false") == "true" && PRECOMPILE_ERRORS[]
        error("Precompile statements failed. See output above for details")
    end

    return nothing
end
# COV_EXCL_STOP

using Revise
using Test

include("common.jl")

@testset "Polling" begin
    @test Revise.polling_files[]

    testdir = randtmp()
    mkdir(testdir)
    push!(LOAD_PATH, testdir)
    dn = joinpath(testdir, "Polling", "src")
    mkpath(dn)
    srcfile = joinpath(dn, "Polling.jl")
    joinpath(dn, "Polling.jl")
    open(srcfile, "w") do io
        println(io, """
__precompile__(false)

module Polling

f() = 1

end
""")
    end
    sleep(0.5) # let the source file age a bit
    @eval using Polling
    @test Polling.f() == 1
    # I'm not sure why 2 sleeps are better than one, but here it seems to make a difference
    sleep(0.1)
    sleep(0.1)
    open(srcfile, "w") do io
        println(io, """
__precompile__(false)

module Polling

f() = 2

end
""")
    end
    # Wait through the polling interval
    yry()
    sleep(7)
    yry()
    @test Polling.f() == 2

    rm(testdir; force=true, recursive=true)
end

function pkg_fileinfo(id::PkgId)
    origin = get(Base.pkgorigins, id, nothing)
    origin === nothing && return nothing
    cachepath = origin.cachepath
    cachepath === nothing && return nothing
    local checksum
    provides, includes_requires, required_modules = try
        ret = @static if VERSION ≥ v"1.11.0-DEV.683" # https://github.com/JuliaLang/julia/pull/49866
            io = open(cachepath, "r")
            checksum = Base.isvalid_cache_header(io)
            iszero(checksum) && (close(io); return nothing)
            provides, (_, includes_srcfiles_only, requires), required_modules, _... =
                Base.parse_cache_header(io, cachepath)
            close(io)
            provides, (includes_srcfiles_only, requires), required_modules
        else
            checksum = UInt64(0) # Buildid prior to v"1.12.0-DEV.764", and the `srcfiles_only` API does not take `io`
            Base.parse_cache_header(cachepath; srcfiles_only = true)
        end
        ret
    catch
        return nothing
    end
    includes, _ = includes_requires
    for (pkgid, buildid) in provides
        if pkgid.uuid === id.uuid && pkgid.name == id.name
            return cachepath, includes, first.(required_modules), (UInt128(checksum) << 64 | buildid)
        end
    end
    return nothing
end

"""
    update_pkgversion!(id::PkgId)

Refresh `Base.pkgorigins[id].version` from the package's `Project.toml`.

Julia caches a package's version in `Base.pkgorigins` at load time, and
(on Julia 1.12+) `pkgversion` returns that cached value. When developing a
package and bumping its version, the cached value would otherwise go stale
(issue #684). Call this after revising a package so `pkgversion` and Pkg's
version checks stay in sync with the source.
"""
function update_pkgversion!(id::PkgId)
    isdefined(Base, :pkgorigins) || return nothing
    isdefined(Base, :get_pkgversion_from_path) || return nothing
    origin = get(Base.pkgorigins, id, nothing)
    origin === nothing && return nothing
    hasproperty(origin, :version) || return nothing
    path = origin.path
    path === nothing && return nothing
    # `path` is the package entry file (e.g. `src/Foo.jl`); the version lives in
    # the `Project.toml` one directory up from `src`. Note: we deliberately avoid
    # taking `Base.require_lock` here. The load-time lock order is
    # require_lock → revise_lock (`watch_package` is a `require` callback), and we
    # hold `revise_lock` at our call sites; acquiring `require_lock` now would
    # invert that order. A bare field assignment is safe without it.
    v = Base.get_pkgversion_from_path(joinpath(dirname(path), ".."))
    # Don't clobber a known version if the project file is momentarily unreadable
    # (e.g. a path switch in flight) or has no `version` entry.
    v === nothing || (origin.version = v)
    return nothing
end

"""
    parse_pkg_files(id::PkgId)

This function gets called by `watch_package` and runs when a package is first loaded.
Its job is to organize the files and expressions defining the module so that later we can
detect and process revisions.
"""
function parse_pkg_files(id::PkgId)
    pkgdata = get!(()->PkgData(id), pkgdatas, id)
    if use_compiled_modules()
        cachefile_includes_reqs_buildid = pkg_fileinfo(id)
        if cachefile_includes_reqs_buildid !== nothing
            cachefile, includes, reqs, buildid = cachefile_includes_reqs_buildid
            pkgdata.requirements = reqs
            if isdefined(Base, :maybe_loaded_precompile) && (mod′ = Base.maybe_loaded_precompile(id, buildid); mod′ isa Module)
                root = mod′
            elseif isdefined(Base, :loaded_precompiles) && haskey(Base.loaded_precompiles, id => buildid)
                root = Base.loaded_precompiles[id => buildid]
            else
                root = Base.root_module(id)
            end
            # Transforms recorded by `include(mapexpr, ...)` calls while the package
            # loaded/precompiled (Julia ≥ 1.14), keyed by `(including_module, abspath)`.
            # `nothing` when there were none or the recording is unavailable.
            mapexprs = @static isdefined(Base, :include_mapexprs) ? (@invokelatest Base.include_mapexprs(root)) : nothing
            matched_mapexprs = mapexprs === nothing ? nothing : Set{keytype(mapexprs)}()
            for chi in includes
                mod = root
                for mpath in chi.modpath
                    mod = getglobal(mod, Symbol(mpath))::Module
                end
                fname = relpath(chi.filename, pkgdata)
                mapexpr = identity
                if mapexprs !== nothing
                    key = (mod, chi.filename)
                    if haskey(mapexprs, key)
                        mapexpr = mapexprs[key]::Function
                        push!(matched_mapexprs, key)
                    end
                end
                # For precompiled packages, we can read the source later (whenever we need it)
                # from the *.ji cachefile. Keep `chi.filename` itself: that is the exact key
                # the cache is indexed by, and reconstructing it from `fname` is unreliable
                # when path forms diverge (e.g. symlinks, see #1033).
                push!(pkgdata, fname=>FileInfo(mod, cachefile, chi.filename; mapexpr))
            end
            if mapexprs !== nothing && length(matched_mapexprs) != length(mapexprs)
                unmatched = [key for key in keys(mapexprs) if key ∉ matched_mapexprs]
                @warn "Revise could not associate the following `include(mapexpr, ...)` records of $id with tracked files; their transforms will not be applied on revision" unmatched
            end
            CodeTracking._pkgfiles[id] = pkgdata.info
            return pkgdata
        end
    end
    # Non-precompiled package(s). Here we rely on the `include` callbacks to have
    # already populated `included_files`; all we have to do is collect the relevant
    # files.
    # Pin to Revise's frozen world (issue #552); `frozen`'s runtime dispatch also reduces
    # compiler latency, since `queue_includes!` pulls in the whole parsing/expression-splitting
    # infrastructure and it's better to wait to compile it until we actually need it.
    frozen(queue_includes!, pkgdata, id)
    return pkgdata
end

# The transform recorded when `fname` was `include(mapexpr, ...)`ed into `mod`
# (Julia ≥ 1.14, `Base.include_mapexprs`), or `identity` when there was none or no
# record is available. The record lives in a binding created when the target package
# loaded — after Revise's frozen world — hence the `@invokelatest`.
function include_mapexpr_for(mod::Module, fname::AbstractString)
    @static if isdefined(Base, :include_mapexprs)
        mod === Base.__toplevel__ && return identity
        table = @invokelatest Base.include_mapexprs(mod)
        table === nothing && return identity
        return get(table, (mod, String(fname)), identity)::Function
    else
        return identity
    end
end

"""
    parentfile, included_files = modulefiles(mod::Module)

Return the `parentfile` in which `mod` was defined, as well as a list of any
other files that were `include`d to define `mod`. If this operation is unsuccessful,
`(nothing, nothing)` is returned.

All files are returned as absolute paths.
"""
function modulefiles(mod::Module)
    function keypath(filename::AbstractString)
        filename = fixpath(filename)
        return get(src_file_key, filename, filename)
    end
    @static if isdefined(Base, :moduleloc)
        parentfile = String(Base.moduleloc(mod).file)
    else
        parentfile = String(first(methods(getfield(mod, :eval))).file)
    end
    id = PkgId(mod)
    if id.name == "Base" || Base.is_stdlib(id)
        parentfile = normpath(Base.find_source_file(parentfile))
        if !startswith(parentfile, juliadir)
            parentfile = replace(parentfile, fallback_juliadir()=>juliadir)
        end
        filedata = Base._included_files
        included_files = filter(mf->mf[1] == mod, filedata)
        return keypath(parentfile), [keypath(mf[2]) for mf in included_files]
    end
    use_compiled_modules() || return nothing, nothing   # FIXME: support non-precompiled packages
    cachefile_includes_reqs_buildid = pkg_fileinfo(id)
    cachefile_includes_reqs_buildid === nothing && return nothing, nothing
    _, includes, _, _ = cachefile_includes_reqs_buildid
    included_files = filter(mf->mf.id == id, includes)
    return keypath(parentfile), [keypath(mf.filename) for mf in included_files]
end

function modulefiles_basestlibs(id)
    ret = Revise.pkg_fileinfo(id)
    cachefile, includes = ret === nothing ? (nothing, nothing) : ret[1:2]
    # `cachefile` will be nothing for Base and stdlibs that *haven't* been moved out
    cachefile === nothing && return Iterators.drop(Base._included_files, 1)  # stepping through sysimg.jl rebuilds Base, omit it
    # stdlibs that are packages
    mod = Base.loaded_modules[id]
    return map(includes) do inc
        submod = mod
        for sm in inc.modpath
            submod = getfield(submod, Symbol(sm))
        end
        return (submod, inc.filename)
    end
end

using Documenter, Revise

makedocs(;
    modules = [Revise],
    sitename = "Revise.jl",
    authors = "Tim Holy <tim.holy@gmail.com> and contributors",
    linkcheck = !("skiplinks" in ARGS),
    pages = [
        "Home" => "index.md",
        "config.md",
        "cookbook.md",
        "limitations.md",
        "tricks.md",
        "debugging.md",
        "internals.md",
        "user_reference.md",
        "dev_reference.md",
    ],
)

deploydocs(
    repo = "github.com/timholy/Revise.jl.git",
    push_preview = true,
)

Base.Experimental.@optlevel 1

using FileWatching, REPL, UUIDs
using LibGit2: LibGit2
using CRC32c: crc32c
using Base: IdSet, PkgId
using Base.Meta: isexpr
using Core: CodeInfo, MethodTable

if !isdefined(Core, :isdefinedglobal)
    isdefinedglobal(m::Module, s::Symbol) = isdefined(m, s)
end

export @includet, MethodSummary, entr, includet, revise

## BEGIN abstract Distributed API

# Abstract type to represent a single worker
abstract type AbstractWorker end

# Wrapper struct to indicate a worker belonging to the Distributed stdlib. Other
# libraries should make their own type that subtypes AbstractWorker for Revise
# to dispatch on.
struct DistributedWorker <: AbstractWorker
    id::Int
end

# This is a list of functions that will retrieve a list of workers
const workers_functions = Base.Callable[]

# A distributed worker library wanting to use Revise should register their
# workers() function with this.
function register_workers_function(f::Base.Callable)
    push!(workers_functions, f)
    nothing
end

# The library should implement this method such that it behaves like
# Distributed.remotecall().
function remotecall_impl end

# The library should implement two methods for this function:
# - is_master_worker(::typeof(my_workers_function)): check if the current
#   process is the master.
# - is_master_worker(w::MyWorkerType): check if `w` is the master.
function is_master_worker end

# Ordered record of the revision actions applied on the master this session, each
# stored as `(mod, expr)` meaning "evaluate `expr` in `mod`". Revisions are
# normally pushed to the workers that exist at revision time, but a worker added
# *later* loads the package fresh from disk and would otherwise miss them; in
# particular it would lack the freshly-gensym'd closures that `@distributed`
# bodies serialize, giving an `UndefVarError` on deserialization (issue #637).
# `init_worker` replays this log to bring such a worker up to date. Reads and
# writes both go through `revise_lock` (see `record_worker_replay!` and
# `init_worker`). Only populated while a Distributed-like library is loaded and
# this process is the master, so non-distributed sessions pay nothing.
const worker_replay_log = Tuple{Module,Any}[]

# Record `(mod, expr)` for later replay onto workers added after this revision,
# but only when this process is the master for some registered worker library.
# Takes `revise_lock` directly: on the normal `revise` path the caller already
# holds it (a reentrant re-acquire is cheap), and this also covers the side paths
# (`revise_file_now`, `eval_revised`) that reach here without holding it.
function record_worker_replay!(mod::Module, expr)
    @lock revise_lock for get_workers in workers_functions
        if @invokelatest is_master_worker(get_workers)
            push!(worker_replay_log, (mod, expr))
            break
        end
    end
    return nothing
end

# Evaluate `expr` in `mod` on worker `p`, ignoring failures (e.g. `mod` not yet
# loaded there, or a type the expression references being absent).
function apply_worker_action(p, mod::Module, expr)
    try
        @invokelatest remotecall_impl(Core.eval, p, mod, expr)
    catch
    end
    return nothing
end

## END abstract Distributed API

"""
    Revise.active[]

If `false`, Revise will stop updating code.
"""
const active = Ref(true)

"""
    Revise.watching_files[]

Returns `true` if we watch files rather than their containing directory.
FreeBSD and NFS-mounted systems should watch files, otherwise we prefer to watch
directories.
"""
const watching_files = Ref(Sys.KERNEL === :FreeBSD)

"""
    Revise.polling_files[]

Returns `true` if we should poll the filesystem for changes to the files that define
loaded code. It is preferable to avoid polling, instead relying on operating system
notifications via `FileWatching.watch_file`. However, NFS-mounted
filesystems (and perhaps others) do not support file-watching, so for code stored
on such filesystems you should turn polling on.

See the documentation for the `JULIA_REVISE_POLL` environment variable.
"""
const polling_files = Ref(false)

# Some filesystems accept `watch_file`/`watch_dir` calls but never deliver a
# notification, so the watch silently blocks forever. The motivating case is the
# Windows filesystem mounted into WSL under `/mnt/...` (a `drvfs`/`9p` mount):
# inotify is broken there but `stat`-based polling works (issue #514). On such
# paths Revise must poll regardless of the global `polling_files[]` setting.

const _is_wsl = Ref{Union{Nothing,Bool}}(nothing)
# Are we running under the Windows Subsystem for Linux? Cached after the first call.
function is_wsl()
    cached = _is_wsl[]
    cached === nothing || return cached
    wsl = false
    if Sys.islinux()
        try
            wsl = occursin(r"microsoft|WSL"i, read("/proc/sys/kernel/osrelease", String))
        catch
            wsl = false
        end
    end
    return _is_wsl[] = wsl
end

# `/proc/mounts` encodes spaces, tabs, etc. in mount points as octal escapes.
function unescape_mount(s::AbstractString)
    occursin('\\', s) || return s
    return replace(s, r"\\([0-7]{3})" => m -> string(Char(parse(UInt8, m[2:end]; base=8))))
end

# Is `prefix` a path-component prefix of `path`? (`/mnt` is a prefix of `/mnt/c`
# but not of `/mnts`.)
function is_path_prefix(prefix::AbstractString, path::AbstractString)
    prefix == path && return true
    prefix == "/" && return startswith(path, "/")
    return startswith(path, prefix * "/")
end

# Filesystem type for the most specific mount point containing `path`, given the
# lines of a `/proc/mounts`-format table. Returns "" if none matches.
function fstype_for_path(path::AbstractString, mount_lines)
    apath = abspath(path)
    best_mount = best_fstype = ""
    for line in mount_lines
        fields = split(line)
        length(fields) >= 3 || continue
        mountpoint = unescape_mount(fields[2])
        if is_path_prefix(mountpoint, apath) && length(mountpoint) >= length(best_mount)
            best_mount, best_fstype = mountpoint, fields[3]
        end
    end
    return best_fstype
end

mount_fstype(path::AbstractString) =
    fstype_for_path(path, try eachline("/proc/mounts") catch; () end)

# Does `path` live on a filesystem that accepts file-watching calls but never
# delivers change notifications, so that Revise must poll instead? The motivating
# case is the Windows filesystem mounted into WSL (a `drvfs`/`9p` mount); see issue
# #514. Only Linux's `/proc/mounts` is consulted, so the result is `false` on every
# other platform.
function nonnotifying_path(path::AbstractString)
    is_wsl() || return false
    fstype = mount_fstype(path)
    return fstype == "9p" || fstype == "drvfs"
end

function wait_changed(file)
    poll = polling_files[] || nonnotifying_path(file)
    try
        poll ? poll_file(file) : watch_file(file)
    catch err
        if Sys.islinux() && err isa Base.IOError && err.code == -28  # ENOSPC; issue #1010
            @warn """Revise was unable to watch files for changes via inotify (ENOSPC).
            This can happen because:
            - the filesystem does not support inotify (e.g., a WSL `/mnt/...` drive or
              some network mounts);
            - a per-user-namespace limit is in effect (common inside containers,
              snaps, or Flatpaks), in which case `cat /proc/sys/fs/inotify/max_user_watches`
              may report a large value that is not the limit actually enforced;
            - the per-user `max_user_watches` limit is genuinely exhausted.
            As a workaround, set the environment variable `JULIA_REVISE_POLL=1` before
            `using Revise` to poll the filesystem instead of using inotify.
            If `max_user_watches` is genuinely the cause, raise it with, e.g.,
            `echo 65536 | sudo tee /proc/sys/fs/inotify/max_user_watches` (administrative
            privileges required).
            See https://github.com/timholy/Revise.jl/issues/26 for more information.""" maxlog=1
        end
        rethrow(err)
    end
    return nothing
end

"""
    Revise.tracking_Main_includes[]

Returns `true` if files directly included from the REPL should be tracked.
The default is `false`. See the documentation regarding the `JULIA_REVISE_INCLUDE`
environment variable to customize it.
"""
const tracking_Main_includes = Ref(false)

include("relocatable_exprs.jl")
include("types.jl")
include("utils.jl")
include("parsing.jl")
include("lowered.jl")
include("loading.jl")
include("visit.jl")
include("pkgs.jl")
include("stale_load.jl")
include("git.jl")
include("recipes.jl")
include("logging.jl")
include("callbacks.jl")

### Globals to keep track of state

# All of Revise's mutable global state (the dictionaries, sets, and vectors
# defined below) is protected by a single coarse lock. A coarse lock is used
# because these structures are interdependent and are touched from several
# threads: the REPL/interactive thread (via `revise`), the package-load callback
# (`watch_package`, which since Julia 1.12 can run on a background thread when
# `require` finishes there), and the file/manifest-watcher tasks. Earlier
# per-structure locks did not compose, so a reader on one thread could observe a
# dictionary mid-rehash while a writer on another thread mutated it, which
# segfaults.
#
# The lock is a `ReentrantLock`, so nested acquisitions on the same task are
# fine. It is held only around state access, with one deliberate exception:
# `revise` holds it across evaluation of revised code to serialize concurrent
# revisions, as it always has (see issues #837 and #845). It must NOT be held
# across a blocking `wait`/`sleep`; the watcher tasks therefore acquire it only
# to enqueue work, never while waiting for filesystem events.
#
# Guards: `watched_files`, `watched_manifests`, `revision_queue`, `queue_errors`,
# `pkgdatas`, `included_files`, `cache_file_key`, `src_file_key`,
# `dont_watch_pkgs`, `silence_pkgs`, `worker_replay_log`, the `user_callbacks_*`
# collections, and the `@require` bookkeeping. (`types_cache` in visit.jl has its
# own independent lock, on a separate code path.)
const revise_lock = ReentrantLock()

"""
    Revise.watched_files

Global variable, `watched_files[dirname]` returns the collection of files in `dirname`
that we're monitoring for changes. The returned value has type [`Revise.WatchList`](@ref).

This variable allows us to watch directories rather than files, reducing the burden on
the OS.
"""
const watched_files = Dict{String,WatchList}()

"""
    Revise.watched_manifests

Global variable, a set of `Manifest.toml` files from the active projects used during this session.
"""
const watched_manifests = Set{String}()

"""
    Revise.revision_queue

Global variable, `revision_queue` holds `(pkgdata,filename)` pairs that we need to revise, meaning
that these files have changed since we last processed a revision.
This list gets populated by callbacks that watch directories for updates.
"""
const revision_queue = Set{Tuple{PkgData,String}}()

"""
    Revise.queue_errors

Global variable, maps `(pkgdata, filename)` pairs that errored upon last revision to
`(exception, backtrace)`.
"""
const queue_errors = Dict{Tuple{PkgData,String},Tuple{Exception, Any}}() # locking is covered by revise_lock

"""
    Revise.duplicated_signatures

Global variable, maps each method signature currently defined in more than one place
within a precompilable package to the list of `LineNumberNode`s where it is defined.
Such duplicates evaluate successfully in the running session but cause the next
precompilation to fail with "Method overwriting is not permitted during Module
precompilation". See [`Revise.duplicate_methods`](@ref). Locking is covered by `revise_lock`.
"""
const duplicated_signatures = Dict{MethodInfoKey,Vector{LineNumberNode}}()

"""
    Revise.missing_file_grace

A tracked file can be missing transiently: code generators often delete a whole
directory of sources and rewrite it over several seconds, and an editor's
atomic-rename save passes through a deleted state. Deleting the file's methods
at the first `revise()` that lands in such a window would be destructive, so a
missing file is instead kept on [`Revise.revision_queue`](@ref) and revisited:
only if it is still missing `missing_file_grace[]` seconds (default: 5.0) after
first being noticed does `revise` delete its methods. Set this to `Inf` if
sources are regenerated by a slow external process, or to `0.0` to delete
methods immediately.

Locking is covered by `revise_lock`.
"""
const missing_file_grace = Ref(5.0)

# When a queued file is missing at revision time, records when `revise` first
# noticed the absence; the entry is removed when the file reappears. Locking is
# covered by `revise_lock`.
const missing_file_times = Dict{Tuple{PkgData,String},Float64}()

# Can we revise types? This is assigned in __init__() based on the Julia version
# and preference.
const __bpart__ = Ref(false)

"""
    Revise.NOPACKAGE

Global variable; default `PkgId` used for files which do not belong to any
package, but still have to be watched because user callbacks have been
registered for them.
"""
const NOPACKAGE = PkgId(nothing, "")

"""
    Revise.pkgdatas

`pkgdatas` is the core information that tracks the relationship between source code
and julia objects, and allows re-evaluation of code in the proper module scope.
It is a dictionary indexed by PkgId:
`pkgdatas[id]` returns a value of type [`Revise.PkgData`](@ref).
"""
const pkgdatas = Dict{PkgId,PkgData}(NOPACKAGE => PkgData(NOPACKAGE))

# Accessors that take `revise_lock` for the duration of a single `pkgdatas`
# operation. Use these (rather than touching `pkgdatas` directly) anywhere that
# might run concurrently with package loading, so a read never observes the
# dictionary mid-rehash. They release the lock before returning, so the result
# may be stale by the time it is used; any authoritative read-modify-write must
# happen inside its own `@lock revise_lock` block.
getpkgdata(id::PkgId) = @lock revise_lock get(pkgdatas, id, nothing)
haspkgdata(id::PkgId) = @lock revise_lock haskey(pkgdatas, id)
allpkgdatas() = @lock revise_lock collect(values(pkgdatas))

"""
    Revise.rewritten_caches

Set of packages that have lost the source snapshot of at least one file because another
process rebuilt or removed their precompile cache. The path of a cache file is determined
by the active project and the compile flags rather than by the source, so a `using` or
`Pkg.precompile` in a separate process overwrites the very file this session recorded.

Revise compares an edit against the source the session loaded, so for a file whose
snapshot is gone there is nothing to compare against and no revision is attempted: the
file's definitions stay as they were, and each attempt raises a
[`Revise.StaleCacheError`](@ref). Only a restart recovers them, so a non-empty
`rewritten_caches` keeps the prompt yellow for the rest of the session. Files whose source
was identical in both builds, and every other package, are unaffected; where
[`Revise.hold_cache!`](@ref) applies, the snapshot survives the rebuild and nothing is
lost at all.
"""
const rewritten_caches = Set{PkgId}()

"""
    Revise.included_files

Global variable, `included_files` gets populated by callbacks we register with `include`.
It's used to track non-precompiled packages and, optionally, user scripts (see docs on
`JULIA_REVISE_INCLUDE`).
"""
const included_files = Tuple{Module,String}[]  # (module, filename); see issue #947

"""
    expected_juliadir()

This is the path where we ordinarily expect to find a copy of the julia source files,
as well as the source cache. For `juliadir` we additionally search some fallback
locations to handle various corrupt and incomplete installations.
"""
expected_juliadir() = joinpath(Sys.BINDIR, Base.DATAROOTDIR, "julia")

"""
    Revise.basesrccache

Full path to the running Julia's cache of source code defining `Base`.
"""
global basesrccache::String

"""
    Revise.basebuilddir

Julia's top-level directory when Julia was built, as recorded by the entries in
`Base._included_files`.
"""
global basebuilddir::String

# issue #835: compute at run time so this reflects the running Julia, not the Julia
# that precompiled Revise (the two can differ for relocated/cache-compatible installs)
function find_basebuilddir()
    # issue #1045: non-incremental PackageCompiler sysimages have no sysimg.jl entry
    idx = findfirst(x -> endswith(x[2], "sysimg.jl"), Base._included_files)
    idx === nothing ? expected_juliadir() : dirname(dirname(Base._included_files[idx][2]))
end

function fallback_juliadir(candidate = expected_juliadir())
    if !isdir(joinpath(candidate, "base"))
        while true
            trydir = joinpath(candidate, "base")
            isdir(trydir) && break
            trydir = joinpath(candidate, "share", "julia", "base")
            if isdir(trydir)
                candidate = joinpath(candidate, "share", "julia")
                break
            end
            next_candidate = dirname(candidate)
            next_candidate == candidate && break
            candidate = next_candidate
        end
    end
    normpath(candidate)
end

# issue #717: point users at their actual depot. Stale caches are written to
# the first depot entry, which honors a custom DEPOT_PATH rather than ~/.julia.
function revise_cache_dir()
    major, minor = Base.VERSION.major, Base.VERSION.minor
    depot = isempty(DEPOT_PATH) ? joinpath(homedir(), ".julia") : first(DEPOT_PATH)
    return joinpath(depot, "compiled", "v$major.$minor", "Revise")
end

function find_juliadir()
    candidate = expected_juliadir()
    isdir(candidate) && return normpath(candidate)
    # Couldn't find julia dir in the expected place.
    # Let's look in the source build also - it's possible that the Makefile didn't
    # set up the symlinks.
    # N.B.: We need to make sure here that the julia we're running is actually
    # the one being built. It's very common on buildbots that the original build
    # dir exists, but is a different julia that is currently being built.
    if Sys.BINDIR == joinpath(basebuilddir, "usr", "bin")
        return normpath(basebuilddir)
    end

    @warn "Unable to find julia source directory in the expected places.\n
           Looking in fallback locations. If this happens on a non-development build, please file an issue."
    return fallback_juliadir(candidate)
end

"""
    Revise.juliadir

Constant specifying full path to julia top-level source directory.
This should be reliable even for local builds, cross-builds, and binary installs.
"""
global juliadir::String

const cache_file_key = Dict{String,String}() # corrected=>uncorrected filenames
const src_file_key   = Dict{String,String}() # uncorrected=>corrected filenames

"""
    Revise.dont_watch_pkgs

Global variable containing the set of packages that Revise will not track.

!!! warning "Deprecated as of Revise 3.13"
    Direct modification of `dont_watch_pkgs` (e.g., `push!(Revise.dont_watch_pkgs, :PkgName)`)
    is deprecated and may be removed in a future release.
    Use [`Revise.dont_watch`](@ref) and [`Revise.allow_watch`](@ref) instead,
    which also persist your settings across Julia sessions via Preferences.jl.

See also [`Revise.silence`](@ref).
"""
const dont_watch_pkgs = Set{Symbol}()
const silence_pkgs = Set{String}()

# Revise pins its OWN method dispatch to the world age captured at `__init__` (`worldage[]`),
# so that revising a method Revise itself calls (e.g. via `track(Base)`) cannot invalidate
# Revise's machinery mid-operation (issue #552). User code is still evaluated at the latest
# world: JuliaInterpreter threads the latest world through each `Frame`. `worldage[]` is
# `nothing` until `__init__` runs, in which case `frozen` degrades to a plain call.
const worldage = Ref{Union{Nothing,UInt}}(nothing)

@inline function frozen(f, args...; kwargs...)
    w = worldage[]
    return w === nothing ? f(args...; kwargs...) : Base.invoke_in_world(w, f, args...; kwargs...)
end

"""
    Revise.advance_world!()

Re-pin Revise's own method dispatch to the current world age. Revise calls this once during
`__init__`; thereafter it stays fixed, so in ordinary use Revise runs at the world it froze at
initialization and is unaffected by later (re)definitions. Call this manually only after
deliberately revising Revise itself or one of its dependencies (CodeTracking, JuliaInterpreter,
LoweredCodeUtils, OrderedCollections), to make those changes take effect in Revise's machinery.
"""
advance_world!() = (worldage[] = Base.get_world_counter(); nothing)

function collect_mis(sigs)
    mis = Core.MethodInstance[]
    world = Base.get_world_counter()
    for tt in sigs
        matches = Base._methods_by_ftype(tt, 10, world)::Vector
        for mm in matches
            m = mm.method
            for mi in Base.specializations(m)
                if mi.specTypes <: tt
                    push!(mis, mi)
                end
            end
        end
    end
    return mis
end

##
## The inputs are sets of expressions found in each file.
## Some of those expressions will generate methods which are identified via their signatures.
## From "old" expressions we know their corresponding signatures, but from "new"
## expressions we have not yet computed them. This makes old and new asymmetric.
##
## Strategy:
## - For every old expr not found in the new ones,
##     + delete the corresponding methods (using the signatures we've previously computed)
##     + remove the sig entries from CodeTracking.method_info
##   Best to do all the deletion first (across all files and modules) in case a method is
##   simply being moved from one file to another.
## - For every new expr found among the old ones,
##     + update the location info in CodeTracking.method_info
## - For every new expr not found in the old ones,
##     + eval the expr
##     + extract signatures
##     + add to the ModuleExprsInfos
##     + add to CodeTracking.method_info
##
## Interestingly, the ex=>mt_sigs link may not be the same as the mt_sigs=>ex link.
## Consider a conditional block,
##     if Sys.islinux()
##         f() = 1
##         g() = 2
##     else
##         g() = 3
##     end
## From the standpoint of Revise's diff-and-patch functionality, we should look for
## diffs in this entire block. (Really good backedge support---or a variant of `lower` that
## links back to the specific expression---might change this, but for
## now this is the right strategy.) From the standpoint of CodeTracking, we should
## link the signature to the actual method-defining expression (either :(f() = 1) or :(g() = 2)).

# TODO
# - Correct evaluation order (type & method rewrite at the same time)
# - Simplify type matching algorithm

function delete_missing!(
        exs_infos_old::ExprsInfos, exs_infos_new::ExprsInfos,
        reeval_list::IdSet{Union{Method,Type}}, handled_types::IdSet{Type}, world::UInt,
        predictions::TypePredictions = TypePredictions(),
    )
    with_logger(_debug_logger) do
        for (rex, exinfos) in exs_infos_old
            haskey(exs_infos_new, rex) && continue
            # ex was deleted
            exinfos === nothing && continue
            for exinfo in exinfos
                if exinfo isa SigInfo
                    # Method deletions are never skipped on the strength of a
                    # prediction: a textually identical signature may dispatch on a
                    # type that is itself being redefined, in which case the new
                    # method is distinct from the old one and the old one must go.
                    handle_method_deletion!(exinfo, rex, world)
                elseif __bpart__[]
                    typeinfo = exinfo::TypeInfo
                    oldtype = prediction_preserves_type(predictions, typeinfo, world)
                    if oldtype !== nothing
                        # The new source redefines this type equivalently, so
                        # evaluation will keep the existing binding and the
                        # subtype-tree walk is unnecessary (issue #1022). The
                        # prediction is re-checked after evaluation; see `revise`.
                        push!(predictions.skipped, (typeinfo, oldtype))
                        continue
                    end
                    handle_type_deletion!(typeinfo, reeval_list, handled_types, world)
                end
            end
        end
    end
    return exs_infos_old
end

# Return the existing type when `predictions` says the new code redefines
# `typeinfo`'s type equivalently (so its deletion walk can be skipped), else `nothing`.
function prediction_preserves_type(predictions::TypePredictions, typeinfo::TypeInfo, world::UInt)
    tn = typeinfo.typname
    get(predictions.preserved, (tn.module, tn.name), false) || return nothing
    Base.invoke_in_world(world, isdefinedglobal, tn.module, tn.name) || return nothing
    existing = Base.invoke_in_world(world, getglobal, tn.module, tn.name)
    existing isa Type || return nothing
    return existing
end

const empty_exs_infos = ExprsInfos()
function delete_missing!(
        mod_exs_infos_old::ModuleExprsInfos, mod_exs_infos_new::ModuleExprsInfos,
        reeval_list::IdSet{Union{Method,Type}}, handled_types::IdSet{Type}, world::UInt,
        predictions::TypePredictions = TypePredictions(),
    )
    for (mod, exs_infos_old) in mod_exs_infos_old
        exs_infos_new = get(mod_exs_infos_new, mod, empty_exs_infos)
        delete_missing!(exs_infos_old, exs_infos_new, reeval_list, handled_types, world, predictions)
        retract_dropped_exports!(mod, exs_infos_old, exs_infos_new)
    end
    return mod_exs_infos_old
end

# issue #633: a name dropped from a module's `export` list must be un-exported,
# otherwise modules that already did `using ThatModule` keep resolving it. This
# needs `Base.set_binding_visibility!`, the accessor that can lower a binding's
# declared visibility to `:none`; it does not exist before Julia 1.14, where
# retracting an export is impossible and this is a no-op.
@static if isdefined(Base, :set_binding_visibility!)
    function retract_dropped_exports!(mod::Module, exs_infos_old::ExprsInfos, exs_infos_new::ExprsInfos)
        old = exported_names(exs_infos_old)
        isempty(old) && return nothing
        new = exported_names(exs_infos_new)
        for name in old
            name in new && continue
            Base.set_binding_visibility!(mod, name, :none)
        end
        return nothing
    end

    function exported_names(exs_infos::ExprsInfos)
        names = Set{Symbol}()
        for rex in keys(exs_infos)
            add_exported_names!(names, rex.ex)
        end
        return names
    end

    # `parse_source!` stores each top-level statement wrapped in a `:block` (and
    # conditional/`for`-`include` groups can nest further), so recurse to reach
    # the `:export` expression.
    function add_exported_names!(names::Set{Symbol}, @nospecialize(ex))
        isa(ex, Expr) || return names
        if ex.head === :export
            for a in ex.args
                a isa Symbol && push!(names, a)
            end
        elseif ex.head === :block || ex.head === :toplevel
            for a in ex.args
                add_exported_names!(names, a)
            end
        end
        return names
    end
else
    retract_dropped_exports!(::Module, ::ExprsInfos, ::ExprsInfos) = nothing
end

# `true` if diffing old against new will delete at least one expression that defined
# a type. This gates the prediction pass: when no type deletion is pending, there is
# nothing for a prediction to save.
function has_pending_type_deletion(mod_exs_infos_new::ModuleExprsInfos, mod_exs_infos_old::ModuleExprsInfos)
    for (mod, exs_infos_old) in mod_exs_infos_old
        exs_infos_new = get(mod_exs_infos_new, mod, empty_exs_infos)
        for (rex, exinfos) in exs_infos_old
            haskey(exs_infos_new, rex) && continue
            exinfos === nothing && continue
            any(exinfo -> exinfo isa TypeInfo, exinfos) && return true
        end
    end
    return false
end
has_pending_type_deletion(@nospecialize(_), ::ModuleExprsInfos) = false

# Run the type-preservation prediction over every expression the evaluation phase
# will (re)evaluate, i.e., the new rexes. Best-effort: any error leaves the affected
# types unpredicted, keeping the pessimistic deletion path in force.
function predict_changes!(
        predictions::TypePredictions,
        mod_exs_infos_new::ModuleExprsInfos, mod_exs_infos_old::ModuleExprsInfos,
    )
    for (mod, exs_infos_new) in mod_exs_infos_new
        exs_infos_old = get(mod_exs_infos_old, mod, empty_exs_infos)
        for rex in keys(exs_infos_new)
            haskey(exs_infos_old, rex) && continue
            ex = rex.ex
            try
                predict_typebodies!(predictions, mod, ex)
            catch err
                isa(err, InterruptException) && rethrow(err)
                @debug "PredictFailed" _group="Action" time=time() deltainfo=(mod, ex, err)
            end
        end
    end
    return predictions
end

function handle_method_deletion!(siginfo::SigInfo, rex::RelocatableExpr, world::UInt)
    mt, sig = siginfo
    ret = Base._methods_by_ftype(sig, mt, -1, world)
    isempty(ret) && return nothing
    m = ret[end].method  # the last method returned is the least-specific that matches, and thus most likely to be type-equal
    methsig = m.sig
    if sig <: methsig && methsig <: sig
        locdefs = get(CodeTracking.method_info, MethodInfoKey(siginfo), nothing)
        if isa(locdefs, Vector{Tuple{LineNumberNode,Expr}})
            if length(locdefs) > 1
                # Just delete this reference but keep the method
                line = firstline(rex)
                ld = map(pr->linediff(line, pr[1]), locdefs)
                idx = argmin(ld)
                if ld[idx] === typemax(eltype(ld))
                    # No `locdefs` entry shares a file with `rex`. This happens when the
                    # method's recorded location comes from a macro rather than the source
                    # file (e.g. `@views @timing function ... end`), so line matching can't
                    # identify the reference to drop. Drop the last one, matching `eval_rex`. (#668)
                    idx = length(locdefs)
                end
                deleteat!(locdefs, idx)
                return nothing
            else
                @assert length(locdefs) == 1
            end
        end
        @debug "DeleteMethod" _group="Action" time=time() deltainfo=(sig, MethodSummary(m))
        # Delete the corresponding methods
        let delexpr = :(delete_method_by_sig($mt, $sig))
            record_worker_replay!(Main, delexpr)
            for get_workers in workers_functions
                for p in @invokelatest get_workers()
                    apply_worker_action(p, Main, delexpr)  # guard against serialization errors if the type isn't defined on the worker
                end
            end
        end
        Base.delete_method(m)
        # Remove the entries from CodeTracking data
        delete!(CodeTracking.method_info, MethodInfoKey(siginfo))
        # Remove frame from JuliaInterpreter, if applicable. Otherwise debuggers
        # may erroneously work with outdated code (265-like problems)
        if haskey(JuliaInterpreter.framedict, m)
            delete!(JuliaInterpreter.framedict, m)
        end
        if isdefined(m, :generator)
            # defensively delete all generated functions
            empty!(JuliaInterpreter.genframedict)
        end
    else
        @debug "FailedSigDeletion" _group="Action" time=time() deltainfo=(siginfo,world)
    end
    nothing
end

function handle_type_deletion!(
        typeinfo::TypeInfo, reeval_list::IdSet{Union{Method,Type}}, handled_types::IdSet{Type}, world::UInt
    )
    oldtypename = typeinfo.typname
    with_logger(_debug_logger) do
        old_list = copy(reeval_list)
        oldtype = Base.invoke_in_world(world, getglobal, oldtypename.module, oldtypename.name)::Type
        alltypes = all_named_types(world) # snapshot the old type universe at the revision world
        record_invalidations_for_type_deletion!(oldtype, reeval_list, handled_types, alltypes)
        diff = setdiff(reeval_list, old_list)
        @debug "DeleteType" _group="Action" time=time() deltainfo=(oldtype,diff)
    end
    return reeval_list
end

function record_invalidations_for_type_deletion!(
        @nospecialize(oldtype::Type), reeval_list::IdSet{Union{Method,Type}}, handled_types::IdSet{Type},
        alltypes::Base.IdSet{Type}
    )
    push!(handled_types, oldtype)

    olddatatype = Base.unwrap_unionall(oldtype)::DataType
    oldtypename = olddatatype.name
    # `oldtype` must be the canonical binding for its TypeName: a non-parametric
    # DataType or the full `T where ...` UnionAll, never a concrete or partial
    # instantiation. The subtype filter below relies on this — `t <: oldtype`
    # then selects exactly what `subtypes(oldtype)` would. (For `P{Int}`,
    # `subtypes` keeps `PC{Int}` via `typeintersect` while `PC <: P{Int}` is
    # `false`, so the two would otherwise diverge.)
    @assert oldtypename.wrapper === oldtype "expected the canonical binding of $(oldtypename), got $(oldtype)"

    # Find all methods restricted to `oldtype`
    meths = old_methods_with(oldtypename)
    meths !== nothing && union!(reeval_list, meths)

    # Find all types using `oldtype`
    related_types = old_types_with(oldtypename, alltypes)
    related_types !== nothing && union!(reeval_list, related_types)

    # For any modules that have not yet been parsed and had their signatures extracted,
    # we need to do this now, before the binding changes to the new type
    meths !== nothing && maybe_extract_sigs_for_meths(meths)
    related_types !== nothing && maybe_extract_sigs_for_types(related_types)

    # If `oldtype` is an abstract type, traverse its subtypes and invalidate them.
    # By the canonical invariant asserted above, filtering the `alltypes` sweep by
    # `t <: oldtype` matches `subtypes(oldtype)` without re-scanning module names
    # at each recursion level.
    oldsubtypes = Base.IdSet{Type}(t for t in alltypes if t !== oldtype && t <: oldtype)
    maybe_extract_sigs_for_types(oldsubtypes)
    for oldsubtype in oldsubtypes
        oldsubtype in handled_types && continue
        push!(reeval_list, oldsubtype)
        record_invalidations_for_type_deletion!(oldsubtype, reeval_list, handled_types, alltypes)
    end

    # `related_types` will also be recursively redefined, so we need to invalidate methods/types related to them as well
    related_types !== nothing && for related_type in related_types
        related_type in handled_types && continue
        record_invalidations_for_type_deletion!(related_type, reeval_list, handled_types, alltypes)
    end
end

function eval_rex(rex_new::RelocatableExpr, exs_infos_old::ExprsInfos, mod::Module; mode::Symbol=:eval)
    return with_logger(_debug_logger) do
        _, includes = nothing, nothing
        rex_old = getkey(exs_infos_old, rex_new, nothing)
        # extract the signatures and update the line info
        if rex_old === nothing
            ex = rex_new.ex
            # ex is not present in old
            @debug titlecase(String(mode)) _group="Action" time=time() deltainfo=(mod, ex, mode)
            exinfos, includes, thunk = eval_with_signatures(mod, ex; mode)  # All signatures defined by `ex`
            if !isexpr(thunk, :thunk)
                thunk = ex
            end
            record_worker_replay!(mod, thunk)
            for get_workers in workers_functions
                if @invokelatest is_master_worker(get_workers)
                    for p in @invokelatest get_workers()
                        @invokelatest(is_master_worker(p)) && continue
                        apply_worker_action(p, mod, thunk)  # don't error if `mod` isn't defined on the worker
                    end
                end
            end
        else
            exinfos = exs_infos_old[rex_old]
            # Update location info
            ln, lno = firstline(unwrap(rex_new)), firstline(unwrap(rex_old))
            if exinfos !== nothing && !isempty(exinfos) && ln != lno
                ln, lno = ln::LineNumberNode, lno::LineNumberNode
                @debug "LineOffset" _group="Action" time=time() deltainfo=(exinfos, lno=>ln)
                for exinfo in exinfos
                    if exinfo isa SigInfo
                        locdefs = CodeTracking.method_info[MethodInfoKey(exinfo)]::AbstractVector
                        ld = let lno=lno
                            map(pr->linediff(lno, pr[1]), locdefs)
                        end
                        idx = argmin(ld)
                        if ld[idx] === typemax(eltype(ld))
                            # println("Missing linediff for $lno and $(first.(locdefs)) with ", rex.ex)
                            idx = length(locdefs)
                        end
                        _, methdef = locdefs[idx]
                        locdefs[idx] = (fixpath(ln), methdef)
                    end
                end
            end
        end
        return exinfos, includes
    end
end

# These are typically bypassed in favor of expression-by-expression evaluation to
# allow handling of new `include` statements.
function eval_new!(exs_infos_new::ExprsInfos, exs_infos_old::ExprsInfos, mod::Module; mode::Symbol=:eval)
    includes = Vector{Tuple{Module,Function,String}}()
    for rex in keys(exs_infos_new)
        exinfos, includes′ = eval_rex(rex, exs_infos_old, mod; mode)
        if exinfos !== nothing
            exs_infos_new[rex] = exinfos
        end
        if includes′ !== nothing
            append!(includes, includes′)
        end
    end
    return exs_infos_new, includes
end

function eval_new!(mod_exs_infos_new::ModuleExprsInfos, mod_exs_infos_old::ModuleExprsInfos; mode::Symbol=:eval)
    includes = Vector{Tuple{Module,Function,String}}()
    for (mod, exs_infos_new) in mod_exs_infos_new
        # Allow packages to override the supplied mode
        if isdefined(mod, :__revise_mode__)
            mode = getfield(mod, :__revise_mode__)::Symbol
        end
        exs_infos_old = get(mod_exs_infos_old, mod, empty_exs_infos)
        _, _includes = eval_new!(exs_infos_new, exs_infos_old, mod; mode)
        append!(includes, _includes)
    end
    return mod_exs_infos_new, includes
end

# Eval and insert into CodeTracking data
function eval_with_signatures(mod::Module, ex::Expr; mode::Symbol=:eval, kwargs...)
    exinfo = ExInfo(ex)
    _, thk = methods_by_execution!(exinfo, mod, ex; mode, kwargs...)
    exinfos = Union{SigInfo,TypeInfo}[]
    append!(exinfos, exinfo.allsigs, exinfo.typeinfos)
    return exinfos, exinfo.includes, thk
end

function instantiate_sigs!(mod_exs_infos::ModuleExprsInfos; mode::Symbol=:sigs, kwargs...)
    for (mod, exs_infos) in mod_exs_infos
        for rex in keys(exs_infos)
            is_doc_expr(rex.ex) && continue
            try
                exs_infos[rex], _, _ = eval_with_signatures(mod, rex.ex; mode, kwargs...)
            catch err
                if (mode !== :sigs || get(kwargs, :always_rethrow, false) ||
                    err isa InterruptException || err isa SignatureExtractionError)
                    rethrow()
                end
                loc = if err isa ReviseEvalException && err.loc != "unknown location"
                    err.loc
                else
                    lnn = firstline(rex)
                    lnn === nothing || lnn.file === nothing || lnn.file === :none ?
                        "unknown location" : location_string((lnn.file, lnn.line))
                end
                throw(SignatureExtractionError(mod, loc, err))
            end
        end
    end
    return mod_exs_infos
end

# This is intended for testing purposes, but not general use. The key problem is
# that it doesn't properly handle methods that move from one file to another; there is the
# risk you could end up deleting the method altogether depending on the order in which you
# process these.
# See `revise` for the proper approach.
function eval_revised(mod_exs_infos_new::ModuleExprsInfos, mod_exs_infos_old::ModuleExprsInfos)
    reeval_list = IdSet{Union{Method,Type}}()
    handled_types = IdSet{Type}()
    world = Base.get_world_counter()
    delete_missing!(mod_exs_infos_old, mod_exs_infos_new, reeval_list, handled_types, world)
    eval_new!(mod_exs_infos_new, mod_exs_infos_old)  # note: drops `includes`
    instantiate_sigs!(mod_exs_infos_new)
end

"""
    Revise.init_watching(files)
    Revise.init_watching(pkgdata::PkgData, files)

For every filename in `files`, monitor the filesystem for updates. When the file is
updated, either [`Revise.revise_dir_queued`](@ref) or [`Revise.revise_file_queued`](@ref) will
be called.

Use the `pkgdata` version if the files are supplied using relative paths.
"""
function init_watching(pkgdata::PkgData, files=srcfiles(pkgdata))
    udirs = Set{String}()
    for file in files
        file = String(file)::String
        dir, basename = splitdir(file)
        dirfull = joinpath(basedir(pkgdata), dir)
        # Hold the lock across the whole body: we both query/insert `watched_files`
        # and mutate the `WatchList` it stores, which the watcher tasks read.
        @lock revise_lock begin
            already_watching_dir = haskey(watched_files, dirfull)
            already_watching_dir || (watched_files[dirfull] = WatchList())
            watchlist = watched_files[dirfull]
            current_id = get(watchlist.trackedfiles, basename, nothing)
            new_id = pkgdata.info.id
            if new_id != NOPACKAGE || current_id === nothing
                # Allow the package id to be updated
                push!(watchlist, basename=>pkgdata)
                # Record the current ctime as baseline so only future changes are detected
                watchlist.file_ctimes[basename] = ctime(joinpath(dirfull, basename))
                # On filesystems that never deliver notifications (e.g. WSL drvfs,
                # issue #514) we must watch each file individually and poll it;
                # directory-polling cannot detect content changes within a file.
                if watching_files[] || nonnotifying_path(dirfull)
                    if !watching_files[]
                        @info """Revise: code under $dirfull is on a filesystem that does not deliver \
                                 file-change notifications (e.g. a WSL `/mnt/...` drive, issue #514). \
                                 Falling back to polling these files; revisions may take a few seconds \
                                 to register.""" maxlog=1
                    end
                    fwatcher = TaskThunk(revise_file_queued, (pkgdata, file))
                    schedule(Task(fwatcher))
                else
                    already_watching_dir || push!(udirs, dirfull)
                end
            end
        end
    end
    for dirfull in udirs
        if !watching_files[]
            # Register the buffered directory monitor now, before the watcher task
            # runs, so events are queued from the moment we start tracking and the
            # startup gap is closed. Skipped on polling/non-notifying filesystems,
            # which never deliver notifications.
            polling_files[] || nonnotifying_path(dirfull) || watch_folder(dirfull, 0)
            dwatcher = TaskThunk(revise_dir_queued, (dirfull,))
            schedule(Task(dwatcher))
        end
    end
    return nothing
end
init_watching(files) = init_watching((@lock revise_lock pkgdatas[NOPACKAGE]), files)

# Maximum time (in seconds) a watched path may be absent before Revise concludes
# it was genuinely removed. A shorter absence is treated as transient: a
# `Pkg.build`, a git checkout, an environment switch, or an editor's
# atomic-rename save can briefly remove and recreate a directory or file, and in
# those cases the watch should resume silently rather than stop and warn (#523).
const watch_reappear_grace = Ref(5.0)

# Block while a watched path is missing. `exists(path)` reports whether it is
# currently present; `watchkey` is its entry in `watched_files`. Returns:
#   :reappeared — came back within the grace period (resume watching)
#   :removed    — no longer in the watch list, e.g. the package moved (stop quietly)
#   :gone       — stayed missing past the grace period (stop and warn)
function await_watched_path(exists, path::AbstractString, watchkey::AbstractString)
    waited = 0.0
    while !exists(path)
        @lock revise_lock haskey(watched_files, watchkey) || return :removed
        waited ≥ watch_reappear_grace[] && return :gone
        sleep(0.1)
        waited += 0.1
    end
    return :reappeared
end

"""
    revise_dir_queued(dirname::AbstractString)

Wait for one or more of the files registered in `Revise.watched_files[dirname]` to be
modified, and then queue the corresponding files on [`Revise.revision_queue`](@ref).
This is generally called via a [`Revise.TaskThunk`](@ref).
"""
@noinline function revise_dir_queued(dirname::AbstractString)
    @assert isabspath(dirname)
    stillwatching = true
    while stillwatching
        if !isdir(dirname)
            status = await_watched_path(isdir, dirname, dirname)
            if status !== :reappeared
                if status === :gone
                    with_logger(SimpleLogger(stderr)) do
                        @warn "$dirname is not an existing directory, Revise is not watching"
                    end
                    # Drop the watch registration as we stop. Otherwise, if `dirname`
                    # is recreated later (e.g. switching back to a branch that has it),
                    # `init_watching` would see the stale entry, assume a watcher is
                    # already running, and never start a replacement — so edits to the
                    # reappeared files would go unnoticed.
                    @lock revise_lock delete!(watched_files, dirname)
                end
                break
            end
            # Reappeared: the directory was removed and recreated, so the existing
            # monitor may be watching a stale inode. Drop it; the next
            # `wait_changed_dir` re-registers a fresh one.
            unwatch_folder(dirname)
        end

        latestfiles, stillwatching = watch_files_via_dir(dirname)  # will block here until file(s) change
        for (file, id) in latestfiles
            key = joinpath(dirname, file)
            @lock revise_lock begin
                if key in keys(user_callbacks_by_file)
                    union!(user_callbacks_queue, user_callbacks_by_file[key])
                    notify(revision_event)
                end
                if id != NOPACKAGE
                    pkgdata = pkgdatas[id]
                    if hasfile(pkgdata, key)  # issue #228
                        push!(revision_queue, (pkgdata, relpath(key, pkgdata)))
                        notify(revision_event)
                    end
                end
            end
        end
    end
    unwatch_folder(dirname)  # stop the OS watch now that we no longer watch this dir
    return
end

# See #66.
"""
    revise_file_queued(pkgdata::PkgData, filename)

Wait for modifications to `filename`, and then queue the corresponding files on [`Revise.revision_queue`](@ref).
This is generally called via a [`Revise.TaskThunk`](@ref).

This is used only on platforms (like BSD) which cannot use [`Revise.revise_dir_queued`](@ref).
"""
function revise_file_queued(pkgdata::PkgData, file)
    if !isabspath(file)
        file = joinpath(basedir(pkgdata), file)
    end

    dirfull, _ = splitdir(file)
    fileexists(f) = file_exists(f) || isdir(f)
    stillwatching = true
    while stillwatching
        if !fileexists(file)
            status = await_watched_path(fileexists, file, dirfull)
            if status !== :reappeared
                if status === :gone
                    let file=file
                        with_logger(SimpleLogger(stderr)) do
                            @warn "$file is not an existing file, Revise is not watching"
                        end
                    end
                end
                notify(revision_event)
                break
            end
        end
        try
            wait_changed(file)  # will block here until the file changes
        catch e
            # issue #459
            (isa(e, InterruptException) && throwto_repl(e)) || throw(e)
        end

        @lock revise_lock begin
            if file in keys(user_callbacks_by_file)
                union!(user_callbacks_queue, user_callbacks_by_file[file])
                notify(revision_event)
            end
            # Check to see if we're still watching this file
            stillwatching = haskey(watched_files, dirfull)
            if PkgId(pkgdata) != NOPACKAGE
                push!(revision_queue, (pkgdata, relpath(file, pkgdata)))
            end
        end
    end
    return
end

# Parse the file's current contents and look up the exprs Revise has on record for
# it. Returns `(mod_exs_infos_new, mod_exs_infos_old, fileok)`. Safe to call from a
# pre-deletion pass: any mutation of `pkgdata` is limited to lazily filling caches.
function parse_for_revision(pkgdata::PkgData, file::AbstractString, idx::Int)
    fi = fileinfo(pkgdata, idx)
    maybe_parse_from_cache!(pkgdata, file, fi)
    maybe_extract_sigs!(fi)
    mod_exs_infos_old = fi.mod_exs_infos
    filep = pkgdata.info.files[idx]
    if isa(filep, AbstractString)
        if file ≠ "."
            filep = normpath(basedir(pkgdata), file)
        else
            filep = normpath(basedir(pkgdata))
        end
    end
    topmod = first(keys(mod_exs_infos_old))
    fileok = file_exists(String(filep)::String)
    pr = fileok ? parse_and_maybe_eval_source(filep, topmod; mapexpr=fi.mapexpr) : ParseResult(ModuleExprsInfos(topmod), true)
    return pr, mod_exs_infos_old, fileok
end

# Apply deletions for `(pkgdata, file)` from the results of `parse_for_revision`.
# Mutates `reeval_list`, `handled_types`, and `predictions.skipped`. A file that no
# longer exists has all its methods deleted but stays registered in `pkgdata` and
# the watch lists: if it is recreated later, the watcher queues it again and the
# next `revise` re-evaluates the new content. (The caller replaces the stored
# `FileInfo` with the parse result, which for a missing file is empty.)
function delete_for_revision(
        pkgdata::PkgData, file::AbstractString, idx::Int,
        @nospecialize(mod_exs_infos_new), mod_exs_infos_old::ModuleExprsInfos, fileok::Bool,
        reeval_list::IdSet{Union{Method,Type}}, handled_types::IdSet{Type}, world::UInt,
        predictions::TypePredictions,
    )
    if mod_exs_infos_new !== nothing
        delete_missing!(mod_exs_infos_old, mod_exs_infos_new::ModuleExprsInfos, reeval_list, handled_types, world, predictions)
    end
    if !fileok && any(!isempty, values(mod_exs_infos_old))
        filep = pkgdata.info.files[idx]
        if isa(filep, AbstractString)
            if file ≠ "."
                filep = normpath(basedir(pkgdata), file)
            else
                filep = normpath(basedir(pkgdata))
            end
        end
        @warn("$filep no longer exists, deleted all methods")
    end
    return nothing
end

# Because we delete first, we have to make sure we've parsed the file
function handle_deletions(
        pkgdata::PkgData, file::AbstractString, idx::Int,
        reeval_list::IdSet{Union{Method,Type}}, handled_types::IdSet{Type}, world::UInt,
        predictions::TypePredictions = TypePredictions(),
    )
    pr, mod_exs_infos_old, fileok = parse_for_revision(pkgdata, file, idx)
    mod_exs_infos_new = (pr.success && !pr.donotparse) ? pr.modexinfos : nothing
    delete_for_revision(pkgdata, file, idx, mod_exs_infos_new, mod_exs_infos_old, fileok,
                        reeval_list, handled_types, world, predictions)
    return mod_exs_infos_new, mod_exs_infos_old
end

struct ReevalInfo
    reeval::Union{Method,Type}
    mod::Module
    exs_infos::ExprsInfos
    rex::RelocatableExpr
    pkgdata::PkgData
    file::String
    ReevalInfo(
        @nospecialize(reeval::Union{Method,Type}), mod::Module, exs_infos::ExprsInfos, rex::RelocatableExpr,
        pkgdata::PkgData, file::String
    ) = new(reeval, mod, exs_infos, rex, pkgdata, file)
end

function redefine_bindings!(revision_errors::Vector{Tuple{PkgData,String}}, reeval_list::IdSet{Union{Method,Type}}, world::UInt)
    reeval_infos = ReevalInfo[]

    # N.B. This traverse could become expensive when Revise tracked code becomes large
    # We could optimize this part by preparing a `CodeTracking.ex_info` cache that incorporates
    # type information as well as index information to `pkgdatas` into the `CodeTracking.method_info` cache,
    # and updating `CodeTracking.ex_info` in sync with `pkgdatas` updates,
    # then performing lookups to `CodeTracking.ex_info` instead
    for (_, pkgdata) in pkgdatas
        for (file, fileinfo) in zip(srcfiles(pkgdata), pkgdata.fileinfos)
            for (mod, exs_infos) in fileinfo.mod_exs_infos
                for (rex, exinfos) in exs_infos
                    exinfos === nothing && continue
                    for exinfo in exinfos
                        if exinfo isa SigInfo
                            mt, sig = exinfo
                            ret = Base._methods_by_ftype(sig, mt, -1, world)
                            isempty(ret) && continue
                            for match in ret
                                if match.method in reeval_list
                                    push!(reeval_infos, ReevalInfo(match.method, mod, exs_infos, rex, pkgdata, file))
                                    break
                                end
                            end
                        else exinfo::TypeInfo
                            typeinfo = exinfo
                            if Base.invoke_in_world(world, isdefinedglobal, typeinfo.typname.module, typeinfo.typname.name)
                                typ = Base.invoke_in_world(world, getglobal, typeinfo.typname.module, typeinfo.typname.name)
                                if typ isa Type && typ in reeval_list
                                    push!(reeval_infos, ReevalInfo(typ, mod, exs_infos, rex, pkgdata, file))
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    for (; reeval, mod, exs_infos, rex, pkgdata, file) in reeval_infos
        reeval isa Type || continue
        with_logger(_debug_logger) do
            @debug "ReevalType" _group="Action" time=time() deltainfo=(reeval,mod,rex)
            try
                newexinfos, _, _ = eval_with_signatures(mod, rex.ex; mode=:eval)
                exs_infos[rex] = newexinfos
            catch err
                # Re-evaluation failed, likely due to type incompatibility
                # Clear exs_infos cache for this `rex` so that we will retry evaluation when methods become compatible
                delete!(exs_infos, rex)
                @debug "ReevalTypeFailed" _group="Action" time=time() deltainfo=(reeval,mod,rex,err)
                push!(revision_errors, (pkgdata, file))
                queue_errors[(pkgdata, file)] = (err, catch_backtrace())
            end
        end
    end
    # Delete every method before evaluating anything: one expression can own several
    # methods (keyword methods, optional-argument methods, constructors), and
    # evaluating it once per method would leave shadowed duplicate definitions behind.
    # Those duplicates keep the pre-revision types in their signatures and become
    # dispatchable again as soon as a later revision deletes the copy shadowing them.
    for (; reeval) in reeval_infos
        reeval isa Method || continue
        with_logger(_debug_logger) do
            @debug "ReevalDeleteMethod" _group="Action" time=time() deltainfo=(reeval.sig, MethodSummary(reeval))
            # ensure that "old data" doesn't get run with "old methods"
            try Base.delete_method(reeval) catch end
        end
    end
    evaluated_rexes = Set{Tuple{Module,RelocatableExpr}}()
    for (; reeval, mod, exs_infos, rex, pkgdata, file) in reeval_infos
        reeval isa Method || continue
        (mod, rex) in evaluated_rexes && continue
        push!(evaluated_rexes, (mod, rex))
        with_logger(_debug_logger) do
            @debug "ReevalMethod" _group="Action" time=time() deltainfo=(reeval, reeval.module, rex)
            try
                newexinfos, _, _ = eval_with_signatures(mod, rex.ex; mode=:eval)
                exs_infos[rex] = newexinfos
            catch err
                # Re-evaluation failed, likely due to type incompatibility
                # Clear exs_infos cache for this `rex` so that we will retry evaluation when methods become compatible
                delete!(exs_infos, rex)
                @debug "ReevalMethodFailed" _group="Action" time=time() deltainfo=(reeval,mod,rex,err)
                push!(revision_errors, (pkgdata, file))
                queue_errors[(pkgdata, file)] = (err, catch_backtrace())
            end
        end
    end
    return revision_errors
end

# Extract the singleton function instance from a method signature `Tuple{typeof(f), ...}`.
# Returns `nothing` for constructors (`Type{T}`) or callable objects with no singleton instance.
function sig_function(@nospecialize(sig))
    ft = Base.unwrap_unionall(sig)
    ft isa DataType && !isempty(ft.parameters) || return nothing
    F = Base.unwrap_unionall(ft.parameters[1])
    (F isa DataType && isdefined(F, :instance)) || return nothing
    return F.instance
end

# Collect the set of method signatures defined by the `SigInfo`s in `exs_infos`.
function sigset(exs_infos::ExprsInfos)
    sigs = Set{Any}()
    for (_, exinfos) in exs_infos
        exinfos === nothing && continue
        for exinfo in exinfos
            exinfo isa SigInfo || continue
            push!(sigs, exinfo.sig)
        end
    end
    return sigs
end

# Issue #239. An accidental definition such as
#     foo() = iterate(x)        # intends to call Base.iterate
#     iterate(x::Foo) = ...     # OOPS: defines a *new* `MyMod.iterate`, shadowing Base.iterate
# creates a module-local `iterate` that shadows the imported one, and `foo`
# binds to it. When the user corrects it to `Base.iterate(x::Foo) = ...`, Revise
# deletes the wrong method, but the now-methodless `MyMod.iterate` binding
# lingers; unqualified references keep resolving to it, so the package stays
# broken until the session is restarted.
#
# This shadowing can only happen for a name that was implicitly in scope; an
# explicit import errors when code like the above is encountered. Thus if an
# edit (a) *empties* a module-owned function binding and (b) adds a method to a
# *different* function of the same name that is implicitly in scope, we take a
# stab at guessing user-intent and make the change. Because this involves
# inference on Revise's part, we log this with an `@info`.
#
# Requires binding partitions (Julia 1.12+): earlier, function bindings are
# `const` and cannot be reassigned, and `delete_binding` does not exist.
# This 1.12+ feature is not hidden behind a check on `__bpart__`, as that
# focuses on type-redefinition.
function realias_orphaned_bindings!(mod_exs_infos_new::ModuleExprsInfos,
                                    mod_exs_infos_old::ModuleExprsInfos)
    Base.VERSION >= v"1.12.0-DEV.2047" || return nothing
    repaired = Tuple{Module,Symbol,Module}[]
    with_logger(_debug_logger) do
        for (mod, exs_infos_old) in mod_exs_infos_old
            oldsigs = sigset(exs_infos_old)
            newsigs = sigset(get(mod_exs_infos_new, mod, empty_exs_infos))
            # (b) functions that gained a method this revision, indexed by name
            added = Dict{Symbol,Any}()
            for s in newsigs
                s in oldsigs && continue
                f = sig_function(s)
                f === nothing && continue
                added[nameof(f)] = f
            end
            isempty(added) && continue
            # (a) functions that lost a method this revision and are now empty + module-owned
            for s in oldsigs
                s in newsigs && continue
                fdel = sig_function(s)
                fdel === nothing && continue
                isempty(methods(fdel)) || continue       # still has methods => not orphaned
                parentmodule(fdel) === mod || continue    # only repair bindings this module owns
                n = nameof(fdel)
                fadd = get(added, n, nothing)
                (fadd === nothing || fadd === fdel) && continue
                # Only repair when `fadd` was implicitly in scope (an export of a module `mod`
                # bare-`using`s, including Base/Core): that is the sole situation that can
                # produce this shadow, so re-importing reproduces the original implicit scope.
                src = implicit_import_source(mod, n, fadd)
                src === nothing && continue
                # `delete_binding` clears the orphan; `using src: n` re-establishes the import.
                # A bare `delete_binding` is not enough: implicit-import fallthrough after
                # deletion is not yet implemented, so `n` would resolve to `UndefVarError`.
                # TODO: replicate to distributed workers (cf. `delete_method_by_sig`).
                # See https://github.com/timholy/Revise.jl/pull/1056#discussion_r3338811301
                try
                    Base.delete_binding(mod, n)
                    usestmt = Expr(:using, Expr(:(:), Expr(:., fullname(src)...), Expr(:., n)))
                    Core.eval(mod, usestmt)
                    @debug "RealiasOrphan" _group="Action" time=time() deltainfo=(mod, n, src)
                    push!(repaired, (mod, n, src))
                catch err
                    @debug "RealiasOrphanFailed" _group="Action" time=time() deltainfo=(mod, n, err)
                end
            end
        end
    end
    # Surface the repair to the user. Unlike method deletion/redefinition (logged only at
    # `@debug`), this is a binding mutation Revise infers — it does not correspond 1:1 to a
    # source edit the user made — so it is worth an `@info`.
    for (mod, n, src) in repaired
        @info "Revise re-imported `$n` into `$mod` from `$src`, repairing an orphaned binding (issue #239)"
    end
    return nothing
end

# If `n` is implicitly in scope in `mod` — an export of a module `mod` brings in via a bare
# `using` (including the implicit `Base`/`Core`) — and that export is the function `f`, return
# the module supplying it; otherwise `nothing`. This is precisely the condition under which an
# unqualified `n(x::T) = ...` definition shadows `f` with a new module-local binding (#239).
function implicit_import_source(mod::Module, n::Symbol, @nospecialize(f))
    for used in ccall(:jl_module_usings, Any, (Any,), mod)::Vector{Any}
        used isa Module || continue
        Base.isexported(used, n) || continue
        isdefined(used, n) || continue
        getglobal(used, n) === f && return used
    end
    return nothing
end

"""
    Revise.revise_file_now(pkgdata::PkgData, file)

Process revisions to `file`. This parses `file` and computes an expression-level diff
between the current state of the file and its most recently evaluated state.
It then deletes any removed methods and re-evaluates any changed expressions.
Note that generally it is better to use [`revise`](@ref) as it properly handles methods
that move from one file to another.

`id` must be a key in [`Revise.pkgdatas`](@ref), and `file` a key in
`Revise.pkgdatas[id].fileinfos`.
"""
function revise_file_now(pkgdata::PkgData, file)
    # @assert !isabspath(file)
    indices = fileindices(pkgdata, file)
    if isempty(indices)
        println("Revise is currently tracking the following files in $(PkgId(pkgdata)): ", srcfiles(pkgdata))
        error(file, " is not currently being tracked.")
    end
    reeval_list = IdSet{Union{Method,Type}}()
    handled_types = IdSet{Type}()
    world = Base.get_world_counter()
    # A file `include`d into several modules has one `FileInfo` per inclusion; revise
    # them all (issue #730).
    for i in indices
        mod_exs_infos_new, mod_exs_infos_old = handle_deletions(pkgdata, file, i, reeval_list, handled_types, world)
        if mod_exs_infos_new != nothing
            _, includes = eval_new!(mod_exs_infos_new, mod_exs_infos_old)
            realias_orphaned_bindings!(mod_exs_infos_new, mod_exs_infos_old)   # issue #239
            fi = fileinfo(pkgdata, i)
            pkgdata.fileinfos[i] = FileInfo(mod_exs_infos_new, fi)
            maybe_add_includes_to_pkgdata!(pkgdata, file, includes; eval_now=true)
        end
    end
    nothing
end

"""
    Revise.errors()

Report the errors represented in [`Revise.queue_errors`](@ref).
Errors are automatically reported the first time they are encountered, but this function
can be used to report errors again.
"""
function errors(revision_errors=keys(queue_errors))
    printed = Set{eltype(revision_errors)}()
    for item in revision_errors
        item in printed && continue
        push!(printed, item)
        pkgdata, file = item
        (err, bt) = queue_errors[(pkgdata, file)]
        fullpath = joinpath(basedir(pkgdata), file)
        if (err isa ReviseEvalException || err isa StaleCacheError ||
            (err isa SignatureExtractionError && captured_stacktrace(err) !== nothing))
            @error "Failed to revise $fullpath" exception=(err, nothing)
        else
            @error "Failed to revise $fullpath" exception=(err, trim_toplevel!(bt))
        end
    end
end

"""
    Revise.retry()

Attempt to perform previously-failed revisions. This can be useful in cases of order-dependent errors.
"""
function retry()
    @lock revise_lock begin
        for k in keys(queue_errors)
            push!(revision_queue, k)
        end
    end
    revise()
end

# Resolve the least-specific type-equal method for a tracked signature, or `nothing`
# if no matching method currently exists.
function resolve_signature_method(key::MethodInfoKey, world::UInt)
    mt, sig = key
    ret = Base._methods_by_ftype(sig, mt, -1, world)
    isempty(ret) && return nothing
    return ret[end].method
end

# A duplicate signature only matters when its package is actually precompiled: the
# "Method overwriting is not permitted during Module precompilation" failure cannot
# occur for `Main`/`includet` code (never precompiled) or for `__precompile__(false)`
# packages (no cache is ever written). `Base.isprecompiled` is unusable here because a
# package under active Revise development always has a stale cache; the mere existence
# of a cache file distinguishes a precompilable package from one that opts out.
function in_precompilable_package(m::Method)
    root = Base.moduleroot(m.module)
    root === Main && return false
    pkgid = Base.PkgId(root)
    pkgid.name == "Main" && return false
    return !isempty(Base.find_all_in_cache_path(pkgid))
end

# Recompute `duplicated_signatures` from the current tracking data and return the keys
# that are newly duplicated relative to the previous state.
function update_duplicated_signatures!(world::UInt)
    current = Dict{MethodInfoKey,Vector{LineNumberNode}}()
    for (key, locdefs) in CodeTracking.method_info
        isa(locdefs, Vector{Tuple{LineNumberNode,Expr}}) || continue
        length(locdefs) > 1 || continue
        m = resolve_signature_method(key, world)
        m === nothing && continue
        in_precompilable_package(m) || continue
        current[key] = LineNumberNode[ld[1] for ld in locdefs]
    end
    newly = MethodInfoKey[key for key in keys(current) if !haskey(duplicated_signatures, key)]
    empty!(duplicated_signatures)
    merge!(duplicated_signatures, current)
    return newly
end

# Append a human-readable description of one duplicated signature to `io`.
function report_duplicate_signature(io::IO, key::MethodInfoKey, lnns, world::UInt)
    m = resolve_signature_method(key, world)
    if m !== nothing
        try
            Base.show_tuple_as_call(io, m.name, m.sig)
        catch
            print(io, key.sig)
        end
    else
        print(io, key.sig)
    end
    println(io)
    for ln in lnns
        println(io, "    ", location_string((ln.file, ln.line)))
    end
    return io
end

function warn_duplicated_signatures(newly::Vector{MethodInfoKey}, world::UInt)
    isempty(newly) && return nothing
    io = IOBuffer()
    for key in newly
        print(io, "  ")
        report_duplicate_signature(io, key, duplicated_signatures[key], world)
    end
    @warn """The following method(s) are defined in more than one location. They work now, but \
the next precompilation will fail with "Method overwriting is not permitted during Module \
precompilation". Delete the redundant definition(s):
$(String(take!(io)))Use `Revise.duplicate_methods()` to report these again.
Your prompt color may be yellow until the duplicates are resolved."""
    return nothing
end

"""
    Revise.duplicate_methods()

Report the method signatures currently defined in more than one place within a
precompilable package (see [`Revise.duplicated_signatures`](@ref)). Such duplicates
evaluate successfully in the running session but cause the next precompilation to fail
with "Method overwriting is not permitted during Module precompilation". Delete the
redundant definition(s) to resolve. Duplicates are reported automatically the first time
they are detected; this function reports them again.
"""
function duplicate_methods()
    isempty(duplicated_signatures) && return nothing
    world = Base.get_world_counter()
    io = IOBuffer()
    for (key, lnns) in duplicated_signatures
        print(io, "  ")
        report_duplicate_signature(io, key, lnns, world)
    end
    @warn "The following method(s) are defined in more than one location and will fail precompilation:\n$(String(take!(io)))"
    return nothing
end

"""
    revise(; throw=false)

`eval` any changes in the revision queue. See [`Revise.revision_queue`](@ref).
If `throw` is `true`, throw any errors that occur during revision or callback;
otherwise these are only logged.
"""
revise(; throw::Bool=false) = frozen(_revise; throw)

function _revise(; throw::Bool=false)
    active[] || return nothing

    @lock revise_lock begin
        have_queue_errors = !isempty(queue_errors)

        # Julia 1.12+: when bindings switch to a new type, we need to re-evaluate method
        # definitions using the new binding resolution.
        reeval_list = IdSet{Union{Method,Type}}()
        handled_types = IdSet{Type}()
        world = Base.get_world_counter()

        # Do all the deletion first. This ensures that a method that moved from one file to another
        # won't get redefined first and deleted second.
        revision_errors = Tuple{PkgData,String}[]
        queue = sort!(collect(revision_queue); lt=pkgfileless)
        # A watcher task can queue a `PkgData` that has since been replaced in
        # `pkgdatas` (e.g., by `Revise.track` of a package whose record had been
        # dropped, as for packages baked into a sysimage — issue #685). If both the
        # stale and the current record are queued for the same file, keep only the
        # current one: each holds its own copy of the file's old signatures, and
        # processing both would delete the same methods twice.
        keep = trues(length(queue))
        for (i, (pkgdata, file)) in enumerate(queue)
            current = get(pkgdatas, PkgId(pkgdata), nothing)
            (current === nothing || current === pkgdata) && continue
            if any(((qpkgdata, qfile),) -> qpkgdata === current && qfile == file, queue)
                keep[i] = false
            end
        end
        queue = queue[keep]
        finished = eltype(revision_queue)[]
        finished_idx = Int[]
        mod_exs_infos = ModuleExprsInfos[]
        interrupt = false

        # Parse every queued file, then predict which already-defined types the new
        # code re-creates unchanged (e.g., a `@kwdef` struct whose only edit is a
        # default value — issue #1022). The prediction must precede `delete_missing!`,
        # which consults it to skip the expensive subtype-tree walk, and it must span
        # all queued files so a type moved between files is still recognized. It runs
        # only when a type deletion is actually pending, and only under `__bpart__[]`
        # (the consumer of the walk it can skip).
        predictions = TypePredictions()
        # A file `include`d into several modules has one `FileInfo` per inclusion,
        # all sharing the queued filename; each is parsed and revised independently,
        # so `idx` identifies which `FileInfo` a parse result belongs to (issue #730).
        parsed = Tuple{PkgData,String,Int,Any,ModuleExprsInfos,Bool}[]
        pending_type_deletion = false
        deferred_missing = Tuple{PkgData,String}[]
        for (pkgdata, file) in queue
            for idx in fileindices(pkgdata, file)
                try
                    pr, mod_exs_infos_old, fileok = parse_for_revision(pkgdata, file, idx)
                    pr.donotparse && continue
                    mod_exs_infos_new = pr.success ? pr.modexinfos : nothing
                    if fileok
                        delete!(missing_file_times, (pkgdata, file))
                    else
                        # The file may be missing only transiently (e.g., mid-rewrite by a
                        # code generator). Within the grace period, leave it queued and
                        # untouched; see `missing_file_grace`.
                        tfirst = get!(missing_file_times, (pkgdata, file), time())
                        if time() - tfirst < missing_file_grace[]
                            push!(deferred_missing, (pkgdata, file))
                            continue
                        end
                    end
                    pending_type_deletion |= __bpart__[] && has_pending_type_deletion(mod_exs_infos_new, mod_exs_infos_old)
                    push!(parsed, (pkgdata, file, idx, mod_exs_infos_new, mod_exs_infos_old, fileok))
                catch err
                    throw && Base.throw(err)
                    interrupt |= isa(err, InterruptException)
                    push!(revision_errors, (pkgdata, file))
                    queue_errors[(pkgdata, file)] = (err, catch_backtrace())
                end
            end
        end
        if pending_type_deletion
            with_logger(_debug_logger) do
                for (_pkgdata, _file, _idx, mod_exs_infos_new, mod_exs_infos_old, _fileok) in parsed
                    mod_exs_infos_new isa ModuleExprsInfos || continue
                    predict_changes!(predictions, mod_exs_infos_new, mod_exs_infos_old)
                end
            end
        end

        # Apply the deletions
        for (pkgdata, file, idx, mod_exs_infos_new, mod_exs_infos_old, fileok) in parsed
            try
                delete_for_revision(pkgdata, file, idx, mod_exs_infos_new, mod_exs_infos_old, fileok,
                                    reeval_list, handled_types, world, predictions)
                if mod_exs_infos_new !== nothing
                    push!(mod_exs_infos, mod_exs_infos_new)
                    push!(finished, (pkgdata, file))
                    push!(finished_idx, idx)
                end
            catch err
                throw && Base.throw(err)
                interrupt |= isa(err, InterruptException)
                push!(revision_errors, (pkgdata, file))
                queue_errors[(pkgdata, file)] = (err, catch_backtrace())
            end
        end

        # Do the evaluation
        for ((pkgdata, file), i, mod_exs_infos_new) in zip(finished, finished_idx, mod_exs_infos)
            defaultmode = PkgId(pkgdata).name == "Main" ? :evalmeth : :eval
            fi = fileinfo(pkgdata, i)
            modsremaining = Set(keys(mod_exs_infos_new))
            changed, err = true, nothing
            while changed
                changed = false
                for (mod, exs_infos_new) in mod_exs_infos_new
                    mod ∈ modsremaining || continue
                    try
                        mode = defaultmode
                        # Allow packages to override the supplied mode
                        if isdefinedglobal(mod, :__revise_mode__)
                            mode = getglobal(mod, :__revise_mode__)::Symbol
                        end
                        mode ∈ (:sigs, :eval, :evalmeth, :evalassign) || error("unsupported mode ", mode)
                        exs_infos_old = get(fi.mod_exs_infos, mod, empty_exs_infos)
                        for rex in keys(exs_infos_new)
                            exinfos, includes = eval_rex(rex, exs_infos_old, mod; mode)
                            if exinfos !== nothing
                                exs_infos_new[rex] = exinfos
                            end
                            if includes !== nothing
                                maybe_add_includes_to_pkgdata!(pkgdata, file, includes; eval_now=true)
                            end
                        end
                        delete!(modsremaining, mod)
                        changed = true
                    catch e
                        err = e
                    end
                end
            end
            if isempty(modsremaining) || isa(err, LoweringException)   # fix #877
                pkgdata.fileinfos[i] = FileInfo(mod_exs_infos_new, fi)
            end
            if isempty(modsremaining)
                realias_orphaned_bindings!(mod_exs_infos_new, fi.mod_exs_infos)  # issue #239
                delete!(queue_errors, (pkgdata, file))
            else
                throw && Base.throw(err)
                interrupt |= isa(err, InterruptException)
                push!(revision_errors, (pkgdata, file))
                queue_errors[(pkgdata, file)] = (err, catch_backtrace())
            end
        end

        # Keep `Base.pkgorigins` version in sync with revised source (issue #684)
        for pkgdata in unique!(first.(finished))
            update_pkgversion!(PkgId(pkgdata))
        end

        # Do binding redefinitions
        if __bpart__[]
            # Verify the predictions that suppressed deletion walks: they were made
            # before any queued change was applied, so a same-revision change to a
            # binding the type's structure depends on (a field-type alias, a
            # supertype, a parameter bound) can falsify them. If the binding moved
            # anyway, run the walk now — `world` still resolves the old type. Relative
            # to a pre-evaluation walk, signature extraction for files that have not
            # yet been parsed sees the new binding, so methods in such files may
            # escape re-evaluation.
            for (typeinfo, oldtype) in predictions.skipped
                tn = typeinfo.typname
                current = @invokelatest(isdefinedglobal(tn.module, tn.name)) ?
                          @invokelatest(getglobal(tn.module, tn.name)) : nothing
                current === oldtype && continue
                handle_type_deletion!(typeinfo, reeval_list, handled_types, world)
            end
            redefine_bindings!(revision_errors, reeval_list, world)
        end

        # Error handling
        if interrupt
            for pkgfile in finished
                haskey(queue_errors, pkgfile) || delete!(revision_queue, pkgfile)
            end
        else
            empty!(revision_queue)
            # Files missing within the grace period stay queued so the next
            # `revise` revisits them (and `revise_first` keeps firing).
            for pkgfile in deferred_missing
                push!(revision_queue, pkgfile)
            end
        end
        errors(revision_errors)
        if !isempty(queue_errors)
            if !have_queue_errors    # only print on the first time errors occur
                io = IOBuffer()
                println(io, "\n") # better here than in the triple-quoted literal, see https://github.com/JuliaLang/julia/issues/34105
                for (pkgdata, file) in keys(queue_errors)
                    println(io, "  ", joinpath(basedir(pkgdata), file))
                end
                str = String(take!(io))
                @warn """The running code does not match the saved version for the following files:$str
                If the error was due to evaluation order, it can sometimes be resolved by calling `Revise.retry()`.
                Use Revise.errors() to report errors again. Only the first error in each file is shown.
                Your prompt color may be yellow until the errors are resolved."""
            end
        end
        # Surface signatures now defined in more than one place within a precompilable
        # package. They evaluate successfully here, but the next precompilation fails with
        # "Method overwriting is not permitted during Module precompilation" (issue #889).
        dupworld = Base.get_world_counter()
        warn_duplicated_signatures(update_duplicated_signatures!(dupworld), dupworld)
        # A package in `rewritten_caches` keeps the prompt yellow for the rest of the
        # session: revision of such a package is best-effort (see `cache_snapshot_is_valid`)
        # and only a restart can restore a session that provably matches the source.
        if isempty(queue_errors) && isempty(duplicated_signatures) && isempty(rewritten_caches)
            maybe_set_prompt_color(:ok)
        else
            maybe_set_prompt_color(:warn)
        end
        tracking_Main_includes[] && queue_includes(Main)

        process_user_callbacks!(; throw)
    end

    nothing
end
revise(::REPL.REPLBackend) = revise()

"""
    revise(mod::Module; force::Bool=true)

Revise all files that define `mod`.

If `force=true`, reevaluate every definition in `mod`, whether it was changed or not. This is useful
to propagate an updated macro definition, or to force recompiling generated functions.
Be warned, however, that this invalidates all the compiled code in your session that depends on `mod`,
and can lead to long recompilation times.
"""
revise(mod::Module; force::Bool=true) = frozen(_revise, mod; force)

function _revise(mod::Module; force::Bool=true)
    mod == Main && error("cannot revise(Main)")
    id = PkgId(mod)
    pkgdata = @lock revise_lock pkgdatas[id]
    @lock revise_lock for file in pkgdata.info.files
        push!(revision_queue, (pkgdata, file))
    end
    _revise()
    force || return true
    # The force re-evaluation runs user code and logs through the user's ambient logger;
    # escape Revise's frozen world so both dispatch at the latest world (issue #552).
    Base.invokelatest(force_reeval!, pkgdata)
    return true  # fixme try/catch?
end

function force_reeval!(pkgdata::PkgData)
    # issue #975: re-evaluating every definition rewrites each docstring, and
    # `Base.Docs` warns on every rewrite; suppress that expected noise.
    with_logger(SuppressReplacingDocsLogger(current_logger())) do
        for i = 1:length(srcfiles(pkgdata))
            fi = fileinfo(pkgdata, i)
            for (mod, exs_infos) in fi.mod_exs_infos
                for def_rex in keys(exs_infos)
                    ex = def_rex.ex
                    exuw = unwrap(ex)
                    isexpr(exuw, :call) && is_some_include(exuw.args[1]) && continue
                    try
                        Core.eval(mod, ex)
                    catch err
                        @show mod
                        display(ex)
                        rethrow(err)
                    end
                end
            end
        end
    end
    return nothing
end

"""
    Revise.track(mod::Module, file::AbstractString)
    Revise.track(file::AbstractString)
    Revise.track(mapexpr::Function, [mod::Module], file::AbstractString)

Watch `file` for updates and [`revise`](@ref) loaded code with any
changes. `mod` is the module into which `file` is evaluated; if omitted,
it defaults to `Main`.

If the file was loaded with `include(mapexpr, file)`, pass the same `mapexpr` so
revisions apply the same transform to each top-level expression.

If this produces many errors, check that you specified `mod` correctly.
"""
track(mod::Module, file::AbstractString; mode=:sigs, kwargs...) =
    frozen(_track, mod, file; mode, kwargs...)
track(mapexpr::Function, mod::Module, file::AbstractString; kwargs...) =
    track(mod, file; mapexpr, kwargs...)
track(mapexpr::Function, file::AbstractString; kwargs...) =
    track(mapexpr, Main, file; kwargs...)

function _track(mod::Module, file::AbstractString; mode=:sigs, mapexpr::Function=identity, kwargs...)
    isfile(file) || error(file, " is not a file")
    # Determine whether we're already tracking this file
    id = Base.moduleroot(mod) == Main ? PkgId(mod, string(mod)) : PkgId(mod)  # see #689 for `Main`
    pkgdata = getpkgdata(id)
    if pkgdata !== nothing
        relfile = relpath(abspath_no_normalize(file), pkgdata)
        hasfile(pkgdata, relfile) && return nothing
        # Use any "fixes" provided by relpath
        file = joinpath(basedir(pkgdata), relfile)
    else
        # Check whether `track` was called via a @require. Ref issue #403 & #431.
        st = stacktrace(backtrace())
        if any(sf->sf.func === :listenpkg && endswith(String(sf.file), "require.jl"), st)
            nameof(mod) === :Plots || Base.depwarn("Revise@2.4 or higher automatically handles `include` statements in `@require` expressions.\nPlease do not call `Revise.track` from such blocks.", :track)
            return nothing
        end
        file = abspath_no_normalize(file)
    end
    # Set up tracking
    pr = parse_and_maybe_eval_source(file, mod; mode, mapexpr)
    if pr.success
        mod_exs_infos = pr.modexinfos
        if mode === :includet
            mode = :sigs   # we already handled evaluation in `parse_and_maybe_eval_source`
        end
        frozen(instantiate_sigs!, mod_exs_infos; mode, kwargs...)
        if !haspkgdata(id)
            # Wait a bit to see if `mod` gets initialized
            sleep(0.1)
        end
        pkgdata = getpkgdata(id)
        if pkgdata === nothing
            pkgdata = PkgData(id, pathof(mod))
        end
        if !haskey(CodeTracking._pkgfiles, id)
            CodeTracking._pkgfiles[id] = pkgdata.info
        end
        @lock revise_lock begin
            push!(pkgdata, relpath(file, pkgdata)=>FileInfo(mod_exs_infos; mapexpr))
            init_watching(pkgdata, (String(file)::String,))
            pkgdatas[id] = pkgdata
        end
    end
    # issue #783: in `:includet` mode, return the value of the last evaluated expression
    return isdefined(pr, :ret) ? pr.ret : nothing
end

function track(file::AbstractString; kwargs...)
    startswith(file, juliadir) && error("use Revise.track(Base) or Revise.track(<stdlib module>)")
    track(Main, file; kwargs...)
end

"""
    includet(filename::AbstractString)
    includet(mapexpr::Function, filename::AbstractString)

Load `filename` and track future changes. `includet` is intended for quick "user scripts"; larger or more
established projects are encouraged to put the code in one or more packages loaded with `using`
or `import` instead of using `includet`. See https://timholy.github.io/Revise.jl/stable/cookbook/
for tips about setting up the package workflow.

Like `include`, `includet` returns the value of the last evaluated expression in `filename`,
and accepts a leading `mapexpr` that transforms each top-level expression before it is
evaluated; revisions of `filename` apply the same transform.

Unlike `include`, `includet` evaluates `filename` into `Main` rather than into the module from
which it is called. To evaluate into the caller's module instead, use [`@includet`](@ref) or pass
the module explicitly with `includet(mod, filename)`.

By default, `includet` only tracks modifications to *methods*, not *data*. See the extended help for details.
Note that this differs from packages, which evaluate all changes by default.
This default behavior can be overridden; see [Configuring the revise mode](@ref).

# Extended help

## Behavior and justification for the default revision mode (`:evalmeth`)

`includet` uses a default `__revise_mode__ = :evalmeth`. The consequence is that if you change

```
a = [1]
f() = 1
```
to
```
a = [2]
f() = 2
```
then Revise will update `f` but not `a`.

This is the default choice for `includet` because such files typically mix method definitions and data-handling.
Data often has many untracked dependencies; later in the same file you might `push!(a, 22)`, but Revise cannot
determine whether you wish it to re-run that line after redefining `a`.
Consequently, the safest default choice is to leave the user in charge of data.

## Workflow tips

If you have a series of computations that you want to run when you redefine your methods, consider separating
your method definitions from your computations:

- method definitions go in a package, or a file that you `includet` *once*
- the computations go in a separate file, that you re-`include` (no "t" at the end) each time you want to rerun
  your computations.

This can be automated using [`entr`](@ref).

## Internals

`includet` is essentially shorthand for

    Revise.track(Main, filename; mode=:includet, skip_include=true)

Do *not* use `includet` for packages, as those should be handled by `using` or `import`.
If `using` and `import` aren't working, you may have packages in a non-standard location;
try fixing it with something like `push!(LOAD_PATH, "/path/to/my/private/repos")`.
(If you're working with code in Base or one of Julia's standard libraries, use
`Revise.track(mod)` instead, where `mod` is the module.)

`includet` is deliberately non-recursive, so if `filename` loads any other files,
they will not be automatically tracked.
(Call [`Revise.track`](@ref) manually on each file, if you've already `included`d all the code you need.)
Multi-file code that needs all of its files tracked is better organized as a package loaded with
`using`/`import`, which Revise tracks recursively and which gives you a proper module namespace.
"""
function includet(mapexpr::Function, mod::Module, file::AbstractString)
    prev = Base.source_path(nothing)
    file = if prev === nothing
        abspath(file)
    else
        normpath(joinpath(dirname(prev), file))
    end
    tls = task_local_storage()
    tls[:SOURCE_PATH] = file
    result = nothing
    try
        result = track(mod, file; mode=:includet, skip_include=true, mapexpr)
        if prev === nothing
            delete!(tls, :SOURCE_PATH)
        else
            tls[:SOURCE_PATH] = prev
        end
    catch err
        if prev === nothing
            delete!(tls, :SOURCE_PATH)
        else
            tls[:SOURCE_PATH] = prev
        end
        if isa(err, ReviseEvalException)
            printstyled(stderr, "ERROR: "; color=Base.error_color());
            invokelatest(showerror, stderr, err; blame_revise=false)
            println(stderr, "\nin expression starting at ", err.loc)
        else
            rethrow()
        end
    end
    return result
end
includet(mod::Module, file::AbstractString) = includet(identity, mod, file)
includet(mapexpr::Function, file::AbstractString) = includet(mapexpr, Main, file)
includet(file::AbstractString) = includet(identity, Main, file)

"""
    @includet "file.jl"

Load `file` and track future changes, evaluating its code into the module in which the macro
is expanded. This is the only difference from [`includet`](@ref): the function form always
evaluates into `Main` (or an explicitly-passed module), whereas `@includet` uses the caller's
module, just as `include` does.

Use `@includet` when calling from inside a module other than `Main`; at the REPL the two forms
are equivalent. The expansion is simply

    Revise.includet(@__MODULE__, file)
"""
macro includet(file)
    return :(includet($__module__, $(esc(file))))
end

"""
    Revise.silence(pkg)

Silence warnings about not tracking changes to package `pkg`.

The list of silenced packages is stored persistently using Preferences.jl.
See also [`Revise.unsilence`](@ref).
"""
silence(pkg::Symbol) = silence(String(pkg))
function silence(pkg::AbstractString)
    @lock revise_lock push!(silence_pkgs, pkg)
    Preferences.@set_preferences!("silenced_packages" => collect(silence_pkgs))
    nothing
end

"""
    Revise.unsilence(pkg)

Remove `pkg` from the list of silenced packages, re-enabling warnings about
not tracking changes to that package.

See also [`Revise.silence`](@ref).
"""
unsilence(pkg::Symbol) = unsilence(String(pkg))
function unsilence(pkg::AbstractString)
    @lock revise_lock delete!(silence_pkgs, pkg)
    Preferences.@set_preferences!("silenced_packages" => collect(silence_pkgs))
    nothing
end

"""
    Revise.dont_watch(pkg)

Prevent Revise from tracking changes to package `pkg`.

The list of excluded packages is stored persistently using Preferences.jl.
See also [`Revise.allow_watch`](@ref) and [`Revise.silence`](@ref).
"""
function dont_watch(pkg::Symbol)
    @lock revise_lock push!(dont_watch_pkgs, pkg)
    Preferences.@set_preferences!("dont_watch_packages" => String[string(p) for p in dont_watch_pkgs])
    nothing
end
dont_watch(pkg::AbstractString) = dont_watch(Symbol(pkg))

"""
    Revise.allow_watch(pkg)

Remove `pkg` from the list of excluded packages, allowing Revise to track
changes to that package again.

See also [`Revise.dont_watch`](@ref).
"""
function allow_watch(pkg::Symbol)
    @lock revise_lock delete!(dont_watch_pkgs, pkg)
    Preferences.@set_preferences!("dont_watch_packages" => String[string(p) for p in dont_watch_pkgs])
    nothing
end
allow_watch(pkg::AbstractString) = allow_watch(Symbol(pkg))

## Utilities

"""
    success = get_def(method::Method)

As needed, load the source file necessary for extracting the code defining `method`.
The source-file defining `method` must be tracked.
If it is in Base, this will execute `track(Base)` if necessary.

This is a callback function used by `CodeTracking.jl`'s `definition`.
"""
function get_def(method::Method; modified_files=revision_queue)
    yield()   # magic bug fix for the OSX test failures. TODO: figure out why this works (prob. Julia bug)
    if method.file === :none && String(method.name)[1] == '#'
        # This is likely to be a kwarg method, try to find something with location info
        method = bodymethod(method)
    end
    filename = fixpath(String(method.file))
    if startswith(filename, "REPL[")
        isdefined(Base, :active_repl) || return false
        fi = add_definitions_from_repl(filename)
        hassig = false
        for (_, exs_infos) in fi.mod_exs_infos
            for exinfos in values(exs_infos)
                hassig |= !isempty(exinfos)
            end
        end
        return hassig
    end
    id = get_tracked_id(method.module; modified_files=modified_files)
    id === nothing && return false
    pkgdata = @lock revise_lock pkgdatas[id]
    filename = relpath(filename, pkgdata)
    if hasfile(pkgdata, filename)
        def = get_def(method, pkgdata, filename)
        def !== nothing && return true
    end
    # Lookup can fail for macro-defined methods, see https://github.com/JuliaLang/julia/issues/31197
    # We need to find the right file.
    if method.module === Base || method.module === Core || method.module === Core.Compiler
        @warn "skipping $method to avoid parsing too much code" maxlog=1 _id=method
        CodeTracking.invoked_setindex!(CodeTracking.method_info, missing, MethodInfoKey(method))
        return false
    end
    parentfile, included_files = modulefiles(method.module)
    if parentfile !== nothing
        def = get_def(method, pkgdata, relpath(parentfile, pkgdata))
        def !== nothing && return true
        for modulefile in included_files
            def = get_def(method, pkgdata, relpath(modulefile, pkgdata))
            def !== nothing && return true
        end
    end
    rootmod = Base.moduleroot(method.module)
    if rootmod === Base || rootmod === Core || rootmod === Core.Compiler
        @warn "skipping $method to avoid parsing too much code" maxlog=1 _id=method
        CodeTracking.invoked_setindex!(CodeTracking.method_info, missing, MethodInfoKey(method))
        return false
    end
    # As a last resort, try every file in the package
    for file in srcfiles(pkgdata)
        def = get_def(method, pkgdata, file)
        def !== nothing && return true
    end
    @warn "$(method.sig)$(isdefined(method, :external_mt) ? " (overlayed)" : "") was not found"
    # So that we don't call it again, store missingness info in CodeTracking
    CodeTracking.invoked_setindex!(CodeTracking.method_info, missing, MethodInfoKey(method))
    return false
end

function get_def(method, pkgdata, filename)
    fi = try_parse_from_cache!(pkgdata, filename)
    fi === nothing && return nothing
    maybe_extract_sigs!(fi)
    return get(CodeTracking.method_info, MethodInfoKey(method), nothing)
end

function get_tracked_id(id::PkgId; modified_files=revision_queue)
    # Methods from Base or the stdlibs may require that we start tracking
    if !haspkgdata(id)
        recipe = id.name === "Compiler" ? :Compiler : Symbol(id.name)
        recipe === :Core && return nothing
        _track(id, recipe; modified_files=modified_files)
        @info "tracking $recipe"
        if !haspkgdata(id)
            @warn "despite tracking $recipe, $id was not found"
            return nothing
        end
    end
    return id
end
get_tracked_id(mod::Module; modified_files=revision_queue) =
    get_tracked_id(PkgId(mod); modified_files=modified_files)

function get_expressions(id::PkgId, filename)
    get_tracked_id(id)
    pkgdata = @lock revise_lock pkgdatas[id]
    fi = try_parse_from_cache!(pkgdata, filename)
    fi === nothing && return nothing
    maybe_extract_sigs!(fi)
    return fi.mod_exs_infos
end

function add_definitions_from_repl(filename::String)
    hist_idx = parse(Int, filename[6:end-1])
    hp = (Base.active_repl::REPL.LineEditREPL).interface.modes[1].hist::REPL.REPLHistoryProvider
    entry = hp.history[hp.start_idx+hist_idx]
    src = entry isa AbstractString ? entry : entry.content
    id = PkgId(nothing, "@REPL")
    pkgdata = @lock revise_lock pkgdatas[id]
    mod_exs_infos = ModuleExprsInfos(Main::Module)
    parse_and_maybe_eval_source!(mod_exs_infos, src, filename, Main::Module)
    instantiate_sigs!(mod_exs_infos)
    fi = FileInfo(mod_exs_infos)
    push!(pkgdata, filename=>fi)
    return fi
end
add_definitions_from_repl(filename::AbstractString) = add_definitions_from_repl(convert(String, filename)::String)

function update_stacktrace_lineno!(trace)
    local nrep
    for i = 1:length(trace)
        t = trace[i]
        has_nrep = !isa(t, StackTraces.StackFrame)
        if has_nrep
            t, nrep = t
        end
        t = t::StackTraces.StackFrame
        linfo = t.linfo
        if linfo isa Core.CodeInstance
            linfo = linfo.def
            @static if isdefined(Core, :ABIOverride)
                if isa(linfo, Core.ABIOverride)
                    linfo = linfo.def
                end
            end
        end
        if linfo isa Core.MethodInstance
            m = linfo.def
            # Why not just call `whereis`? Because that forces tracking. This is being
            # clever by recognizing that these entries exist only if there have been updates.
            updated = get(CodeTracking.method_info, MethodInfoKey(m), nothing)
            if updated !== nothing
                lnn = updated[1][1]     # choose the first entry by default
                lineoffset = lnn.line - m.line
                t = StackTraces.StackFrame(t.func, lnn.file, t.line+lineoffset, t.linfo, t.from_c, t.inlined, t.pointer)
                if has_nrep
                    @assert @isdefined(nrep) "Assertion to tell the compiler about the definedness of this variable"
                    trace[i] = t, nrep
                else
                    trace[i] = t
                end
            end
        end
    end
    return trace
end

function method_location(method::Method)
    # Why not just call `whereis`? Because that forces tracking. This is being
    # clever by recognizing that these entries exist only if there have been updates.
    updated = get(CodeTracking.method_info, MethodInfoKey(method), nothing)
    if updated !== nothing
        lnn = updated[1][1]
        return lnn.file, lnn.line
    end
    return method.file, method.line
end

# Set the prompt color to indicate the presence of unhandled revision errors
const original_repl_prefix = Ref{Union{String,Function,Nothing}}(nothing)
function maybe_set_prompt_color(color)
    isdefined(Base, :active_repl) || return nothing
    return set_prompt_color!(color, Base.active_repl)
end

function set_prompt_color!(color, repl)
    if isa(repl, REPL.LineEditREPL) && isdefined(repl, :interface)
        # Always recolor the `julia>` prompt, never whatever mode happens to
        # be active, so a revision error raised while in shell/help/pkg mode
        # does not leak that mode's color onto `julia>` (issue #755).
        julia_prompt = repl.interface.modes[1]
        if color === :warn
            # First save the original setting
            if original_repl_prefix[] === nothing
                original_repl_prefix[] = julia_prompt.prompt_prefix
            end
            julia_prompt.prompt_prefix = "\e[33m"  # yellow
        else
            color = original_repl_prefix[]
            color === nothing && return nothing
            julia_prompt.prompt_prefix = color
            original_repl_prefix[] = nothing
        end
    end
    return nothing
end

# `revise_first` gets called by the REPL prior to executing the next command (by having been pushed
# onto the `ast_transform` list).
# This uses invokelatest not for reasons of world age but to ensure that the call is made at runtime.
# This allows `revise_first` to be compiled without compiling `revise` itself, and greatly
# reduces the overhead of using Revise.
function revise_first(ex)
    # Special-case `exit()` (issue #562)
    if isa(ex, Expr)
        exu = unwrap(ex)
        if isexpr(exu, :block, 2)
            arg1 = exu.args[1]
            if isexpr(arg1, :softscope)
                exu = exu.args[2]
            end
        end

        # Try to detect shell mode in the REPL. Might also falsely trigger for certain
        # `julia>` mode commands, but 🤷
        if isexpr(exu, :call, 3) && exu.args[1] == :(Base.repl_cmd)
            return ex
        end

        if isa(exu, Expr)
            exu.head === :call && length(exu.args) == 1 && exu.args[1] === :exit && return ex
            lhsrhs = LoweredCodeUtils.get_lhs_rhs(exu)
            if lhsrhs !== nothing
                lhs, _ = lhsrhs
                if isexpr(lhs, :ref) && length(lhs.args) == 1
                    arg1 = lhs.args[1]
                    isexpr(arg1, :(.), 2) && arg1.args[1] === :Revise && is_quotenode_egal(arg1.args[2], :active) && return ex
                end
            end
        end
    end
    # Check for queued revisions, and if so call `revise` first before executing the expression
    return Expr(:toplevel, :($isempty($revision_queue) || $(Base.invokelatest)($revise)), ex)
end

steal_repl_backend(_...) = @warn """
    `steal_repl_backend` has been removed from Revise, please update your `~/.julia/config/startup.jl`.
    See https://timholy.github.io/Revise.jl/stable/config/
    """
wait_steal_repl_backend() = steal_repl_backend()
async_steal_repl_backend() = steal_repl_backend()

"""
    Revise.init_worker(p)

Define methods on worker `p` that Revise needs in order to perform revisions on `p`,
and replay onto `p` any revisions already applied on the master this session.
Revise itself does not need to be running on `p`.

Call this after the relevant packages have been loaded on `p` (e.g. via
`@everywhere using MyPkg`); otherwise the replayed revisions, which evaluate into
those modules, are silently skipped and `p` stays at the on-disk state. Replaying
is what keeps closures serialized across workers (such as `@distributed` bodies)
in sync after a revision, including for workers added later (issue #637).
"""
function init_worker(p::AbstractWorker)
    @invokelatest remotecall_impl(Core.eval, p, Main, quote
        function whichtt(mt::Union{Nothing, Core.MethodTable}, @nospecialize sig)
            ret = Base._methods_by_ftype(sig, mt, -1, Base.get_world_counter())
            isempty(ret) && return nothing
            m = ret[end][3]::Method   # the last method returned is the least-specific that matches, and thus most likely to be type-equal
            methsig = m.sig
            (sig <: methsig && methsig <: sig) || return nothing
            return m
        end
        function delete_method_by_sig(mt::Union{Nothing, Core.MethodTable}, @nospecialize sig)
            m = whichtt(mt, sig)
            isa(m, Method) && Base.delete_method(m)
        end
    end)
    @invokelatest(is_master_worker(p)) && return nothing
    actions = lock(revise_lock) do
        copy(worker_replay_log)
    end
    # Unlike the best-effort propagation during `revise`, this is an explicit
    # synchronization point: wait for each action so the worker is fully caught up
    # before `init_worker` returns and the caller starts dispatching work to it.
    for (mod, expr) in actions
        try
            @invokelatest wait(remotecall_impl(Core.eval, p, mod, expr))
        catch  # e.g. `mod` not loaded on the worker yet
        end
    end
    return nothing
end

init_worker(p::Int) = init_worker(DistributedWorker(p))

active_repl_backend_available() = isdefined(Base, :active_repl_backend) && Base.active_repl_backend !== nothing

# Wait for the REPL backend to come up, then register `revise_first` on it.
# #719: this runs async in case Revise is loaded from startup.jl, before the
# backend exists. issue #900: keep this a named function (not an anonymous
# `@async` closure) so it has a stable, precompilable signature.
function wait_for_repl_backend()
    iter = 0
    while !active_repl_backend_available() && iter < 20
        sleep(0.05)
        iter += 1
    end
    if active_repl_backend_available()
        push!(Base.active_repl_backend.ast_transforms, revise_first)
    end
    return nothing
end

function __init__()
    ccall(:jl_generating_output, Cint, ()) == 1 && return nothing
    run_on_worker = get(ENV, "JULIA_REVISE_WORKER_ONLY", "0")

    # Find the Distributed module if it's been loaded
    distributed_pkgid = Base.PkgId(Base.UUID("8ba89e20-285c-5b6f-9357-94700520ee1b"), "Distributed")
    distributed_module = get(Base.loaded_modules, distributed_pkgid, nothing)

    # We do a little hack to figure out if this is the master worker without
    # loading Distributed. When a worker is added with Distributed.addprocs() it
    # calls julia with the `--worker` flag. This is processed very early during
    # startup before any user code (e.g. through `-E`) is executed, so if
    # Distributed is *not* loaded already then we can be sure that this is the
    # master worker. And if it is loaded then we can just check
    # Distributed.myid() directly.
    if !(isnothing(distributed_module) || distributed_module.myid() == 1 || run_on_worker == "1")
        return nothing
    end

    # Pin Revise's own dispatch to the world it sees now, after Revise and its dependencies
    # are fully loaded (issue #552). See `advance_world!`.
    advance_world!()

    # Setting up the paths relative to package module location

    global basebuilddir = find_basebuilddir()
    global juliadir = find_juliadir()
    global basesrccache = normpath(joinpath(expected_juliadir(), "base.cache"))

    # Check Julia paths (issue #601)
    if !isdir(juliadir)
        @warn """Expected non-existent $juliadir to be your Julia directory.
                 Certain functionality will be disabled.
                 To fix this, try deleting Revise's cache files in $(revise_cache_dir()), then restart Julia and load Revise.
                 If this doesn't fix the problem, please report an issue at https://github.com/timholy/Revise.jl/issues."""
    end
    excluded = Preferences.@load_preference("dont_watch_packages", String[])
    for pkg in excluded
        push!(dont_watch_pkgs, Symbol(pkg))
    end
    silenced = Preferences.@load_preference("silenced_packages", String[])
    for pkg in silenced
        push!(silence_pkgs, pkg)
    end
    __bpart__[] = Base.VERSION >= v"1.12.0-DEV.2047" && Preferences.@load_preference("revise_structs", false)
    polling = get(ENV, "JULIA_REVISE_POLL", "0")
    if polling == "1"
        polling_files[] = watching_files[] = true
    end
    tracking_Main_includes[] = Base.get_bool_env("JULIA_REVISE_INCLUDE", false)
    # Correct line numbers for code moving around
    Base.update_stackframes_callback[] = update_stacktrace_lineno!
    if isdefined(Base, :methodloc_callback)
        Base.methodloc_callback[] = method_location
    end
    # Add `includet` to the compiled_modules (fixes #302)
    for m in methods(includet)
        push!(JuliaInterpreter.compiled_methods, m)
    end
    # Set up a repository for methods defined at the REPL
    id = PkgId(nothing, "@REPL")
    @lock revise_lock begin
        pkgdatas[id] = PkgData(id, nothing)
    end
    # Set the lookup callbacks
    CodeTracking.method_lookup_callback[] = get_def
    CodeTracking.expressions_callback[] = get_expressions

    # Watch the manifest file for changes
    mfile = manifest_file()
    if mfile !== nothing
        @lock revise_lock begin
            push!(watched_manifests, mfile)
            wmthunk = TaskThunk(watch_manifest, (mfile,))
            schedule(Task(wmthunk))
        end
    end
    push!(Base.include_callbacks, watch_includes)
    push!(Base.package_callbacks, watch_package_callback)

    mode = get(ENV, "JULIA_REVISE", "auto")
    if mode == "auto"
        pushfirst!(REPL.repl_ast_transforms, revise_first)
        # #664: once a REPL is started, it no longer interacts with REPL.repl_ast_transforms
        if active_repl_backend_available()
            push!(Base.active_repl_backend.ast_transforms, revise_first)
        else
            # wait for active_repl_backend to exist. Schedule the named function
            # directly (rather than `@async`, which wraps it in an anonymous
            # closure) so the task body carries a stable, precompilable signature.
            t = Task(wait_for_repl_backend)
            schedule(t)
            isdefined(Base, :errormonitor) && Base.errormonitor(t)
        end

        if isdefined(Main, :Atom)
            Atom = getfield(Main, :Atom)
            if Atom isa Module && isdefined(Atom, :handlers)
                setup_atom(Atom)
            end
        end
    end

    return nothing
end

const REVISE_ID = Base.PkgId(Base.UUID("295af30f-e4ad-537b-8983-00126c2a3abe"), "Revise")
function watch_package_callback(id::PkgId)
    # `Base.package_callbacks` fire immediately after module initialization, and
    # would fire on Revise itself. This is not necessary for most users, and has
    # the downside that the user doesn't get to the REPL prompt until
    # `watch_package` finishes compiling.  To prevent this, Revise hides the
    # actual `watch_package` method behind `frozen` (a world-pinned `invoke_in_world`),
    # whose runtime dispatch also delays compilation of everything `watch_package` requires,
    # leading to faster perceived startup times.
    if id != REVISE_ID
        frozen(watch_package, id)
    end
    return
end

function setup_atom(atommod::Module)::Nothing
    handlers = getfield(atommod, :handlers)
    for x in ["eval", "evalall", "evalshow", "evalrepl"]
        if haskey(handlers, x)
            old = handlers[x]
            Main.Atom.handle(x) do data
                revise()
                old(data)
            end
        end
    end
    return nothing
end

function add_revise_deps()
    # Populate CodeTracking data for dependencies and initialize watching on code that Revise depends on
    @lock revise_lock begin
        for mod in (CodeTracking, OrderedCollections, JuliaInterpreter, LoweredCodeUtils, Revise)
            id = PkgId(mod)
            pkgdata = parse_pkg_files(id)
            init_watching(pkgdata, srcfiles(pkgdata))
            pkgdatas[id] = pkgdata
        end
    end
    return nothing
end

include("precompile.jl")
_precompile_()

"""
    repo, repo_path = git_repo(path::AbstractString)

Return the `repo::LibGit2.GitRepo` containing the file or directory `path`.
`path` does not necessarily need to be the top-level directory of the
repository. Also returns the `repo_path` of the top-level directory for the
repository.
"""
function git_repo(path::AbstractString)
    if isfile(path)
        path = dirname(path)
    end
    while true
        # check if we are at the repo root
        git_dir = joinpath(path, ".git")
        if ispath(git_dir)
            return LibGit2.GitRepo(path), path
        end
        # traverse to parent folder
        previous = path
        path = dirname(path)
        if previous == path
            return nothing, path
        end
    end
end

function git_tree(repo::LibGit2.GitRepo, commit="HEAD")
    return LibGit2.GitTree(repo, "$commit^{tree}")
end
function git_tree(path::AbstractString, commit="HEAD")
    repo, _ = git_repo(path)
    return git_tree(repo, commit)
end

"""
    files = git_files(repo)

Return the list of files checked into `repo`.
"""
function git_files(repo::LibGit2.GitRepo)
    status = LibGit2.GitStatus(repo;
        status_opts=LibGit2.StatusOptions(flags=LibGit2.Consts.STATUS_OPT_INCLUDE_UNMODIFIED))
    files = String[]
    for i = 1:length(status)
        e = status[i]
        dd = unsafe_load(e.head_to_index)
        push!(files, unsafe_string(dd.new_file.path))
    end
    return files
end
Base.keys(tree::LibGit2.GitTree) = git_files(tree.owner)

"""
    Revise.git_source(file::AbstractString, reference)

Read the source-text for `file` from a git commit `reference`.
The reference may be a string, Symbol, or `LibGit2.Tree`.

# Example:

    Revise.git_source("/path/to/myfile.jl", "HEAD")
    Revise.git_source("/path/to/myfile.jl", :abcd1234)  # by commit SHA
"""
function git_source(file::AbstractString, reference)
    fullfile = abspath(file)
    tree = git_tree(fullfile, reference)
    # git uses Unix-style paths even on Windows
    filepath = replace(relpath(fullfile, LibGit2.path(tree.owner)),
                       Base.Filesystem.path_separator_re=>'/')
    return git_source(filepath, tree)
end

function git_source(file::AbstractString, tree::LibGit2.GitTree)
    local blob
    blob = tree[file]
    if blob === nothing
        # assume empty tree when tracking new files
        src = ""
    else
        src = LibGit2.content(blob)
    end
    return src
end

using Revise, Test
using Revise.CodeTracking
using Revise.LoweredCodeUtils

function reljpath(path)
    for subdir in ("base/", "stdlib/", "test/")
        s = split(path, subdir)
        if length(s) == 2
            return subdir * s[end]
        end
    end
    return path
end
function filepredicate(file, reffiles)
    bfile = Base.find_source_file(file)
    bfile === nothing && return false  # when the file is "none"
    return reljpath(bfile) ∈ reffiles
end
function signature_diffs(mod::Module, signatures; filepredicate=nothing)
    # `signatures` (CodeTracking.method_info) is keyed by `MethodInfoKey(mt, sig)`;
    # compare against the signature types it records.
    # Use an IdSet: an ==-hashed Set would dynamically dispatch on each distinct
    # signature type, minting (and natively compiling) a fresh MethodInstance per
    # signature — ~25ms x tens of thousands of signatures. Identity matching is
    # also what the pre-MethodInfoKey code did (method_info is an IdDict).
    sigkeys = Base.IdSet{Any}(k.sig for k in keys(signatures))
    extras = copy(sigkeys)
    modeval, modinclude = getfield(mod, :eval), getfield(mod, :include)
    failed = []
    nmethods = 0
    for fsym in names(mod; all=true)
        isdefined(mod, fsym) || continue
        f = getfield(mod, fsym)
        isa(f, Base.Callable) || continue
        (f === modeval || f === modinclude) && continue
        for m in methods(f)
            nmethods += 1
            if m.sig in sigkeys
                delete!(extras, m.sig)
            else
                if filepredicate !== nothing
                    filepredicate(String(m.file)) || continue # find signatures only in selected files
                end
                push!(failed, m.sig)
            end
        end
    end
    return failed, extras, nmethods
end
function extracttype(T)
    p1 = T.parameters[1]
    isa(p1, Type) && return p1
    isa(p1, TypeVar) && return p1.ub
    error("unrecognized type ", T)
end
if isdefined(Core, :TypeofVararg)
    istva(T) = isa(T, Core.TypeofVararg)
else
    istva(T) = false
end
function in_module_or_core(T, mod::Module)
    if isa(T, TypeVar)
        return in_module_or_core(T.ub, mod)
    end
    if isa(T, UnionAll)
        T = Base.unwrap_unionall(T)
    end
    T === Union{} && return true
    if isa(T, Union)
        in_module_or_core(T.a, mod) || return false
        return in_module_or_core(T.b, mod)
    end
    if istva(T)
        isdefined(T, :T) || return true
        return in_module_or_core(T.T, mod)
    end
    Tname = T.name
    if Tname.name === :Type
        return in_module_or_core(extracttype(T), mod)
    end
    Tmod = Tname.module
    return Tmod === mod || Tmod === Core
end

module Lowering end

@testset ":lambda expressions" begin
    ex = quote
        mutable struct InnerC
            x::Int
            valid::Bool

            function InnerC(x; notvalid::Bool=false)
                return new(x, !notvalid)
            end
        end
    end
    mt_sigs, _ = Revise.eval_with_signatures(Lowering, ex)
    @test length(mt_sigs) >= 2
end

try # Suppress world age increments, since the instantiation messes with base
    basefiles = Set{String}()
    @time for (i, (mod, file)) in enumerate(Base._included_files)
        (endswith(file, "sysimg.jl") || endswith(file, "Base.jl") ) && continue
        Base.VERSION < v"1.7" && Sys.iswindows() && endswith(file, "RNGs.jl") && continue  # invalid redefinition of constant RandomDevice
        file = Revise.fixpath(file)
        push!(basefiles, reljpath(file))
        mexs = Revise.parse_and_maybe_eval_source(file, mod).modexinfos
        Revise.instantiate_sigs!(mexs; always_rethrow=true)
    end
    failed, extras, nmethods = signature_diffs(Base, CodeTracking.method_info; filepredicate = fn->filepredicate(fn, basefiles))
    # In some cases, the above doesn't really select the file-of-origin. For example, anything
    # defined with an @enum gets attributed to Enum.jl rather than the file in which @enum is used.
    realfailed = similar(failed, 0)
    for sig in failed
        ft = Base.unwrap_unionall(sig).parameters[1]
        match(r"^getfield\(Base, Symbol\(\"##\d", string(ft)) === nothing || continue  # exclude anonymous functions
        all(T->in_module_or_core(T, Base), Base.unwrap_unionall(sig).parameters[2:end]) || continue
        push!(realfailed, sig)
    end
    if true   # change to true to see the failures
        world = Base.get_world_counter()
        for tt in realfailed
            println(tt)
            mms = Base._methods_by_ftype(tt, -1, world)
            for mm in mms
                println(mm.method)
            end
        end
    end
    @test length(realfailed) < 60  # big enough for some cushion in case new "difficult" methods get added
catch org_err
    try
        Base.invokelatest(display_error, Base.scrub_repl_backtrace(Base.current_exceptions()))
    catch err
        Core.println(org_err)
    end
end

# Test that one can overload `Revise.parse_source!` and several Base methods to allow revision of
# non-Julia code.

using Revise
using Test

Revise.parsers[".program"] = function (filename::AbstractString)
    exprs = []
    for line in eachline(filename)
       val, name = split(line, '=')
       push!(exprs, :(function $(Symbol(name))() $val end))
    end
    Expr(:toplevel, :(baremodule fake_lang
       $(exprs...)
    end), :(using .fake_lang))
end

@testset "non-jl revisions" begin
    path = joinpath(@__DIR__, "test.program")
    try
        cp(joinpath(@__DIR__, "fake_lang", "test.program"), path, force=true)
        sleep(mtimedelay)
        includet(path)
        @yry()    # comes from test/common.jl
        @test fake_lang.y() == "2"
        @test fake_lang.x() == "1"
        sleep(mtimedelay)
        cp(joinpath(@__DIR__, "fake_lang", "new_test.program"), path, force=true)
        @yry()
        @test fake_lang.x() == "2"
        @test_throws MethodError fake_lang.y()
    finally
        rm(path, force=true)
    end
end

# This is primarily used to parse non-precompilable packages.
# These lack a cache header that lists the files that constitute the package;
# they also lack the source cache, and so have to parsed immediately or
# we won't be able to compute a diff when a file is modified (we don't have a record
# of what the source was before the modification).
#
# The main trick here is that since `using` is recursive, `included_files`
# might contain files associated with many different packages. We have to figure
# out which correspond to a particular module `mod`, which we do by:
#   - checking the module in which each file is evaluated. This suffices to
#     detect "supporting" files, i.e., those `included` within the module
#     definition.
#   - checking the filename. The top-level file of a non-precompiled package
#     is `include`d into `Base.__toplevel__` (see `Base._require` in
#     `loading.jl`), so module-of-evaluation can't identify it. Here we hope
#     that the top-level filename follows convention and matches the module.
#
# We pass `Base.__toplevel__` through to `parse_and_maybe_eval_source` unchanged. `ExprSplitter`
# has a dedicated `loaded_modules` fallback for that case which resolves
# `module PkgName ... end` to the real loaded module even when `PkgName` is not
# a direct dep of the active project. Rewriting to `Main` here would skip that
# fallback and synthesize an empty `Main.PkgName` stub (#961).
function queue_includes!(pkgdata::PkgData, id::PkgId)
    modstring = id.name
    @lock revise_lock begin
        delids = Int[]
        for i = 1:length(included_files)
            mod, fname = included_files[i]
            modname = String(Symbol(mod))
            if startswith(modname, modstring) || endswith(fname, modstring*".jl")
                mapexpr = include_mapexpr_for(mod, fname)
                pr = parse_and_maybe_eval_source(fname, mod; mapexpr)
                if pr.success
                    fname = relpath(fname, pkgdata)
                    push!(pkgdata, fname=>FileInfo(pr.modexinfos; mapexpr))
                end
                push!(delids, i)
            end
        end
        deleteat!(included_files, delids)
    end
    CodeTracking._pkgfiles[id] = pkgdata.info
    return pkgdata
end

function queue_includes(mod::Module)
    id = PkgId(mod)
    pkgdata = get(pkgdatas, id, nothing)
    if pkgdata === nothing
        pkgdata = PkgData(id)
    end
    queue_includes!(pkgdata, id)
    if has_writable_paths(pkgdata)
        init_watching(pkgdata)
    end
    @lock revise_lock pkgdatas[id] = pkgdata
    return pkgdata
end

# A near-duplicate of some of the functionality of queue_includes!
# This gets called for silenced packages, to make sure they don't "contaminate"
# included_files
function remove_from_included_files(modsym::Symbol)
    i = 1
    modstring = string(modsym)
    @lock revise_lock begin
        while i <= length(included_files)
            mod, fname = included_files[i]
            modname = String(Symbol(mod))
            if startswith(modname, modstring) || endswith(fname, modstring*".jl")
                deleteat!(included_files, i)
            else
                i += 1
            end
        end
    end
end

read_from_cache(pkgdata::PkgData, file::AbstractString) =
    read_from_cache(pkgdata, file, fileinfo(pkgdata, file))
function read_from_cache(pkgdata::PkgData, file::AbstractString, fi::FileInfo)
    filep = joinpath(basedir(pkgdata), file)
    if fi.cachefile == basesrccache
        # Get the original path
        filec = get(cache_file_key, filep, filep)
        return open(basesrccache) do io
            Base._read_dependency_src(io, filec)
        end
    end
    # `read_dependency_src` matches paths by exact string equality, so look the source
    # up by the filename the cache was indexed with rather than one reconstructed from
    # `basedir` (which can diverge in form, e.g. across symlinks; see #1033).
    lookup = isempty(fi.cachefilename) ? filep : fi.cachefilename
    io = pkgdata.cacheio
    io === nothing && return Base.read_dependency_src(fi.cachefile, lookup)
    seekstart(io)
    iszero(Base.isvalid_cache_header(io)) && throw(ArgumentError("invalid header in cache file $(fi.cachefile)"))
    return Base.read_dependency_src(io, fi.cachefile, lookup)
end

# Whether this platform and Julia version support keeping the snapshot alive with an open
# handle. On Windows a held handle can block the other process from replacing the file, and
# reading a cache through a handle needs the header API of Julia 1.11+.
can_hold_cache() = !Sys.iswindows() && VERSION >= v"1.11.0-DEV.683"

"""
    Revise.hold_cache!(pkgdata)

Keep a handle open on `pkgdata`'s precompile cache file, so that the source snapshot it
holds stays readable for as long as the session runs.

Julia replaces a cache file by renaming a freshly built one over it. On platforms where
that leaves existing handles attached to the original file, a handle opened here still
reads the snapshot this session loaded even after another process rebuilds the cache;
[`Revise.cache_snapshot_is_valid`](@ref) then finds the cache intact and revision
proceeds normally. Where a held handle would instead block the other process from
replacing the file, no handle is taken and the rebuild is handled by detection.
"""
function hold_cache!(pkgdata::PkgData)
    can_hold_cache() || return pkgdata
    pkgdata.cacheio === nothing || return pkgdata
    isempty(srcfiles(pkgdata)) && return pkgdata
    cachefile = fileinfo(pkgdata, 1).cachefile
    (isempty(cachefile) || cachefile == basesrccache) && return pkgdata
    pkgdata.cacheio = try
        open(cachefile, "r")
    catch
        nothing
    end
    return pkgdata
end

# Identifies the source text a precompile cache holds for one file, so that a cache
# rebuilt from unchanged source is recognized as still carrying the same snapshot.
# Julia 1.11+ records a size and a content hash; 1.10 records only the source file's
# mtime, so on that version a file merely touched between two builds reads as changed.
@static if VERSION >= v"1.11.0-DEV.683"    # https://github.com/JuliaLang/julia/pull/49866
    cache_src_id(inc) = hash(inc.fsize, UInt64(inc.hash))
else
    cache_src_id(inc) = hash(inc.mtime)
end

function maybe_parse_from_cache!(pkgdata::PkgData, file::AbstractString)
    if startswith(file, "REPL[")
        return add_definitions_from_repl(file)
    end
    return maybe_parse_from_cache!(pkgdata, file, fileinfo(pkgdata, file))
end
"""
    Revise.cache_snapshot_is_valid(pkgdata) -> Bool

Whether the precompile cache Revise reads `pkgdata`'s source snapshots from is still the
one this session loaded. Every precompilation mints a new build id, so a cache whose
build id has changed, or that has gone missing, was rebuilt or removed by another
process. A handle held by [`Revise.hold_cache!`](@ref) keeps the original readable, in
which case the check passes and nothing is lost; otherwise the individual files that
changed between the two builds lose their baseline (see
[`Revise.cached_source_is_current`](@ref)).
"""
function cache_snapshot_is_valid(pkgdata::PkgData)
    pkgdata.cachebuildid == 0 && return true   # not loaded from a cache; nothing to compare against
    cachedata = current_cachedata(pkgdata)
    cachedata === nothing && return false
    _, _, _, buildid = cachedata
    return buildid == pkgdata.cachebuildid
end

# Header of the cache Revise can still read for this package: through the held handle when
# there is one, since that reports the file the handle is attached to rather than whatever
# now occupies the path.
function current_cachedata(pkgdata::PkgData)
    io = pkgdata.cacheio
    io === nothing && return pkg_fileinfo(PkgId(pkgdata))
    return pkg_fileinfo(PkgId(pkgdata), fileinfo(pkgdata, 1).cachefile, io)
end

"""
    Revise.cached_source_is_current(pkgdata, fi) -> Bool

Whether the source snapshot Revise can still read for the file described by `fi` is the
one this session loaded. A cache rebuilt from unchanged source carries the same snapshot
and remains a valid baseline; only the files whose content differs between the build this
session loaded and the build now on disk lose theirs.
"""
function cached_source_is_current(pkgdata::PkgData, fi::FileInfo)
    cache_snapshot_is_valid(pkgdata) && return true
    fi.cachesrcid === nothing && return false     # nothing recorded to compare against
    cachedata = current_cachedata(pkgdata)
    cachedata === nothing && return false
    _, includes, _, _ = cachedata
    for inc in includes
        inc.filename == fi.cachefilename && return cache_src_id(inc) == fi.cachesrcid
    end
    return false
end

# Record the loss and warn once per package, then let the caller report the individual
# files. A package listed here keeps the prompt yellow for the rest of the session.
function note_rewritten_cache(id::PkgId)
    isnew = @lock revise_lock (id ∈ rewritten_caches ? false : (push!(rewritten_caches, id); true))
    isnew || return nothing
    @warn """The precompile cache of $(id.name) was rebuilt by another process after this session loaded it, and the source it held for one or more edited files is gone.
        Revise compares an edit against the source the session loaded, so for those files there is nothing to compare against and no revision is attempted; each one is reported separately.
        Other files of $(id.name), and every other package, continue to revise normally. Your prompt color will be yellow for the rest of this session; restart Julia to pick up the current state of the affected files."""
    return nothing
end

function maybe_parse_from_cache!(pkgdata::PkgData, file::AbstractString, fi::FileInfo)
    if (isempty(fi.mod_exs_infos) && !fi.parsed[]) && (!isempty(fi.cachefile) || !isempty(fi.cacheexprs))
        if !isempty(fi.cachefile) && !cached_source_is_current(pkgdata, fi)
            id = PkgId(pkgdata)
            note_rewritten_cache(id)
            throw(StaleCacheError(id, joinpath(basedir(pkgdata), file)))
        end
        # Source was never parsed, get it from the precompile cache
        src = read_from_cache(pkgdata, file, fi)
        filep = joinpath(basedir(pkgdata), file)
        filec = get(cache_file_key, filep, filep)
        topmod = first(keys(fi.mod_exs_infos))
        pr = parse_and_maybe_eval_source!(fi.mod_exs_infos, src, filec, topmod; mapexpr=fi.mapexpr)
        if !pr.success
            @error "failed to parse cache file source text for $file"
        end
        if !pr.donotparse
            add_modexs!(fi, fi.cacheexprs)
            empty!(fi.cacheexprs)
        end
        fi.parsed[] = true
    end
    return fi
end

# Reading the cache to look up where something was defined is best-effort: a file whose
# snapshot is gone has no definitions to report. The loss is raised where it matters,
# when the file is actually being revised.
function try_parse_from_cache!(pkgdata::PkgData, file::AbstractString)
    try
        return maybe_parse_from_cache!(pkgdata, file)
    catch err
        err isa StaleCacheError || rethrow()
        return nothing
    end
end

function add_modexs!(fi::FileInfo, modexs::Vector{Tuple{Module,Expr}})
    for (mod, rex) in modexs
        exs_infos = get(fi.mod_exs_infos, mod, nothing)
        if exs_infos === nothing
            fi.mod_exs_infos[mod] = exs_infos = ExprsInfos()
        end
        pushex!(exs_infos, rex)
    end
    return fi
end

function maybe_extract_sigs!(fi::FileInfo)
    if !fi.extracted[]
        instantiate_sigs!(fi.mod_exs_infos)
        fi.extracted[] = true
    end
    return fi
end
maybe_extract_sigs!(pkgdata::PkgData, file::AbstractString) = maybe_extract_sigs!(fileinfo(pkgdata, file))

# Signature extraction lowers and partially evaluates each top-level expression. For
# macro-generated code this can be fragile to re-lowering: JLLWrappers builds a `let`
# block that defines and immediately calls gensym'd closures, and re-`:sigs` after the
# package is already loaded can leave the closure's call method undefined for the freshly
# minted closure type (issue #706). The package is already loaded and correct, so on
# failure record the error the same way `revise()` does and keep going, rather than
# letting it abort the manifest watcher.
function maybe_extract_sigs_or_queue_error!(pkgdata::PkgData, file::AbstractString, fi::FileInfo)
    try
        maybe_extract_sigs!(fi)
    catch err
        isa(err, InterruptException) && rethrow(err)
        @lock revise_lock queue_errors[(pkgdata, file)] = (err, catch_backtrace())
    end
    return fi
end

is_not_populated(fi::FileInfo) =
    (isempty(fi.mod_exs_infos) && !fi.parsed[]) && (!isempty(fi.cachefile) || !isempty(fi.cacheexprs))

function maybe_extract_sigs_for_meths(meths)
    for m in meths
        methinfo = get(CodeTracking.method_info, MethodInfoKey(m), false)
        if methinfo === false
            pkgdata = get(pkgdatas, PkgId(m.module), nothing)
            pkgdata === nothing && continue
            for file in srcfiles(pkgdata)
                fi = fileinfo(pkgdata, file)
                if is_not_populated(fi)
                    fi = try_parse_from_cache!(pkgdata, file)
                    fi === nothing || instantiate_sigs!(fi.mod_exs_infos)
                end
            end
        end
    end
end

function maybe_extract_sigs_for_types(types)
    for ty in types
        m = parentmodule(ty)
        pkgdata = get(pkgdatas, PkgId(m), nothing)
        pkgdata === nothing && continue
        for file in srcfiles(pkgdata)
            fi = fileinfo(pkgdata, file)
            if is_not_populated(fi)
                fi = try_parse_from_cache!(pkgdata, file)
                fi === nothing || instantiate_sigs!(fi.mod_exs_infos)
            end
        end
    end
end

function maybe_add_includes_to_pkgdata!(pkgdata::PkgData, file::AbstractString, includes; eval_now::Bool=false)
    for (mod, mapexpr, inc) in includes
        inc = joinpath(splitdir(file)[1], inc)
        incrp = relpath(inc, pkgdata)
        hasinclude = false
        # An entry for the same path and destination module whose `mapexpr` differs:
        # the `include(mapexpr, ...)` statement was edited (or its closure was
        # recreated when the including statement was re-evaluated), so that entry
        # describes a transform that is no longer in the source.
        stale_idx = 0
        for (i, srcfile) in enumerate(srcfiles(pkgdata))
            srcfile == incrp || continue
            fi = pkgdata.fileinfos[i]
            if fi.mapexpr === mapexpr
                hasinclude = true
                break
            elseif stale_idx == 0 && first(keys(fi.mod_exs_infos)) === mod
                stale_idx = i
            end
        end
        if hasinclude
            # Already registered, but the watch may have been relinquished while
            # the file's directory was absent (e.g. a branch switch removed it
            # past `watch_reappear_grace`); an `include` of the file in revised
            # code is the signal to resume. Filesystem events were lost while
            # the watch was down — the stored state (including any deletion of
            # the file's methods) cannot be trusted — so bring the file current
            # before re-arming the watch.
            if !iswatched(pkgdata, incrp)
                revise_file_now(pkgdata, incrp)
                init_watching(pkgdata, (incrp,))
            end
        elseif stale_idx != 0
            fi = pkgdata.fileinfos[stale_idx]
            # The stored expressions must describe what is currently loaded, which was
            # produced by the *old* transform: reconstruct them from the source snapshot
            # in the precompile cache before swapping in the new transform. (Parsing
            # after the swap would apply the new transform to the old source, making the
            # subsequent diff vacuous and leaving the session stale.)
            maybe_parse_from_cache!(pkgdata, incrp, fi)
            pkgdata.fileinfos[stale_idx] = FileInfo(fi.mod_exs_infos, mapexpr, fi.cachefile, fi.cachefilename,
                                                    fi.cachesrcid, fi.cacheexprs, fi.extracted, fi.parsed)
            # Re-diff the file under the new transform so the session catches up with
            # the new effective source.
            if eval_now
                revise_file_now(pkgdata, incrp)
            else
                @lock revise_lock push!(revision_queue, (pkgdata, incrp))
            end
            if !iswatched(pkgdata, incrp)
                init_watching(pkgdata, (incrp,))
            end
        else
            # Add the file to pkgdata
            push!(pkgdata.info.files, incrp)
            fi = FileInfo(mod; mapexpr)
            push!(pkgdata.fileinfos, fi)
            # Parse the source of the new file
            fullfile = joinpath(basedir(pkgdata), incrp)
            if isfile(fullfile)
                parse_and_maybe_eval_source!(fi.mod_exs_infos, fullfile, mod; mapexpr)
                if eval_now
                    # Pin to Revise's frozen world (issue #552); `frozen`'s runtime dispatch
                    # also reduces latency.
                    frozen(instantiate_sigs!, fi.mod_exs_infos; mode=:eval)
                end
            end
            # Add to watchlist
            init_watching(pkgdata, (incrp,))
            yield()
        end
    end
end

# Is `file` (relative to `pkgdata`) registered with a directory watcher? A live
# watch must be left untouched by re-registration attempts: `init_watching`
# resets the file's ctime baseline, which is owned by the watcher task.
function iswatched(pkgdata::PkgData, file::AbstractString)
    dir, basename = splitdir(String(file)::String)
    dirfull = joinpath(basedir(pkgdata), dir)
    return @lock revise_lock begin
        wl = get(watched_files, dirfull, nothing)
        wl !== nothing && haskey(wl.trackedfiles, basename)
    end
end

# `@require` blocks are tracked under a synthetic filename built by appending this
# suffix to the real source file (see `add_require`). Such keys have no file on disk,
# so any path-based operation (reading, watching) must skip them.
const requires_suffix = "__@require__"
is_requires_file(file::AbstractString) = endswith(file, requires_suffix)

# This is used by Requires.jl: therefore even if it appears unused by Revise.jl,
# it cannot be removed as long as we support integration with Requires.jl
function add_require(sourcefile::String, modcaller::Module, idmod::String, ::String, expr::Expr)
    id = PkgId(modcaller)
    # If this fires when the module is first being loaded (because the dependency
    # was already loaded), Revise may not yet have the pkgdata for this package.
    if !haspkgdata(id)
        watch_package(id)
    end

    @lock revise_lock begin
        # Get/create the FileInfo specifically for tracking @require blocks
        pkgdata = pkgdatas[id]
        filekey = relpath(sourcefile, pkgdata) * requires_suffix
        fileidx = fileindex(pkgdata, filekey)
        if fileidx === nothing
            files = srcfiles(pkgdata)
            fileidx = length(files) + 1
            push!(files, filekey)
            push!(pkgdata.fileinfos, FileInfo(modcaller))
        end
        fi = pkgdata.fileinfos[fileidx]
        # Tag the expr to ensure it is unique
        expr = Expr(:block, copy(expr))
        push!(expr.args, :(const __pkguuid__ = $idmod))
        # Add the expression to the fileinfo
        complex = true     # is this too complex to delay?
        if !fi.extracted[]
            # If we haven't yet extracted signatures, do our best to avoid it now in case the
            # signature-extraction code has not yet been compiled (latency reduction)
            includes, complex = deferrable_require(expr)
            if !complex
                # [(modcaller, identity, inc) for inc in includes] but without precompiling a Generator
                modincludes = Tuple{Module,Function,String}[]
                for inc in includes
                    push!(modincludes, (modcaller, identity, inc))
                end
                maybe_add_includes_to_pkgdata!(pkgdata, filekey, modincludes)
                if isempty(fi.mod_exs_infos)
                    # Source has not even been parsed
                    push!(fi.cacheexprs, (modcaller, expr))
                else
                    add_modexs!(fi, Tuple{Module,Expr}[(modcaller, expr)])
                end
            end
        end
        if complex
            frozen(eval_require_now, pkgdata, fileidx, filekey, sourcefile, modcaller, expr)
        end
    end
end

function deferrable_require(expr::Expr)
    includes = String[]
    complex = deferrable_require!(includes, expr)
    return includes, complex
end
function deferrable_require!(includes, expr::Expr)
    if expr.head === :call
        callee = expr.args[1]
        if is_some_include(callee)
            if isa(expr.args[2], AbstractString)
                push!(includes, expr.args[2])
            else
                return true
            end
        elseif callee === :eval || (isa(callee, Expr) && callee.head === :. && is_quotenode_egal(callee.args[2], :eval))
            # Any eval statement is suspicious and requires immediate action
            return false
        end
    end
    expr.head === :macrocall && expr.args[1] === Symbol("@eval") && return true
    for a in expr.args
        a isa Expr || continue
        deferrable_require!(includes, a) && return true
    end
    return false
end

function eval_require_now(pkgdata::PkgData, fileidx::Int, filekey::String, sourcefile::String, modcaller::Module, expr::Expr)
    fi = pkgdata.fileinfos[fileidx]
    exs_infos_new = ExprsInfos()
    exs_infos_new[RelocatableExpr(expr)] = nothing
    mod_exs_infos_new = ModuleExprsInfos(modcaller=>exs_infos_new)
    # Before executing the expression we need to set the load path appropriately
    prev = Base.source_path(nothing)
    tls = task_local_storage()
    tls[:SOURCE_PATH] = sourcefile
    # Now execute the expression
    mod_exs_infos_new, includes = try
        eval_new!(mod_exs_infos_new, fi.mod_exs_infos)
    finally
        if prev === nothing
            delete!(tls, :SOURCE_PATH)
        else
            tls[:SOURCE_PATH] = prev
        end
    end
    # Add any new methods or `include`d files to tracked objects
    pkgdata.fileinfos[fileidx] = FileInfo(mod_exs_infos_new, fi)
    ret = maybe_add_includes_to_pkgdata!(pkgdata, filekey, includes; eval_now=true)
    return ret
end

# Block until `dirname` reports filesystem activity. Returns the set of entry
# names the events identified, or `nothing` when the changed entries are not
# known (polling mode, a torn-down monitor, or an event that did not name its
# file) -- a `nothing` return means "anything in the directory may have
# changed".
#
# On notifying filesystems this uses a *persistent, buffered* `FolderMonitor`
# (`watch_folder`): the OS watch stays registered between calls and queues every
# event, so a change that lands while we are busy enqueueing a previous one is
# retained rather than dropped. This is the crucial difference from `watch_file`,
# which arms a fresh one-shot monitor per call and silently loses anything that
# occurs in the gap between calls -- a dominant source of missed revisions on
# macOS FSEvents under load.
#
# On polling/non-notifying filesystems we keep the existing directory poll.
function wait_changed_dir(dirname::AbstractString)
    if polling_files[] || nonnotifying_path(dirname)
        wait_changed(dirname)  # unchanged poll behavior
        return nothing
    end
    changed = Set{String}()
    complete = true
    try
        name, _ = watch_folder(dirname)              # block for the next buffered event
        isempty(name) ? (complete = false) : push!(changed, name)
        while true                                   # drain a burst delivered in one wakeup
            name, event = watch_folder(dirname, 0)
            event.timedout && break
            isempty(name) ? (complete = false) : push!(changed, name)
        end
    catch e
        # EOFError: monitor torn down; let caller re-check state. issue #459: Ctrl-C.
        e isa EOFError || (isa(e, InterruptException) && throwto_repl(e)) || throw(e)
        return nothing
    end
    return complete ? changed : nothing
end

# Content hash for disambiguating events whose ctime is unchanged. Reads the
# file, so call it only on event-named files, not in the per-directory sweep.
filehash(path::AbstractString) = open(crc32c, path)

# Scan the `tracked` `name=>PkgId` pairs of directory `dirname`, returning those
# whose files should be queued for revision. `changed` is the set of entry names
# reported by the filesystem events (`nothing` if unknown).
#
# The primary change test compares ctimes, but the kernel stamps inodes with
# tick-resolution (often ~10ms) timestamps, so a delete-and-recreate that lands
# within one tick of the recorded ctime is invisible to it (#945). For a file
# named in an event, an unchanged ctime therefore means either a duplicate
# notification of a change already queued (a single save delivers several
# events, possibly across wakeups) or a same-tick rewrite; only content
# distinguishes the two, so those files are settled by comparing a stored
# hash. Hashes are recorded when a file is queued — an absent hash reads as
# changed, keeping the failure mode "spurious no-op revision", never a missed
# one. The timestamp sweep is unchanged for files the events did not name.
function scan_changed_files(dirname::AbstractString, wf::WatchList, tracked, changed::Union{Nothing,Set{String}})
    latestfiles = Pair{String,PkgId}[]
    for (file, id) in tracked
        fullpath = joinpath(dirname, file)
        if isdir(fullpath)
            # Detected a modification in a directory that we're watching in
            # itself (not as a container for watched files)
            push!(latestfiles, file=>id)
            continue
        elseif !file_exists(fullpath)
            # File may have been deleted. But check again after a very brief pause.
            sleep(0.1)
            if !file_exists(fullpath)
                # Queue the disappearance only once (stored ctime 0.0 marks it
                # as already queued); a sibling-file event must not requeue a
                # persistently missing file. The stored value reverts to a real
                # ctime when the file reappears.
                if (@lock revise_lock get(wf.file_ctimes, file, NaN)) != 0.0
                    push!(latestfiles, file=>id)
                    @lock revise_lock wf.file_ctimes[file] = 0.0
                end
                continue
            end
        end
        current_ctime = ctime(fullpath)
        queueit = current_ctime != @lock revise_lock get(wf.file_ctimes, file, current_ctime - 1)
        if !queueit && changed !== nothing && file in changed
            h = filehash(fullpath)
            queueit = h != @lock revise_lock get(wf.file_hashes, file, h + 1)
        end
        if queueit
            push!(latestfiles, file=>id)
            h = filehash(fullpath)
            @lock revise_lock begin
                wf.file_ctimes[file] = current_ctime
                wf.file_hashes[file] = h
            end
        end
    end
    return latestfiles
end

function watch_files_via_dir(dirname::AbstractString)
    changed = wait_changed_dir(dirname)  # block until the directory changes (buffered on notifying filesystems)
    # Snapshot the tracked files under the lock. We then do the (potentially
    # blocking) filesystem checks below without holding it, reacquiring only to
    # read/update ctimes, so we never hold `revise_lock` across `sleep`.
    snap = @lock revise_lock begin
        wf = get(watched_files, dirname, nothing)
        wf === nothing ? nothing : (wf, collect(wf.trackedfiles))
    end
    snap === nothing && return Pair{String,PkgId}[], false
    wf, tracked = snap
    return scan_changed_files(dirname, wf, tracked, changed), true
end

"""
    watch_package(id::Base.PkgId)

Start watching a package for changes to the files that define it.
This function gets called via a callback registered with `Base.require`, at the completion
of module-loading by `using` or `import`.
"""
function watch_package(id::PkgId)
    # we may have switched environments, so make sure we're watching the right manifest
    active_project_watcher()

    return @lock revise_lock begin
        local pkgdata = get(pkgdatas, id, nothing)
        pkgdata !== nothing && return pkgdata
        modsym = Symbol(id.name)
        if modsym ∈ dont_watch_pkgs
            if id.name ∉ silence_pkgs
                @warn "$modsym is excluded from watching by Revise. Use Revise.silence(\"$modsym\") to quiet this warning."
            end
            remove_from_included_files(modsym)
            return nothing
        end
        pkgdata = parse_pkg_files(id)
        if has_writable_paths(pkgdata)
            init_watching(pkgdata, srcfiles(pkgdata))
            hold_cache!(pkgdata)
        end
        pkgdatas[id] = pkgdata
        pkgdata
    end
end

function has_writable_paths(pkgdata::PkgData)
    dir = basedir(pkgdata)
    isdir(dir) || return true
    haswritable = false
    # Compatibility note:
    # The following can be written in cd(dir) do ... end block
    # but that would trigger Julia to crash for some corner cases.
    # This is identified on Julia 1.7.3 + modified ubuntu 18.04, and it is
    # verified that doesn't happen for Julia 1.9.2 on the same machine.
    current_dir = pwd()
    try
        cd(dir)
        for file in srcfiles(pkgdata)
            haswritable |= iswritable(file)
        end
    finally
        cd(current_dir)
    end
    return haswritable
end

function watch_includes(mod::Module, fn::AbstractString)
    @lock revise_lock push!(included_files, (mod, abspath_no_normalize(fn)))
end

## Working with Pkg and code-loading

# Much of this is adapted from base/loading.jl

function manifest_file(project_file = Base.active_project())
    if project_file isa String && isfile(project_file)
        mfile = Base.project_file_manifest_path(project_file)
        if mfile isa String
            return mfile
        end
    end
    return nothing
end

function manifest_paths!(pkgpaths::Dict, manifest_file::String)
    d = if isdefined(Base, :get_deps) # `get_deps` is present in versions that support new manifest formats
        Base.get_deps(Base.parsed_toml(manifest_file))
    else
        Base.parsed_toml(manifest_file)
    end
    for (name, entries) in d
        entries::Vector{Any}
        for entry in entries
            id = PkgId(UUID(entry["uuid"]::String), name)
            path = Base.explicit_manifest_entry_path(manifest_file, id, entry)
            if path isa String
                if isfile(path)
                    # Workaround for #802
                    path = dirname(dirname(path))
                end
                pkgpaths[id] = path
            end
        end
    end
    return pkgpaths
end

manifest_paths(manifest_file::String) =
    manifest_paths!(Dict{PkgId,String}(), manifest_file)

function watch_manifest(mfile::String)
    while true
        try
            wait_changed(mfile)
        catch e
            # issue #459
            (isa(e, InterruptException) && throwto_repl(e)) || throw(e)
        end
        manifest_file() == mfile || continue   # process revisions only if this is the active manifest
        try
            with_logger(_debug_logger) do
                @debug "Pkg" _group="manifest_update" manifest_file=mfile
                isfile(mfile) || return nothing
                pkgdirs = manifest_paths(mfile)
                pathreplacements = Pair{String,String}[]
                @lock revise_lock begin
                    for (id, pkgdir) in pkgdirs
                        if haskey(pkgdatas, id)
                            pkgdata = pkgdatas[id]
                            if !samefile(pkgdir, basedir(pkgdata))
                                ## The package directory has changed
                                @debug "Pkg" _group="pathswitch" oldpath=basedir(pkgdata) newpath=pkgdir
                                push!(pathreplacements, basedir(pkgdata)=>pkgdir)
                                switch_basepath(pkgdata, pkgdir)
                            end
                        end
                    end
                    # Update the paths in the watchlist
                    for (oldpath, newpath) in pathreplacements
                        for (_, pkgdata) in pkgdatas
                            if samefile(basedir(pkgdata), oldpath)
                                switch_basepath(pkgdata, newpath)
                            end
                        end
                    end
                end
            end
        catch err
            @error "Error watching manifest" exception=(err, trim_toplevel!(catch_backtrace()))
        end
    end
end

# Return `true` if both paths are files with identical contents.
function same_contents(file1::AbstractString, file2::AbstractString)
    (isfile(file1) && isfile(file2)) || return false
    filesize(file1) == filesize(file2) || return false
    return read(file1) == read(file2)
end

function switch_basepath(pkgdata::PkgData, newpath::String)
    oldpath = basedir(pkgdata)
    # Stop all associated watching tasks
    for dir in unique_dirs(srcfiles(pkgdata))
        @debug "Pkg" _group="unwatch" dir=dir
        @lock revise_lock delete!(watched_files, joinpath(oldpath, dir))
        # Note: if the file is revised, the task(s) will run one more time.
        # However, because we've removed the directory from the watch list this will be a no-op,
        # and then the tasks will be dropped.
    end
    # Revise code as needed
    watchfiles = String[]
    mustnotify = false
    for file in srcfiles(pkgdata)
        # issue #678: `@require` blocks are tracked under a synthetic filename with no
        # file on disk; reading or watching it as a real path would error.
        is_requires_file(file) && continue
        push!(watchfiles, file)
        # A file that is byte-identical in the new directory defines what the module
        # already contains, so there is nothing to revise. Skipping it also avoids the
        # signature extraction below, which re-executes macro expansions that define
        # types or constants; those error when the definition is already present.
        same_contents(joinpath(oldpath, file), joinpath(newpath, file)) && continue
        fi = try
            maybe_parse_from_cache!(pkgdata, file)
        catch err
            if err isa StaleCacheError
                # No baseline to diff the new location against, and the old source on disk
                # is not one either. Queue the file so `revise` reports the loss.
                @lock revise_lock push!(revision_queue, (pkgdata, file))
                mustnotify = true
                continue
            end
            # https://github.com/JuliaLang/julia/issues/42404
            # Get the source-text from the package source instead
            fi = fileinfo(pkgdata, file)
            if isempty(fi.mod_exs_infos) && (!isempty(fi.cachefile) || !isempty(fi.cacheexprs))
                filep = joinpath(oldpath, file)
                src = read(filep, String)
                topmod = first(keys(fi.mod_exs_infos))
                if !parse_and_maybe_eval_source!(fi.mod_exs_infos, src, filep, topmod; mapexpr=fi.mapexpr).success
                    @error "failed to parse source text for $filep"
                end
                add_modexs!(fi, fi.cacheexprs)
                empty!(fi.cacheexprs)
                fi.parsed[] = true
            end
            fi
        end
        maybe_extract_sigs_or_queue_error!(pkgdata, file, fi)
        @lock revise_lock push!(revision_queue, (pkgdata, file))
        mustnotify = true
    end
    mustnotify && notify(revision_event)
    # Update the directory
    pkgdata.info.basedir = newpath
    # Restart watching, if applicable
    if has_writable_paths(pkgdata)
        init_watching(pkgdata, watchfiles)
    end
    return nothing
end

function active_project_watcher()
    mfile = manifest_file()
    isnothing(mfile) && return
    @lock revise_lock begin
        mfile ∈ watched_manifests && return
        push!(watched_manifests, mfile)
    end
    wmthunk = TaskThunk(watch_manifest, (mfile,))
    schedule(Task(wmthunk))
    return
end

# How Revise works

In addition to the material below, see these talks:
- [JuliaCon 2018](https://www.youtube.com/watch?v=KuM0AGaN09s)
- [JuliaCon 2019](https://www.youtube.com/watch?v=gXDI4DSp04c)

Revise is based on the fact that you can change functions even when
they are defined in other modules.
Here's an example showing how you do that manually (without using Revise):

```julia-repl
julia> convert(Float64, π)
3.141592653589793

julia> # That's too hard, let's make life easier for students

julia> @eval Base convert(::Type{Float64}, x::Irrational{:π}) = 3.0
convert (generic function with 714 methods)

julia> convert(Float64, π)
3.0
```

Revise removes some of the tedium of manually copying and pasting code
into `@eval` statements.
To decrease the amount of re-JITting
required, Revise avoids reloading entire modules; instead, it takes care
to `eval` only the *changes* in your package(s), much as you would if you were
doing it manually.
Importantly, changes are detected in a manner that is independent of the specific
line numbers in your code, so that you don't have to re-evaluate just
because code moves around within the same file.
(One unfortunate side effect is that line numbers may become inaccurate in backtraces,
but Revise takes pains to correct these, see below.)

Conceptually, Revise implements
[`diff` and `patch`](https://opensource.com/article/18/8/diffs-patches)
for a running Julia session. Schematically, Revise's inner loop (`revise()`) looks like this:

```julia
for def in setdiff(oldexprs, newexprs)
    # `def` is an expression that defines a method.
    # It was in `oldexprs`, but is no longer present in `newexprs`--delete the method.
    delete_methods_corresponding_to_defexpr(mod, def)
end
for def in setdiff(newexprs, oldexprs)
    # `def` is an expression for a new or modified method. Instantiate it.
    Core.eval(mod, def)
end
```

In somewhat greater detail, Revise uses the following overall strategy:

- add callbacks to Base so that Revise gets notified when new
  packages are loaded or new files `include`d
- prepare source-code caches for every new file. These caches
  will allow Revise to detect changes when files are updated. For precompiled
  packages this happens on an as-needed basis, using the cached
  source in the `*.ji` file. For non-precompiled packages, Revise parses
  the source for each `include`d file immediately so that the initial state is
  known and changes can be detected.
- monitor the file system for changes to any of the dependent files;
  it immediately appends any updates to a list of file names that need future
  processing
- intercept the REPL's backend to ensure that the list of
  files-to-be-revised gets processed each time you execute a new
  command at the REPL
- when a revision is triggered, the source file(s) are re-parsed, and
  a diff between the cached version and the new version is
  created. `eval` the diff in the appropriate module(s).
- replace the cached version of each source file with the new version, so that
  further changes are `diff`ed against the most recent update.

## The structure of Revise's internal representation

![diagram](figures/diagram.png)

**Figure notes**: Nodes represent primary objects in Julia's compilation pipeline.
Arrows and their labels represent functions or data structures that allow you to move from one node to another.
Red ("destructive") paths force recompilation of dependent functions.

Revise bridges between text files (your source code) and compiled code.
Revise consequently maintains data structures that parallel Julia's own internal
processing of code.
When dealing with a source-code file, you start with strings, parse them to obtain Julia
expressions, evaluate them to obtain Julia objects, and (where appropriate,
e.g., for methods) compile them to machine code.
This will be called the *forward workflow*.
Revise sets up a few key structures that allow it to progress from files to modules
to Julia expressions and types.

Revise also sets up a *backward workflow*, proceeding from compiled code to Julia
types back to Julia expressions.
This workflow is useful, for example, when dealing with errors: the stack traces
displayed by Julia link from the compiled code back to the source files.
To make this possible, Julia builds "breadcrumbs" into compiled code that store the
filename and line number at which each expression was found.
However, these links are static, meaning they are set up once (when the code is compiled)
and are not updated when the source file changes.
Because trivial manipulations to source files (e.g., the insertion of blank lines
and/or comments) can change the line number of an expression without necessitating
its recompilation, Revise implements a way of correcting these line numbers before
they are displayed to the user.
The same problem presents when using a [debugger](https://julialang.org/blog/2019/03/debuggers/), in that one wants the debugger to display the correct code (at the correct line number) even after modifications have been made to the file.
This capability requires that Revise proceed backward from the compiled objects to
something resembling the original text file.

### Terminology

A few convenience terms are used throughout: *definition*,
*signature-expression*, and *signature-type*.
These terms are illustrated using the following example:

```@raw html
<p><pre><code class="language-julia">function <mark>print_item(io::IO, item, ntimes::Integer=1, pre::String="")</mark>
    print(io, pre)
    for i = 1:ntimes
        print(io, item)
    end
end</code></pre></p>
```

This represents the *definition* of a method.
Definitions are stored as expressions, using a [`Revise.RelocatableExpr`](@ref).
The highlighted portion is the *signature-expression*, specifying the name, argument names
and their types, and (if applicable) type-parameters of the method.

From the signature-expression we can generate one or more *signature-types*.
Since this function has two default arguments, this signature-expression generates
three signature-types, each corresponding to a different valid way of calling
this method:

```julia
Tuple{typeof(print_item),IO,Any}                    # print_item(io, item)
Tuple{typeof(print_item),IO,Any,Integer}            # print_item(io, item, 2)
Tuple{typeof(print_item),IO,Any,Integer,String}     # print_item(io, item, 2, "  ")
```

In Revise's internal code, a definition is often represented with a variable `def`, and a signature-type with `sigt`.
The method table for which the method was defined is also represented, to form a `mt_sigt` pair.
Recent versions of Revise do not make extensive use of signature expressions.

### Computing signatures

Since version 2.0, Revise works primarily with lowered-code representations, specifically using the lowered code to compute method signatures (if you don't know about lowered code, see [this tutorial](https://juliadebug.github.io/JuliaInterpreter.jl/stable/ast/)).
There are several reasons that make this an attractive approach, of which the most important are:

- keyword-argument methods get "expanded" to multiple methods handling various ways of populating the arguments. The lowered code lists all of them, which ensures that Revise knows about them all. (There are some challenges regarding "gensymmed" names, see [LoweredCodeUtils](https://github.com/JuliaDebug/LoweredCodeUtils.jl) and [julia#30908](https://github.com/JuliaLang/julia/issues/30908), but in short LoweredCodeUtils "fixes" those difficulties.)
- for methods generated by code, the only really reliable mechanism to compute all the signatures is to step through the code that generates the methods. That is performed using [JuliaInterpreter](https://github.com/JuliaDebug/JuliaInterpreter.jl).

As an example, suppose the following code is part of your module definition:
```julia
for T in (Float16, Float32, Float64)
    @eval sizefloat(x::$T) = sizeof($T)
end
```
!!! tip "clarification"
    This is equivalent to the following explicit definitions:
    ```julia
    sizefloat(x::Float16) = 2
    sizefloat(x::Float32) = 4
    sizefloat(x::Float64) = 8
    ```

If you replace the loop with `for T in (Float32, Float64)`, then Revise should delete the method for `Float16`. But this implies that Revise can deduce all the method-signatures created by this block, which essentially requires "simulating" the block that defines the methods. (In simple cases there are other approaches, but for complex cases stepping through the code seems to be the only viable answer.)

Because lowered code is far simpler than ordinary Julia code, it is much easier to interpret. Let's look briefly at a method definition:

```julia
floatwins(x::AbstractFloat, y::Integer) = x
```

which has lowered representation approximately equal to

```
CodeInfo(
│        $(Expr(:method, :floatwins))
│   %2 = Core.Typeof(floatwins)
│   %3 = Core.svec(%2, AbstractFloat, Integer)
│   %4 = Core.svec()
│   %5 = Core.svec(%3, %4)
│        $(Expr(:method, :floatwins, :(%5), CodeInfo(quote
    return x
end)))
└──      return floatwins
)
```

(I've edited this lightly for clarity.) As one steps through this, the first line tells us we're about to define a method for the function `floatwins`. Lines 2-5 compute the signature, in the representation `svec(sig, params)`, where here `sig = svec(typeof(floatwins), AbstractFloat, Integer)` and `params = svec()`.
(This example has no type parameters, which is why `params` is empty.)

What Revise does is steps through the first 5 of these lines, and when it encounters the `Expr(:method, :floatwins, :(%5), CodeInfo(...))` statement,
it pulls out the signature (the `%5`, which refers to the result computed on the 5th line) and records this as a method generated by this block of code. (It does not, however, evaluate the `Expr(:method, ...)` expression as a whole, because that would force it to be recompiled.) Stepping through this code ensures that Revise can compute the exact signature, no matter how this method is defined at the level of ordinary Julia code.

Unfortunately, modules sometimes contain code blocks that perhaps shouldn't be interpreted:

```julia
init_c_library()     # library crashes if we call this twice
```

Starting with version 2.3, Revise attempts to avoid interpreting any code not necessary for signature computation.
If you are just tracking changes, Revise will skip over such blocks; if you're loading a file with `includet` for the first time, Revise will execute such blocks in compiled mode.

Revise achieves this by computing [backedges](https://juliadebug.github.io/LoweredCodeUtils.jl/stable/edges/), essentially a set of links encoding the dependencies among different lines of the lowered code.
For the `floatwins` example above, the backedges would represent the fact that line 2 has one direct dependant, line 3 (which uses `%2`), that lines 3 and 4 both have line 5 as their dependents, and line 5 has line 6 as a dependent.  As a consequence, to (nearly) execute line 6, we have to execute lines 2-5, because they set up the signature. If an interdependent block doesn't contain any `:method` or related (`:struct_type`, `:eval`) expressions, then it doesn't need to interpret the block at all.

As should be evident, the lowered code makes it much easier to analyze the graph of these dependencies.  There are, however, a few tricky cases.
For example, any code inside an `@eval` might, or might not, expand into lowered code that contains a `:method` expression.  Because Revise can't reliably predict what it will look like after expansion, Revise will execute any code in (or needed for) an `@eval` block. As a consequence, even after version 2.3 Revise may sometimes interpret more code than is strictly necessary.

!!! note

    If Revise executes code that still shouldn't be run twice, one good solution is to put all initialization inside your module's [`__init__` function](https://docs.julialang.org/en/v1/manual/modules/#Module-initialization-and-precompilation-1).
    For files that you track with `includet`, you can also split "code that defines methods" into a separate file from "code that does work," and have Revise track only the method-defining file.
    However, starting with version 2.3 Revise should be fairly good at doing this on its own; such manual interventions should not be necessary in most cases.

### Core data structures and representations

Most of Revise's magic comes down to just three internal variables:

- [`Revise.watched_files`](@ref): encodes information used by the filesystem (`FileWatching`)
  to detect changes in source files.
- [`Revise.revision_queue`](@ref): a list of "work to do," containing the files that have been
  modified since the last code update.
- [`Revise.pkgdatas`](@ref): the central repository of parsed code, used to "diff" for changes
  and then "patch" the running session.

Two "maps" are central to Revise's inner workings: `ExprsInfos` maps link
definition=>signature-types (the forward workflow), while `CodeTracking` (specifically,
its internal variable `method_info`) links from a
method table/signature-type pair to the corresponding definition (the backward workflow).
Concretely, `CodeTracking.method_info` is just an `IdDict` mapping `MethodInfoKey(mt, sigt) => (locationinfo, def)`.
Of note, a stack frame typically contains a link to a method, which stores the equivalent
of `sigt`; consequently, this information allows one to look up the corresponding
`locationinfo` and `def`. (When methods move, the location information stored by CodeTracking
gets updated by Revise.)

Some additional notes about Revise's `ExprsInfos` maps:

- For expressions that do not define a method, it is just `def=>nothing`
- For expressions that do define a method, it is `def=>[mt_sigt1, ...]`.
  `[mt_sigt1, ...]` is the list of method table/signature-type pairs generated from `def` (often just one,
  but more in the case of methods with default arguments or keyword arguments).
- They are represented as an `OrderedDict` so as to preserve the sequence in which expressions
  occur in the file.
  This can be important particularly for updating macro definitions, which affect the
  expansion of later code.
  The order is maintained so as to match the current ordering of the source-file,
  which is not necessarily the same as the ordering when these expressions were last
  `eval`ed.
- Each key in the map (the definition `RelocatableExpr`) is the most recently
  `eval`ed version of the expression.
  This has an important consequence: the line numbers in the `def` (which are still present,
  even though not used for equality comparisons) correspond to the ones in compiled code.
  Any discrepancy with the current line numbers in the file is handled through updates to
  the location information stored by `CodeTracking`.

`ExprsInfos` are organized by module and then file, so that one can map
`filename`=>`module`=>`def`=>`mt_sigts`.
Importantly, single-file modules can be "reconstructed" from the keys of the corresponding
`ExprsInfos` (and multi-file modules from a collection of such items), since they hold
the complete ordered set of expressions that would be `eval`ed to define the module.

The global variable that holds all this information is [`Revise.pkgdatas`](@ref), organized
into a dictionary of [`Revise.PkgData`](@ref) objects indexed by Base Julia's `PkgId`
(a unique identifier for packages).

### An example

Consider a module, `Items`, defined by the following two source files:

`Items.jl`:

```julia
__precompile__(false)

module Items

include("indents.jl")

function print_item(io::IO, item, ntimes::Integer=1, pre::String=indent(item))
    print(io, pre)
    for i = 1:ntimes
        print(io, item)
    end
end

end
```

`indents.jl`:

```julia
indent(::UInt16) = 2
indent(::UInt8)  = 4
```

If you create this as a mini-package and then say `using Revise, Items`, you can start
examining internal variables in the following manner:

```julia-repl
julia> id = Base.PkgId(Items)
Items [b24a5932-55ed-11e9-2a88-e52f99e65a0d]

julia> pkgdata = Revise.pkgdatas[id]
PkgData(Items [b24a5932-55ed-11e9-2a88-e52f99e65a0d]:
  "src/Items.jl": FileInfo(Main=>ExprsInfos(<1 expressions>, <0 signatures>), Items=>ExprsInfos(<2 expressions>, <3 signatures>), )
  "src/indents.jl": FileInfo(Items=>ExprsInfos(<2 expressions>, <2 signatures>), )
```

(Your specific UUID may differ.)

Path information is stored in `pkgdata.info`:
```julia-repl
julia> pkgdata.info
PkgFiles(Items [b24a5932-55ed-11e9-2a88-e52f99e65a0d]):
  basedir: "/tmp/pkgs/Items"
  files: ["src/Items.jl", "src/indents.jl"]
```

`basedir` is the only part using absolute paths; everything else is encoded relative
to that location. This facilitates, e.g., switching between `develop` and `add` mode in the
package manager.

`src/indents.jl` is particularly simple:

```julia-repl
julia> pkgdata.fileinfos[2]
FileInfo(Items=>ExprsInfos with the following expressions:
  :(indent(::UInt16) = begin
          2
      end)
  :(indent(::UInt8) = begin
          4
      end), )
```

This is just a summary; to see the actual `def=>mt_sigts` map, do the following:

```julia-repl
julia> pkgdata.fileinfos[2].mod_exs_infos[Items]
OrderedCollections.OrderedDict{Module, OrderedCollections.OrderedDict{Revise.RelocatableExpr, Union{Nothing, Vector{CodeTracking.MethodInfoKey}}}} with 2 entries:
  :(indent(::UInt16) = begin…                       => CodeTracking.MethodInfoKey[CodeTracking.MethodInfoKey(nothing, Tuple{typeof(indent),UInt16})]
  :(indent(::UInt8) = begin…                        => CodeTracking.MethodInfoKey[CodeTracking.MethodInfoKey(nothing, Tuple{typeof(indent),UInt8})]
```

These are populated now because we specified `__precompile__(false)`, which forces
Revise to defensively parse all expressions in the package in case revisions are made
at some future point.
For precompiled packages, each `pkgdata.fileinfos[i]` can instead rely on the `cachefile`
(another field stored in the [`Revise.FileInfo`](@ref)) as a record of the state of the file
at the time the package was loaded; as a consequence, Revise can defer parsing the source
file(s) until they are updated.

`Items.jl` is represented with a bit more complexity,
`"Items.jl"=>Dict(Main=>map1, Items=>map2)`.
This is because `Items.jl` contains one expression (the `__precompile__` statement)
that is `eval`ed in `Main`,
and other expressions that are `eval`ed in `Items`.

### Revisions and computing diffs

When the file system notifies Revise that a file has been modified, Revise re-parses
the file and assigns the expressions to the appropriate modules, creating a
[`Revise.ModuleExprsInfos`](@ref) `mod_exs_infos_new`.
It then compares `mod_exs_infos_new` against `mod_exs_infos_ref`, 
the reference object that is synchronized to code as it was `eval`ed.

The following actions are taken:
- if a `def` entry in `mod_exs_infos_ref` is equal to one in `mod_exs_infos_new`, the expression is "unchanged"
  except possibly for line number. The `locationinfo` in `CodeTracking` is updated as needed.
- if a `def` entry in `mod_exs_infos_ref` is not present in `mod_exs_infos_new`, that entry is deleted and
  any corresponding methods are also deleted.
- if a `def` entry in `mod_exs_infos_new` is not present in `mod_exs_infos_ref`, it is `eval`ed and then added to
  `mod_exs_infos_ref`.

Technically, a new `mod_exs_infos_ref` is generated every time to ensure that the expressions are
ordered as in `mod_exs_infos_new`; however, conceptually this is better thought of as an updating of
`mod_exs_infos_ref`, after which `mod_exs_infos_new` is discarded.

Note that one consequence is that modifying a method causes two actions, the deletion of
the original followed by `eval`ing a new version.
During revision, all method deletions are performed first, followed by all the new `eval`ed methods.
This ensures that if a method gets moved from `fileB.jl` to `fileA.jl`, Revise doesn't mistakenly
redefine and then delete the method simply because `fileA.jl` got processed before `fileB.jl`.

### Internal API

You can find more detail about Revise's inner workings in the [Developer reference](@ref).

# User reference

There are really only a handful of functions that most users would be expected to call manually:
`revise`, `includet` (or [`@includet`](@ref)), `Revise.track`, `entr`, `Revise.retry`, `Revise.errors`,
`Revise.duplicate_methods`, and `Revise.stale_load`.
Other user-level constructs might apply if you want to debug Revise or
prevent it from watching specific packages, or for fine-grained handling of callbacks.

```@docs
revise
Revise.track
includet
@includet
entr
Revise.retry
Revise.errors
Revise.duplicate_methods
Revise.stale_load
```

### Revise logs (debugging Revise)

```@docs
Revise.debug_logger
Revise.actions
Revise.diffs
```

### Prevent Revise from watching specific packages

```@docs
Revise.dont_watch
Revise.allow_watch
Revise.dont_watch_pkgs
Revise.silence
Revise.unsilence
```

### Tolerance for missing files

```@docs
Revise.missing_file_grace
```

### Revise module

```@docs
Revise
```

# Introduction to Revise

`Revise.jl` may help you keep your Julia sessions running longer, reducing the
need to restart when you make changes to code.
With Revise, you can be in the middle of a session and then edit source code,
update packages, switch git branches, and/or stash/unstash code;
typically, the changes will be incorporated into the very next command you issue from the REPL.
This can save you the overhead of restarting, loading packages, and waiting for code to JIT-compile.

Using Revise also improves your experience when using the
[debuggers](https://julialang.org/blog/2019/03/debuggers/).
Revise will keep track of changed locations of your methods in file, and ensure that the
debugger displays the source code of what you're actually debugging.

!!! note "Automatically loading Revise"

    Many users automatically load Revise on startup.
    On versions of Julia older than 1.5, this is slightly more involved
    than just adding `using Revise` to `.julia/config/startup.jl`: see
    [Using Revise by default](@ref) for details.

## Installation

You can obtain Revise using Julia's Pkg REPL-mode (hitting `]` as the first character of the command prompt):

```julia
(v1.0) pkg> add Revise
```

or with `using Pkg; Pkg.add("Revise")`.

## Usage example

We'll make changes to Julia's "Example" package (a trivial package designed to
illustrate the file and directory organization of typical packages).
We have to "develop" it in order to make changes:

```julia
(v1.0) pkg> dev Example
[...output related to installation...]

```
Now we load Revise (if we haven't already done so) and Example:
```julia
julia> using Revise        # importantly, this must come before `using Example`

julia> using Example

julia> hello("world")
"Hello, world"
```

Now we're going to check that the `Example` module currently lacks a function named `f`:

```julia
julia> Example.f()
ERROR: UndefVarError: f not defined
```

But say we really want `f`, so let's add it.
You can either navigate to the source code (at `.julia/dev/Example/src/Example.jl`)
in an editor manually, or you can use Julia to open it for you:

```julia
julia> edit(hello)   # opens Example.jl in the editor you have configured
```

Now, add a function `f() = π` and save the file.
Go back to the REPL (the *same* REPL, don't restart Julia) and try this:

```julia
julia> Example.f()
π = 3.1415926535897...
```

Voila! Even though we'd loaded Example before adding this function,
Revise noticed the change and inserted it into our running session.

!!! warning
    Revise's first revision has latency of several seconds--it's compiling all of its internal code, which includes a complete [Julia interpreter](https://github.com/JuliaDebug/JuliaInterpreter.jl) and all of Revise's parse/diff/patch/cache machinery.
    After your first revision, future revisions will generally be fast enough that they will seem nearly instantaneous. (There are exceptions, but they occur
    only in specific circumstances, for example when Revise's own code gets [invalidated](https://julialang.org/blog/2020/08/invalidations/) by your changes.)

Now suppose we realize we've made a horrible mistake: that `f` method will mess up everything, because it's part of a more complicated dispatch process and incorrectly intercepts certain `f` calls.
No problem, just delete `f` in your editor, save the file, and you're back to this:

```julia
julia> Example.f()
ERROR: UndefVarError: f not defined
```

all without restarting Julia.
While you can evaluate *new* methods without Revise using [inline evaluation](https://www.julia-vscode.org/docs/stable/userguide/runningcode/#Julia:-Execute-Code-Block-(AltEnter)-1) through your IDE,
method *deletion* is just one example of a change that can only be made easily by Revise.

If you need more examples, see [Revise usage: a cookbook](@ref).

## Other key features of Revise

Revise updates its internal paths when you change versions of a package.
To try this yourself, first re-insert that definition of `f` in the `dev` version of
`Example` and save the file.
Now try toggling back and forth between the `dev` and released versions of `Example`:

```julia
(v1.0) pkg> free Example   # switch to the released version of Example

julia> Example.f()
ERROR: UndefVarError: f not defined

(v1.0) pkg> dev Example

julia> Example.f()
π = 3.1415926535897...
```

Revise is not tied to any particular editor.
(The [EDITOR or JULIA_EDITOR](https://docs.julialang.org/en/v1/manual/environment-variables/#JULIA_EDITOR) environment variables can be used to specify your preference for which editor gets launched by Julia's `edit` function.)

!!! warning
    Some editors (like `vim`) may require [configuration](@ref edcfg) to function properly.

If you don't want to have to remember to say `using Revise` each time you start
Julia, see [Using Revise by default](@ref).

## What Revise can track

Revise is fairly ambitious: if all is working, subject to a few [Limitations](@ref) you should be able to track changes to

- any package that you load with `import` or `using`
- any script you load with [`includet`](@ref) (see [Configuring the revise mode](@ref) for important default restrictions on `includet`)
- any file defining `Base` julia itself (with `Revise.track(Base)`)
- any of Julia's standard libraries (with, e.g., `using Unicode; Revise.track(Unicode)`). Some stdlibs may require special handling; see, for example, a trick for modifying [REPL](@ref editREPL).
- any file defining `Core.Compiler` (with `Revise.track(Core.Compiler)`)

The last one requires that you clone Julia and build it yourself from source.

## Secrets of Revise "wizards"

Revise can assist with methodologies like
[test-driven development](https://en.wikipedia.org/wiki/Test-driven_development).
While it's often desirable to write the test first, sometimes when fixing a bug
it's very difficult to write a good test until you understand the bug better.
Often that means basically fixing the bug before your write the test.
With Revise, you can

- fix the bug while simultaneously developing a high-quality test
- verify that your test passes with the fixed code
- commit the test, but not the fix
- `git stash` your fix and check that your new test fails on the old code,
  thus verifying that your test captures the essence of the former bug (if it doesn't fail,
  you need a better test!)
- `git stash pop`, test again, commit the fix, and submit

all without restarting your Julia session.

## Other Revise workflows

Revise can be used to perform work when files update.
For example, let's say you want to regenerate a set of web pages whenever your code changes.
Suppose you've placed your Julia code in a package called `MyWebCode`,
and the pages depend on "file.js" and all files in the "assets/" directory; then

```julia
entr(["file.js", "assets"], [MyWebCode]) do
    build_webpages(args...)
end
```

will execute `build_webpages(args...)` whenever you save updates to the listed files
or `MyWebCode`.

If you want to regenerate the web page as soon as any change is detected, not
only in `MyWebCode` but also in any package tracked by Revise, you can provide
the `all` keyword argument to [`entr`](@ref):

```julia
entr(["file.js", "assets"]; all=true) do
    build_webpages(args...)
end
```

## Taking advantage of Revise in other packages

To make it easier for other packages to benefit from Revise without needing to add it
as a dependency or understand Revise's internals, Revise interfaces with
[CodeTracking](https://github.com/JuliaDebug/CodeTracking.jl),
which is a small package acting as Revise's "query" interface.

## What else do I need to know?

Except in cases of problems (see below), that's it!
Revise is a tool that runs in the background, and when all is well it should be
essentially invisible, except that you don't have to restart Julia so often.

Revise can also be used as a "library" by developers who want to add other new capabilities
to Julia; the sections [How Revise works](@ref) and [Developer reference](@ref) are
particularly relevant for them.

## If Revise doesn't work as expected

If Revise isn't working for you, here are some steps to try:

- See [Configuration](@ref) for information on customization options.
  In particular, some file systems (like [NFS](https://en.wikipedia.org/wiki/Network_File_System)) and current users of [WSL2](https://devblogs.microsoft.com/commandline/announcing-wsl-2/) might require special options.
- Revise can't handle all kinds of code changes; for more information,
  see the section on [Limitations](@ref).
- Try running `test Revise` from the Pkg REPL-mode.
  If tests pass, check the documentation to make sure you understand how Revise should work.
  If they fail (especially if it mirrors functionality that you need and isn't working), see
  [Debugging problems with paths](@ref) for one set of suggestions.

If you still encounter problems, please [file an issue](https://github.com/timholy/Revise.jl/issues).
Especially if you think Revise is making mistakes in adding or deleting methods, please
see the page on [Debugging Revise](@ref) for information about how to attach logs
to your bug report.

You can prevent Revise from attempting to make further changes to running code with

```
julia> Revise.active[] = false
```

This can be useful if Revise is throwing an error when making revisions but you want to keep using your REPL.

# Configuration

!!! compat
    These instructions are applicable only for Julia 1.5 and higher. If you are running an older version of Julia, upgrading to at least 1.6 is recommended. If you cannot upgrade, see the documentation for Revise 3.2.x or earlier.

## Using Revise by default

If you like Revise, you can ensure that every Julia session uses it by
launching it from your `~/.julia/config/startup.jl` file.
Note that using Revise adds a small latency at Julia startup, generally about 0.7s when you first launch Julia and another 0.25s for your first package load.
Users should weigh this penalty against whatever benefit they may derive from not having to restart their entire session.

This can be as simple as adding

```julia
using Revise
```
as the first line in your `startup.jl`. If you have a Unix terminal available, simply run
```bash
mkdir -p ~/.julia/config/ && echo "using Revise" >> ~/.julia/config/startup.jl
```

If you use different package environments and do not always have Revise available,

```julia
try
    using Revise
catch e
    @warn "Error initializing Revise" exception=(e, catch_backtrace())
end
```

is recommended instead.

### Using Revise automatically within Jupyter/IJulia

IJulia has an integration with Revise and will automatically add it as a
[preexecute
hook](https://julialang.github.io/IJulia.jl/stable/library/public/#IJulia.push_preexecute_hook)
if Revise is loaded (e.g. through your `startup.jl`), *unless* the
`JULIA_REVISE` environment variable is set to something other than `auto`.

## [Editor configuration](@id edcfg)

At present, `vim` is the only editor known to benefit from configuration: if needed, you should modify your settings file so that `backupcopy=yes`.

More generally, Revise uses file-watching, and any editor that saves files with the following sequence:

1. rename the old version to a backup
2. write the new file

will generate *two* triggers per save; if Revise reacts to the "disappearance" of the file after step 1, it may end up needlessly deleting methods, and even if they get redefined after step 2, you'll need to recompile all the code the next time you execute any dependent methods.

Your best option is to change your editor settings, if possible, to ensure that Revise is triggered only after the new file is finished writing. Either of:

1. write the new file to a temporary name
2. rename the temporary to the real file name

or

1. save the old file to a backup name
2. write the new data to the real file name

should work fine. In `vim`, `backupcopy=yes` forces the latter of these two behaviors.

## Configuring the revise mode

By default, in packages all changes are tracked, but with `includet` only method definitions are tracked.
This behavior can be overridden by defining a variable `__revise_mode__` in the module(s) containing
your methods and/or data. `__revise_mode__` must be a `Symbol` taking one of the following values:

- `:eval`: evaluate everything (the default for packages)
- `:evalmeth`: evaluate changes to method definitions (the default for `includet`)
  This should work even for quite complicated method definitions, such as those that might
  be made within a `for`-loop and `@eval` block.
- `:evalassign`: evaluate method definitions and assignment statements. A top-level expression
  `a = Int[]` would be evaluated, but `push!(a, 1)` would not because the latter is not an assignment.
- `:sigs`: do not implement any changes, only scan method definitions for their signatures so that
  their location can be updated as changes to the file(s) are made.

If you're using `includet` from the REPL, you can enter `__revise_mode__ = :eval` to set
it throughout `Main`. `__revise_mode__` can be set independently in each module.

## Optional global configuration

Revise can be configured by setting environment variables. These variables have to be
set before you execute `using Revise`, because these environment variables are parsed
only during execution of Revise's `__init__` function.

There are several ways to set these environment variables:

- If you are [Using Revise by default](@ref) then you can include statements like
  `ENV["JULIA_REVISE"] = "manual"` in your `.julia/config/startup.jl` file prior to
  the line containing `using Revise`.
- On Unix systems, you can set variables in your shell initialization script
  (e.g., put lines like `export JULIA_REVISE=manual` in your
  [`.bashrc` file](https://www.linuxfromscratch.org/blfs/view/svn/postlfs/profile.html)
  if you use `bash`).
- On Unix systems, you can launch Julia from the Unix prompt as `$ JULIA_REVISE=manual julia`
  to set options for just that session.

The function of specific environment variables is described below.

### Manual revision: JULIA_REVISE

By default, Revise processes any modified source files every time you enter
a command at the REPL.
However, there might be times where you'd prefer to exert manual control over
the timing of revisions. `Revise` looks for an environment variable
`JULIA_REVISE`, and if it is set to anything other than `"auto"` it
will require that you manually call `revise()` to update code.

### User scripts: JULIA\_REVISE\_INCLUDE

By default, `Revise` only tracks files that have been required as a consequence of
a `using` or `import` statement; files loaded by `include` are not
tracked, unless you explicitly use `includet` or `Revise.track(filename)`. However, you can turn on
automatic tracking by setting the environment variable `JULIA_REVISE_INCLUDE` to the
string `"1"` (e.g., `JULIA_REVISE_INCLUDE=1` in a bash script).

!!! note
    Most users should avoid setting `JULIA_REVISE_INCLUDE`.
    Try `includet` instead.

### Enabling struct revision

On Julia 1.12+, Revise can automatically revise `struct` definitions in a
running session.  This feature requires scanning the global method table and
type hierarchy at startup, which can be slow so it's disabled by default. If you
would like to enable it you can set the `revise_structs` preference to `true`
via [Preferences.jl](https://github.com/JuliaPackaging/Preferences.jl).

Add the following to the `LocalPreferences.toml` file in your active project:

```toml
[Revise]
revise_structs = true
```

!!! warning
    The default for this preference may change in the future.

## Configurations for fixing errors

### No space left on device

!!! note
    This applies only to Linux

Revise needs to be notified by your filesystem about changes to your code,
which means that the files that define your modules need to be watched for updates.
Some systems impose limits on the number of files and directories that can be
watched simultaneously; if such a limit is hit, on Linux this can result in Revise silently ceasing to work
(albeit with unit tests failing) or in a fairly cryptic error like

```sh
ERROR: start_watching (File Monitor): no space left on device (ENOSPC)
```

The cure is to investigate and possibly increase the number of files that can be watched.

Invoking
```sh
$ sysctl fs.inotify
```
at the linux prompt may e.g. result in
```
fs.inotify.max_queued_events = 16384
fs.inotify.max_user_instances = 128
fs.inotify.max_user_watches = 524288
```

For Revise usage, `max_user_watches >= 65536` is recommended, and more can be helpful; the value of 524288 above is common on modern systems. One can set higher values as needed, e.g.,
```sh
$ sudo sysctl fs.inotify.max_user_instances=2048
```
After changing these values, it is advised to run Revise's unit tests to see if they pass.

This change can be made [permanent](https://support.scc.suse.com/s/kb/360054835111).

For more information see issues [#26](https://github.com/timholy/Revise.jl/issues/26)
and  [#778](https://github.com/timholy/Revise.jl/issues/778).


### Polling and NFS-mounted code directories: JULIA\_REVISE\_POLL

!!! note
    This applies only to Unix systems with code on network-mounted drives

`Revise` works by monitoring your filesystem for changes to the files that define your code.
On most operating systems, Revise can work "passively" and wait to be signaled
that one or more watched directories has changed.

Unfortunately, a few file systems (notably, the Unix-based Network File System NFS) don't support this approach. In such cases, Revise needs to "actively" check each file periodically to see whether it has changed since the last check. This active process is called [polling](https://en.wikipedia.org/wiki/Polling_(computer_science)).
You turn on polling by setting the environment variable `JULIA_REVISE_POLL` to the
string `"1"` (e.g., `JULIA_REVISE_POLL=1` in a bash script).

!!! warning
    If you're using polling, you may have to wait several seconds before changes take effect.
    Polling is *not* recommended unless you have no other alternative.

!!! note
    NFS stands for [Network File System](https://en.wikipedia.org/wiki/Network_File_System) and is typically only used to mount shared network drives on *Unix* file systems.
    Despite similarities in the acronym, NTFS, the standard [filesystem on Windows](https://en.wikipedia.org/wiki/NTFS), is completely different from NFS; Revise's default configuration should work fine on Windows without polling.

!!! note
    Under WSL, the Windows filesystem mounted at `/mnt/...` does not deliver file-change
    notifications to Linux (an upstream [WSL bug](https://github.com/microsoft/WSL/issues/4739),
    surfaced in Julia as [this issue](https://github.com/JuliaLang/julia/issues/37029)).
    Revise detects this case automatically and falls back to polling for code stored there,
    so you should not need to set `JULIA_REVISE_POLL` manually. Code kept in the native Linux
    filesystem (e.g. under your home directory) continues to use fast notification-based watching.
    Polling these `/mnt/...` files means revisions may take a few seconds to register.

# Developer reference

## Internal global variables

### Configuration-related variables

These are set during execution of Revise's `__init__` function.

```@docs
Revise.active
Revise.watching_files
Revise.polling_files
Revise.tracking_Main_includes
```

### Path-related variables

```@docs
Revise.juliadir
Revise.expected_juliadir
Revise.basesrccache
Revise.basebuilddir
```

### Internal state management

```@docs
Revise.pkgdatas
Revise.watched_files
Revise.revision_queue
Revise.NOPACKAGE
Revise.queue_errors
Revise.duplicated_signatures
Revise.included_files
Revise.watched_manifests
Revise.rewritten_caches
```

The following are specific to user callbacks (see [`Revise.add_callback`](@ref)) and
the implementation of [`entr`](@ref):

```@docs
Revise.revision_event
Revise.user_callbacks_queue
Revise.user_callbacks_by_file
Revise.user_callbacks_by_key
```

## Types

```@docs
Revise.RelocatableExpr
Revise.ModuleExprsInfos
Revise.FileInfo
Revise.PkgData
Revise.WatchList
Revise.TaskThunk
Revise.ReviseEvalException
Revise.StaleCacheError
Revise.SignatureExtractionError
MethodSummary
```

## Function reference

### Functions called when you load a new package

```@docs
Revise.watch_package
Revise.parse_pkg_files
Revise.init_watching
Revise.update_pkgversion!
```

### Monitoring for changes

These functions get called on each directory or file that you monitor for revisions.
These block execution until the file(s) are updated, so you should only call them from
within an `@async` block.
They work recursively: once an update has been detected and execution resumes,
they schedule a revision (see [`Revise.revision_queue`](@ref)) and
then call themselves on the same directory or file to wait for the next set of changes.

```@docs
Revise.revise_dir_queued
Revise.revise_file_queued
```

The following functions support user callbacks, and are used in the implementation of `entr`
but can be used more broadly:

```@docs
Revise.add_callback
Revise.remove_callback
```

### Evaluating changes (revising) and computing diffs

[`revise`](@ref) is the primary entry point for implementing changes. Additionally,

```@docs
Revise.revise_file_now
Revise.hold_cache!
Revise.cache_snapshot_is_valid
Revise.cached_source_is_current
```

Revise pins its own method dispatch to the world age captured at initialization, so that
revising a method Revise itself uses cannot disrupt its machinery mid-operation.

```@docs
Revise.advance_world!
```

### Caching the definition of methods

```@docs
Revise.get_def
```

### Parsing source code

```@docs
Revise.parse_and_maybe_eval_source
Revise.parse_and_maybe_eval_source!
Revise.ParseResult
```

### Lowered source code

Much of the "brains" of Revise comes from doing analysis on lowered code.
This part of the package is not as well documented.

```@docs
Revise.gensym_base
Revise.minimal_evaluation!
Revise.methods_by_execution!
Revise.ExInfo
```

### Modules and paths

```@docs
Revise.modulefiles
```

### Handling errors

```@docs
Revise.trim_toplevel!
```

In current releases of Julia, hitting Ctrl-C from the REPL can stop tasks running in the background.
This risks stopping Revise's ability to watch for changes in files and directories.
Revise has a work-around for this problem.

```@docs
Revise.throwto_repl
```

### Git integration

```@docs
Revise.git_source
Revise.git_files
Revise.git_repo
```

### Distributed computing

```@docs
Revise.init_worker
```

## Extension system

```@docs
Revise.SigInfo
Revise.ExtendedData
Revise.get_extended_data
Revise.replace_extended_data
```

# Limitations

## Struct revision

### Struct revision is supported on Julia 1.12+

Starting with Julia 1.12, Revise can handle changes to struct definitions. When you modify
a struct, Revise will automatically re-evaluate the struct definition and any methods or
types that depend on it. For example:

```julia
struct Inner
    value::Int
end

struct Outer
    inner::Inner
end

print_value(o::Outer) = println(o.inner.value)
```

If you change it to:

```julia
struct Inner
    value::Float64
    name::String
end
```

Revise will redefine `Inner`, and also re-evaluate `Outer` (which uses `Inner`
as a field type) and `print_value` (which references `Outer` in its signature).

On versions of Julia older than 1.12, Revise does not support changes to
`struct` definitions. These require you to restart your session.

### Workaround for the struct revision issue before Julia 1.12

On Julia versions prior to 1.12, struct definitions cannot be revised. During early stages of development, 
it's quite common to want to change type definitions. 
You can work around Julia's/Revise's limitations by temporary renaming. 
We'll illustrate this below, using `write` to be explicit about when updates to the file happen. 
But in ordinary usage, these are changes you'd likely make with your editor.

```julia-repl
julia> using Pkg, Revise

julia> Pkg.generate("MyPkg")
  Generating  project MyPkg:
    MyPkg/Project.toml
    MyPkg/src/MyPkg.jl
Dict{String, Base.UUID} with 1 entry:
  "MyPkg" => UUID("69940cda-0c72-4a1a-ae0b-fd3109336fe8")

julia> cd("MyPkg")

julia> write("src/MyPkg.jl","""
       module MyPkg

       export FooStruct, processFoo

       abstract type AbstractFooStruct end
       struct FooStruct1 <: AbstractFooStruct
           bar::Int
       end
       FooStruct = FooStruct1
       function processFoo(foo::AbstractFooStruct)
           @info foo.bar
       end

       end
       """)
230

julia> Pkg.activate(".")
  Activating project at `~/blah/MyPkg`

julia> using MyPkg
  No Changes to `~/blah/MyPkg/Project.toml`
  No Changes to `~/blah/MyPkg/Manifest.toml`
Precompiling MyPkg
  1 dependency successfully precompiled in 2 seconds

julia> processFoo(FooStruct(1))
[ Info: 1

julia> write("src/MyPkg.jl","""
       module MyPkg

       export FooStruct, processFoo

       abstract type AbstractFooStruct end
       struct FooStruct2 <: AbstractFooStruct # change version number
           bar::Float64 # change type of the field
       end
       FooStruct = FooStruct2 # update alias reference
       function processFoo(foo::AbstractFooStruct)
           @info foo.bar
       end

       end
       """);

julia> FooStruct # make sure FooStruct refers to FooStruct2
MyPkg.FooStruct2

julia> processFoo(FooStruct(3.5))
[ Info: 3.5
```

Here, note that we made two changes: we updated the "version number" of FooStruct when we changed something about its fields, and we also re-assigned FooStruct to alias the new version. We did not change the definition of any methods that have been typed AbstractFooStruct.

This works as long as the new type name doesn't conflict with an existing name; within a session you need to change the name each time you change the definition.

Once your development has converged on a solution, it's best to switch to the "permanent" name: in the example above, `FooStruct` is a non-constant global variable, and if used internally in a function there will be consequent performance penalties. Switching to the permanent name will force you to restart your session.

```julia-repl
julia> isconst(MyPkg, :FooStruct)
true

julia> write("src/MyPkg.jl","""
       module MyPkg

       export FooStruct, processFoo

       abstract type AbstractFooStruct end # this could be removed
       struct FooStruct <: AbstractFooStruct # change to just FooStruct
           bar::Float64
       end

       function processFoo(foo::AbstractFooStruct) # consider changing to FooStruct
           @info foo.bar
       end

       end
       """);

julia> run(Base.julia_cmd()) # start a new Julia session, alternatively exit() and restart julia


julia> using Pkg, Revise # NEW Julia Session

julia> Pkg.activate(".")
  Activating project at `~/blah/MyPkg`

julia> using MyPkg
Precompiling MyPkg
  1 dependency successfully precompiled in 2 seconds

julia> isconst(MyPkg, :FooStruct)
true
```

### Toplevel binding changes do not propagate

While struct revision is supported, some forms of "binding revision" do not work.
Specifically, Revise does not track implicit dependencies between top-level bindings.

For example:

```julia
MyVecType{T} = Vector{T}  # changing this to AbstractVector{T} won't update A
struct MyVec{T}
    v::MyVecType{T}
end
```

If you change `MyVecType{T}` from `Vector{T}` to `AbstractVector{T}`, the struct `MyVec` will
**not** be automatically re-evaluated because Revise does not track the dependency edge
from `MyVecType` to `MyVec`. The same applies to `const` bindings and other global bindings
that are referenced in type definitions.

Supporting this would require tracking implicit binding edges across all
top-level code, which involves significant interpreter enhancements and may
never happen. See the related case of [code that depends on data](@ref data)
below.

As a workaround, you can manually call [`revise`](@ref) to force re-evaluation of all definitions in `MyModule`, which will pick up the new bindings.

## Other limitations

In addition, some situations may require special handling:

### [Macros and generated functions](@id other-limitations/macros-and-generated-functions)

If you change a macro definition or methods that get called by `@generated` functions
outside their `quote` block, these changes will not be propagated to functions that have
already evaluated the macro or generated function.

You may explicitly call `revise(MyModule)` to force reevaluating every definition in module
`MyModule`.
Note that when a macro changes, you have to revise all of the modules that *use* it.

### Removing a name from `export` (Julia before 1.14)

On Julia versions before 1.14, deleting a name from a module's `export` list
leaves the name accessible in any module that had already done `using
ThatModule`. Revise itself supports retracting exported names, but it relies on
a Julia feature that will only become available starting with Julia 1.14
(https://github.com/JuliaLang/julia/pull/62131).

### [Code that depends on data](@id data)

Revise does not track dependencies on "data." For example, if your source code
looks like

```julia
tf = true
if tf
    f() = 1
else
    f() = 2
end
```

and you change `tf` to `false`, Revise will not update the definition of `f`.
This is because there is no record of the fact that `f` depends on the value of `tf`.

This limitation does not affect code like this:

```julia
if true
    f() = 1
else
    f() = 2
end
```

In this case, changing `true` to `false` will redefine `f`, but only because
it's part of the same expression and Revise will re-evaluate the expression.

The maintainers have no intention of ever "fixing" this limitation, as it would
require adding enormous bloat to every session for very little actual benefit.

### [Code already running in a task (including `Threads.@spawn`)](@id world-age-tasks)

Revise installs revised methods as *new* definitions, which take effect in a new
[world age](https://docs.julialang.org/en/v1/manual/methods/#Redefining-Methods).
A task observes only the methods that existed when it *started running*: calls
made from within the task dispatch at the task's fixed world age. Consequently a
long-running task that began before you edited the source keeps executing the old
definitions, even though Revise has successfully installed the new ones.

This is most surprising with `Threads.@spawn` (or `@async`), because the REPL
returns to the prompt and everything *appears* up to date—a fresh call from the
REPL, or a newly spawned task, sees the revised code—while a background worker
silently keeps running the old code:

```julia
f() = 1
worker = Threads.@spawn while true
    @show f()      # keeps printing 1, even after `f` is revised to return 2
    sleep(1)
end
```

The same limitation can also surface as an outright error rather than silent
staleness. If a task pinned to an older world age dispatches a method or closure
that was *created* after the task started, Julia raises a world-age error like

```
MethodError: no method matching f()
The applicable method may be too new: running in world age 27916, while current world is 27952.
```

Examples that can trigger this include reactive or event-loop frameworks with
runner Tasks.

This is a consequence of Julia's world-age semantics, not something Revise can
change: Revise cannot retroactively advance the world age of a task that is
already running. There are two workarounds:

- restart the task after revising, so the new task picks up the current world age; or
- route the calls that should track revisions through
  [`Base.invokelatest`](https://docs.julialang.org/en/v1/base/base/#Base.invokelatest),
  which dispatches at the latest world age:

```julia
worker = Threads.@spawn while true
    @show Base.invokelatest(f)   # picks up revisions to `f`
    sleep(1)
end
```

The same caveat applies to any long-lived loop started before a revision,
including a `while true` loop running directly at the REPL; see also
[Editing code that defines REPL](@ref editREPL).

### Distributed computing (multiple workers) and anonymous functions

Revise supports changes to code in worker processes.
The code must be loaded in the main process in which Revise is running.

Revise cannot handle changes in anonymous functions used in `remotecall`s.
Consider the following module definition:

```julia
module ParReviseExample
using Distributed

greet(x) = println("Hello, ", x)

foo() = for p in workers()
    remotecall_fetch(() -> greet("Bar"), p)
end

end # module
```

Changing the remotecall to `remotecall_fetch((x) -> greet("Bar"), p, 1)` will fail,
because the new anonymous function is not defined on all workers.
The workaround is to write the code to use named functions, e.g.,

```julia
module ParReviseExample
using Distributed

greet(x) = println("Hello, ", x)
greetcaller() = greet("Bar")

foo() = for p in workers()
    remotecall_fetch(greetcaller, p)
end

end # module
```

and the corresponding edit to the code would be to modify it to `greetcaller(x) = greet("Bar")`
and `remotecall_fetch(greetcaller, p, 1)`.

### `include(mapexpr, filename)` requires Julia 1.14 for packages

Julia supports the ability to modify source code after parsing and before evaluation,
via `include(mapexpr, filename)`. Revising such files applies the same transform.
For files included this way *while a package loads*, Revise depends on a record kept
by Julia (`Base.include_mapexprs`) that is available starting with Julia 1.14; on
older Julia versions the transform is silently dropped when the file is revised.
No version restriction applies to [`includet`](@ref)/[`Revise.track`](@ref) (which
accept a leading `mapexpr` of their own) or to `include(mapexpr, filename)` statements
*added* to an already-loaded package, since those transforms are discovered without
the load-time record.

# Debugging Revise

## Handling errors

Revise attempts to make error reports mimic Julia's own stacktraces, and as a consequence it has
to prevent stacktraces from containing lots of lines pointing to Revise's own code.
If you're trying to debug a Revise error, you'd probably prefer to see the entire stacktrace.
You can uncomment the obvious commented-out line in [`Revise.trim_toplevel!`](@ref).

## The logging framework

If Revise isn't behaving the way you expect it to, it can be useful to examine the
decisions it made.
Revise supports Julia's [Logging framework](https://docs.julialang.org/en/v1/stdlib/Logging/)
and can optionally record its decisions in a format suitable for later inspection.
What follows is a simple series of steps you can use to turn on logging, capture messages,
and then submit them with a bug report.
Alternatively, more advanced developers may want to examine the logs themselves to determine
the source of Revise's error, and for such users a few tips about interpreting the log
messages are also provided below.

### Turning on logging

Currently, the best way to turn on logging is within a running Julia session:

```jldoctest; setup=(using Revise)
julia> rlogger = Revise.debug_logger()
ReviseLogger with min_level=Debug
```
You'll use `rlogger` at the end to retrieve the logs.

Now carry out the series of julia commands and code edits that reproduces the problem.

### Capturing the logs and submitting them with your bug report

Once all the revisions have been triggered and the mistake has been reproduced,
it's time to capture the logs.
To capture all the logs, use

```julia-repl
julia> using Base.CoreLogging: Debug

julia> logs = filter(r->r.level==Debug, rlogger.logs);
```

You can capture just the changes that Revise made to running code with

```julia-repl
julia> logs = Revise.actions(rlogger)
```

You can either let these print to the console and copy/paste the text output into the
issue, or if they are extensive you can save `logs` to a file:

```julia
open("/tmp/revise.logs", "w") do io
    for log in logs
        println(io, log)
    end
end
```

Then you can upload the logs somewhere (e.g., https://gist.github.com/) and link the url in your bug report.
To assist in the resolution of the bug, please also specify additional relevant information such as the name of the function that was misbehaving after revision and/or any error messages that your received.

See also [A complete debugging demo](@ref) below.

### Logging by default

If you suspect a bug in Revise but have difficulty isolating it, you can include the lines

```julia
    # Turn on logging
    Revise.debug_logger()
```

within the `Revise` block of your `~/.julia/config/startup.jl` file.
This will ensure that you always log Revise's actions.
Then carry out your normal Julia development.
If a Revise-related problem arises, executing these lines

```julia
rlogger = Revise.debug_logger()
using Base.CoreLogging: Debug
logs = filter(r->r.level==Debug, rlogger.logs)
open("/tmp/revise.logs", "w") do io
    for log in logs
        println(io, log)
    end
    # also print in verbose form
    ioctx = IOContext(io, :verbose=>true)
    for log in logs
        println(ioctx, log)
    end
end
```

within the same session will generate the `/tmp/revise.logs` file that
you can submit with your bug report.
(What makes this possible is that a second call to `Revise.debug_logger()` returns
the same logger object created by the first call--it is not necessary to hold
on to `rlogger`.)

### The structure of the logs

For those who want to do a little investigating on their own, it may be helpful to
know that Revise's core changes are captured in the group called "Action," and they come in three
flavors:

- log entries with message `"Eval"` signify a call to `eval`; for these events,
  keyword `:deltainfo` has value `(mod, expr)` where `mod` is the module of evaluation
  and `expr` is a [`Revise.RelocatableExpr`](@ref) containing the expression
  that was evaluated.
- log entries with message `"DeleteMethod"` signify a method deletion; for these events,
  keyword `:deltainfo` has value `(sigt, methsummary)` where `sigt` is the signature of the
  method that Revise *intended* to delete and `methsummary` is a [`MethodSummary`](@ref) of the
  method that Revise actually found to delete.
- log entries with message `"LineOffset"` correspond to updates to Revise's own internal
  estimates of how far a given method has become displaced from the line number it
  occupied when it was last evaluated. For these events, `:deltainfo` has value
  `(sigt, newlineno, oldoffset=>newoffset)`.

If you're debugging mistakes in method creation/deletion, the `"LineOffset"` events
may be distracting; by default [`Revise.actions`](@ref) excludes these events.

Note that Revise records the time of each revision, which can sometimes be useful in
determining which revisions occur in conjunction with which user actions.
If you want to make use of this, it can be handy to capture the start time with `tstart = time()`
before commencing on a session.

See [`Revise.debug_logger`](@ref) for information on groups besides "Action."


### A complete debugging demo

From within Revise's `test/` directory, try the following:

```julia-repl
julia> rlogger = Revise.debug_logger();

shell> cp revisetest.jl /tmp/

julia> includet("/tmp/revisetest.jl")

julia> ReviseTest.cube(3)
81

shell> cp revisetest_revised.jl /tmp/revisetest.jl

julia> ReviseTest.cube(3)
27

julia> rlogger.logs
9-element Vector{Revise.LogRecord}:
 Revise DeleteMethod: cube(::Any)
 Revise DeleteMethod: mult3(::Any)
 Revise DeleteMethod: mult4(::Any)
 Revise Eval: #= /tmp/revisetest.jl:7 =#
 Revise Eval: #= /tmp/revisetest.jl:9 =#
 Revise LineOffset
 Revise Eval: #= /tmp/revisetest.jl:14 =#
 Revise LineOffset
 Revise LineOffset
```

You can see that Revise started by deleting three methods, followed by evaluating three new versions of those methods. Interspersed are various changes to the line numbering.

In verbose mode, the same information looks like this:

```julia-repl
julia> show(IOContext(stdout, :verbose=>true), MIME("text/plain"), rlogger.logs)
9-element Vector{Revise.LogRecord}:
 Revise.LogRecord(Debug, DeleteMethod, Action, Revise_4ac0f476, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 296, (time=1.753703251773368e9, deltainfo=(Tuple{typeof(Main.ReviseTest.cube), Any}, cube(::Any))))
 Revise.LogRecord(Debug, DeleteMethod, Action, Revise_4ac0f476, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 296, (time=1.753703251782686e9, deltainfo=(Tuple{typeof(Main.ReviseTest.Internal.mult3), Any}, mult3(::Any))))
 Revise.LogRecord(Debug, DeleteMethod, Action, Revise_4ac0f476, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 296, (time=1.753703251782706e9, deltainfo=(Tuple{typeof(Main.ReviseTest.Internal.mult4), Any}, mult4(::Any))))
 Revise.LogRecord(Debug, Eval, Action, Revise_9147188b, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 347, (time=1.753703251786138e9, deltainfo=(Main.ReviseTest, quote
    #= /tmp/revisetest.jl:7 =#
    cube(x) = begin
            #= /tmp/revisetest.jl:7 =#
            x ^ 3
        end
end)))
 Revise.LogRecord(Debug, Eval, Action, Revise_9147188b, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 347, (time=1.75370325178672e9, deltainfo=(Main.ReviseTest, quote
    #= /tmp/revisetest.jl:9 =#
    fourth(x) = begin
            #= /tmp/revisetest.jl:9 =#
            x ^ 4
        end
end)))
 Revise.LogRecord(Debug, LineOffset, Action, Revise_fcadbd44, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 369, (time=1.753703251787128e9, deltainfo=(CodeTracking.MethodInfoKey[CodeTracking.MethodInfoKey(nothing, Tuple{typeof(Main.ReviseTest.Internal.mult2), Any})], :(#= /tmp/revisetest.jl:11 =#) => :(#= /tmp/revisetest.jl:13 =#))))
 Revise.LogRecord(Debug, Eval, Action, Revise_9147188b, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 347, (time=1.753703251793889e9, deltainfo=(Main.ReviseTest.Internal, quote
    #= /tmp/revisetest.jl:14 =#
    mult3(x) = begin
            #= /tmp/revisetest.jl:14 =#
            3x
        end
end)))
 Revise.LogRecord(Debug, LineOffset, Action, Revise_fcadbd44, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 369, (time=1.753703251795383e9, deltainfo=(CodeTracking.MethodInfoKey[CodeTracking.MethodInfoKey(nothing, Tuple{typeof(Main.ReviseTest.Internal.unchanged), Any})], :(#= /tmp/revisetest.jl:18 =#) => :(#= /tmp/revisetest.jl:19 =#))))
 Revise.LogRecord(Debug, LineOffset, Action, Revise_fcadbd44, "/home/tim/.julia/dev/Revise/src/packagedef.jl", 369, (time=1.753703251795399e9, deltainfo=(CodeTracking.MethodInfoKey[CodeTracking.MethodInfoKey(nothing, Tuple{typeof(Main.ReviseTest.Internal.unchanged2), Any})], :(#= /tmp/revisetest.jl:20 =#) => :(#= /tmp/revisetest.jl:21 =#))))
```

Perhaps the most useful component of this is the timing information, as it gives clues to what you might have been doing to trigger revisions.

In rare cases it might be helpful to independently record the sequence of edits to the file.
You can make copies `cp editedfile.jl > /tmp/version1.jl`, edit code, `cp editedfile.jl > /tmp/version2.jl`,
etc.
`diff version1.jl version2.jl` can be used to capture a compact summary of the changes
and pasted into the bug report.

## Debugging problems with paths

During certain types of usage you might receive messages like

```
Warning: /some/system/path/stdlib/v1.0/SHA/src is not an existing directory, Revise is not watching
```

Unless you've just deleted that directory, this indicates that some of Revise's functionality is broken.

In the majority of cases, failures come down to Revise having trouble locating source
code on your drive.
This problem should be fixable, because Revise includes functionality
to update its links to source files, as long as it knows what to do.

One of the best approaches is to run Revise's own tests via `pkg> test Revise`.
Here are some possible test warnings and errors, and steps you might take to fix them:

- `Base & stdlib file paths: Test Failed at /some/path...  Expression: isfile(Revise.basesrccache)`
  This failure is quite serious, and indicates that you will be unable to access code in `Base`.
  To fix this, look for a file called `"base.cache"` somewhere in your Julia install
  or build directory (for the author, it is at `/home/tim/src/julia-1.0/usr/share/julia/base.cache`).
  Now compare this with the value of `Revise.basesrccache`.
  (If you're getting this failure, presumably they are different.)
  An important "top level" directory is `Sys.BINDIR`; if they differ already at this level,
  consider adding a symbolic link from the location pointed at by `Sys.BINDIR` to the
  corresponding top-level directory in your actual Julia installation.
  You'll know you've succeeded in specifying it correctly when, after restarting
  Julia, `Revise.basesrccache` points to the correct file and `Revise.juliadir`
  points to the directory that contains `base/`.
  If this workaround is not possible or does not succeed, please
  [file an issue](https://github.com/timholy/Revise.jl/issues) with a description of
  why you can't use it and/or
  + details from `versioninfo` and information about how you obtained your Julia installation;
  + the values of `Revise.basesrccache` and `Revise.juliadir`, and the actual paths to `base.cache`
    and the directory containing the running Julia's `base/`;
  + what you attempted when trying to fix the problem;
  + if possible, your best understanding of why this failed to fix it.
- `skipping Core.Compiler tests due to lack of git repo`: this likely indicates
  that you downloaded a Julia binary rather than building Julia from source.
  While Revise should be able to access the code in `Base` and standard libraries,
  at the current time it is not possible for Revise to access julia's Core.Compiler module
  unless you clone Julia's repository and build it from source.
- `skipping git tests because Revise is not under development`: this warning should be
  harmless. Revise has built-in functionality for extracting source code using `git`,
  and it uses itself (i.e., its own git repository) for testing purposes.
  These tests run only if you have checked out Revise for development (`pkg> dev Revise`)
  or on the continuous integration servers (Travis and Appveyor).

# Tricks

## [Editing code that defines REPL](@id editREPL)

Updating the code in Julia's REPL stdlib requires some extra trickery, because modified method definitions can't be deployed until you exit any currently-running REPL functions, like those handling the prompt that you're using to interact with Julia. A workaround is to create a sub-REPL that you can shut down, and then restart a new one whenever you want to test new code:

```julia
using Revise
using REPL
Revise.track(REPL)

term = REPL.Terminals.TTYTerminal("dumb", stdin, stdout, stderr)
repl = REPL.LineEditREPL(term, true)
Revise.retry()

while true
    @info("Launching sub-REPL, use `^D` to reload, `exit()` to quit.")
    REPL.run_repl(repl)
    Revise.retry()
end
```

Many thanks to `staticfloat` for [contributing](https://github.com/timholy/Revise.jl/issues/741) this suggestion.

## Skipping re-precompilation after a restart

If you restart Julia while developing a package that is expensive to precompile,
`using MyBigPackage` will trigger precompilation before anything else can happen.
When the edits since the last precompilation are modest, it can be much faster to
load the old precompile cache and let Revise patch the loaded code up to date:

```julia
using Revise
Revise.stale_load("MyBigPackage")
using MyBigPackage
```

This mimics what Revise does during a running session, but across a restart.
See [`Revise.stale_load`](@ref) for the details and limitations.

# Revise usage: a cookbook

## Package-centric usage

For code that might be useful more than once, it's often a good idea to put it in
a package.
Revise cooperates with the package manager to enforce its distinction between
["versioned" and "under development" packages](https://pkgdocs.julialang.org/v1/managing-packages/);
packages that you want to modify and have tracked by `Revise` should be `dev`ed rather than `add`ed.

!!! note
    You should never modify package files in your `.julia/packages` directory,
    because this breaks the "contract" that such package files correspond to registered versions of the code.
    In recent versions of Julia, the source files in `.julia/packages` are read-only,
    and you should leave them this way.

    In keeping with this spirit, Revise is designed to avoid tracking changes in such files.
    The correct way to make and track modifications is to `dev` the package.

For creating packages, the author recommends [PkgTemplates.jl](https://github.com/JuliaCI/PkgTemplates.jl).
A fallback is to use "plain" `Pkg` commands.
Both options are described below.

### PkgTemplates

!!! note
    Because PkgTemplates integrates nicely with [`git`](https://git-scm.com/),
    this approach might require you to do some configuration.
    (Once you get things set up, you shouldn't have to do this part ever again.)
    PkgTemplates needs you to configure your `git` user name and email.
    Some instructions on configuration are [here](https://docs.github.com/en/get-started/git-basics/set-up-git)
    and [here](https://git-scm.com/book/en/v2/Getting-Started-First-Time-Git-Setup).
    It's also helpful to sign up for a [GitHub account](https://github.com/)
    and set git's `github.user` variable.
    The [PkgTemplates documentation](https://juliaci.github.io/PkgTemplates.jl/stable/)
    may also be useful.

    If you struggle with this part, consider trying the "plain" `Pkg` variant below.

!!! note
    If the current directory in your Julia session is itself a package folder, PkgTemplates
    will use it as the parent environment (project) for your new package.
    To reduce confusion, before trying the commands below it may help to first ensure you're in a
    a "neutral" directory, for example by typing `cd()` at the Julia prompt.

Let's create a new package, `MyPkg`, to play with.

```julia-repl
julia> using PkgTemplates

julia> t = Template()
Template:
  → User: timholy
  → Host: github.com
  → License: MIT (Tim Holy <tim.holy@gmail.com> 2019)
  → Package directory: ~/.julia/dev
  → Minimum Julia version: v1.0
  → SSH remote: No
  → Add packages to main environment: Yes
  → Commit Manifest.toml: No
  → Plugins: None

julia> t("MyPkg")
Generating project MyPkg:
    /home/tim/.julia/dev/MyPkg/Project.toml
    /home/tim/.julia/dev/MyPkg/src/MyPkg.jl
[lots more output suppressed]
```

In the first few lines you can see the location of your new package, here
the directory `/home/tim/.julia/dev/MyPkg`.

Press `]` to enter the [Pkg REPL](https://pkgdocs.julialang.org/v1/getting-started/#Basic-Usage).
Then add the new package to your current environment with the `dev` command.

```julia-repl
(<environment>) pkg> dev MyPkg   # the dev command will look in the ~/.julia/dev folder automatically
```

Press the backspace key to return to the Julia REPL.

Now let's try it out:

```julia-repl
julia> using Revise   # you must do this before loading any revisable packages

julia> using MyPkg
[ Info: Precompiling MyPkg [102b5b08-597c-4d40-b98a-e9249f4d01f4]
```

(It's perfectly fine if you see a different string of digits and letters after the "Precompiling MyPkg" message.)
You'll note that Julia found your package without you having to take any extra steps.

*Without* quitting this Julia session, open the `MyPkg.jl` file in an editor.
You might be able to open it with

```julia-repl
julia> edit(pathof(MyPkg))
```

although that might require configuring your EDITOR environment variable.

You should see something like this:

```julia
module MyPkg

# Write your package code here.

end
```

This is the basic package created by PkgTemplates.
Let's create a simple `greet` function to return a message:

```julia
module MyPkg

greet() = print("Hello World!")

end # module
```

Now go back to that same Julia session, and try calling `greet`.
After a pause (while Revise's internal code compiles), you should see

```julia-repl
julia> MyPkg.greet()
Hello World!
```

From this point forward, revisions should be fast. You can modify `MyPkg.jl`
quite extensively without quitting the Julia session, although there are some [Limitations](@ref).


### Using Pkg

[Pkg](https://pkgdocs.julialang.org/v1/) works similarly to `PkgTemplates`,
but requires less configuration while also doing less on your behalf.
Let's create a blank `MyPkg` using `Pkg`. (If you tried the `PkgTemplates` version
above, you might first have to delete the package with `Pkg.rm("MyPkg")` following by
a complete removal from your `dev` directory.)

```julia-repl
julia> using Revise, Pkg

julia> cd(Pkg.devdir())   # take us to the standard "development directory"

(v1.2) pkg> generate MyPkg
Generating project MyPkg:
    MyPkg/Project.toml
    MyPkg/src/MyPkg.jl

(v1.2) pkg> dev MyPkg
[ Info: resolving package identifier `MyPkg` as a directory at `~/.julia/dev/MyPkg`.
...
```

For the line starting `(v1.2) pkg>`, hit the `]` key at the beginning of the line,
then type `generate MyPkg`.
The next line, `dev MyPkg`, is necessary to tell `Pkg` about the existence of this new package.

Now you can do the following:
```julia-repl
julia> using MyPkg
[ Info: Precompiling MyPkg [efe7ebfe-4313-4388-9b6c-3590daf47143]

julia> edit(pathof(MyPkg))
```
and the rest should be similar to what's above under `PkgTemplates`.
Note that with this approach, `MyPkg` has not been set up for version
control.

!!! note
    If you `add` instead of `dev` the package, the package manager will make a copy of the `MyPkg` files in your `.julia/packages` directory.
    This will be the "official" version of the files, and Revise will not track changes.


## `includet` usage

The alternative to creating packages is to manually load individual source files.
This approach is intended for early stages of development;
if you want to track multiple files and/or have some files include other files,
you should consider switching to the package style above.

Open your editor and create a file like this:

```julia
mygreeting() = "Hello, world!"
```

Save it as `mygreet.jl` in some directory. Here we will assume it's being saved in `/tmp/`.

Now load the code with `includet`, which stands for "include and track":

```julia-repl
julia> using Revise

julia> includet("/tmp/mygreet.jl")

julia> mygreeting()
"Hello, world!"
```

Now, in your editor modify `mygreeting` to do this:

```julia
mygreeting() = "Hello, revised world!"
```

and then try it in the same session:

```julia-repl
julia> mygreeting()
"Hello, revised world!"
```

As described above, the first revision you make may be very slow, but later revisions
should be fast.
